unit chess;

interface

uses
	 dos, xcrt,
	 ch_gen, ch_cplay, ch_book,
	 slget, scr,
	 defs, mogutils, mogfile, mogsend, utils, dtime,
	 users, message, post, filedef, sublist, general, ch_def;


function  chess_parse(s : string) : boolean;
procedure chessupdscr(n : integer);

procedure ChessMaint;


implementation


procedure ChessScrOff;
var
	lp 	: integer;
begin
	for lp := 1 to 15 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xstrwrite(#27'[1r');
end;


procedure ChessScrOn;
var
	lp, pp, n	: integer;
begin
	xstrwrite(#27'[15r');

	for lp := 1 to 15 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xgotoxy(1, 1);
	xtextbackground(red);
	xtextcolor(yellow);
	xclreol;
	xgotoxy(63, 1);
	xwrite('MogTalk MogChess');

	xgotoxy(1, 14);
	xclreol;
	xgotoxy(57, 14);
	xwrite('MogTalk Teleconference');

	xtextbackground(black);

	xgotoxy(1, 2);
	slwriteln('  \LCPlayer Information'+#13#10+
			  '  \LGWhite:'+#13#10+
			  '   Time:'#13#10+
			  '  Black:'#13#10+
			  '   Time:'#13#10#10+
			  '  \LCGame Status'#13#10+
			  '   \LGGame:'+#13#10#10+
			  '  State:'#13#10#10+
			  '   Type:\WH');

	xgotoxy(29, 2);
	xwrite('a  b  c  d  e  f  g  h');
	xgotoxy(27, 3);
	xwrite('Ŀ');

	if flipped then n := 10 else n := 0;

	for lp := 1 to 4 do
	begin
		xgotoxy(26, 2+lp*2);
		xwrite(strs(10-(lp*2))+'');

		for pp := 1 to 4 do
		begin
			xtextbackground(lightgray);
			xwrite('   ');
			xtextbackground(black);
			xwrite('   ');
		end;
		xwrite(''+strs(10-(lp*2)));

		xgotoxy(26, 3+lp*2);
		xwrite(strs(9-(lp*2))+'');
		for pp := 1 to 4 do
		begin
			xtextbackground(black);
			xwrite('   ');
			xtextbackground(lightgray);
			xwrite('   ');
		end;
		xtextbackground(black);
		xwrite(''+strs(9-(lp*2)));
	end;

	xgotoxy(27, 12);
	xwrite('');

	xgotoxy(29, 13);
	xwrite('a  b  c  d  e  f  g  h');

	xgotoxy(63, 2);
	slwrite('\LCMoves History');
	xgotoxy(63, 3);
	slwrite('\LCWhite   Black');
end;


function CheckForMulPiece(game : gamet; col : colortype; src, dest : position; pi : piece) : string;
var
	s 		: string;
	lp, pp	: integer;
	g2		: gamet;
	p		: position;
	dum		: boolean;
begin
	s := '';

	move(game, g2, sizeof(game));

	for lp := 1 to 8 do
	begin
		p.y := lp;
		for pp := 1 to 8 do
		begin
			p.x := pp;

			if ((p.x <> src.x) or (p.y <> src.y)) and (pi = GetP(game, p)) then
			begin
				PutP(g2, dest, None);
				if IsValidMove(g2, p, dest, false, dum) then
				begin
					if p.x = src.x then
						s := chr(src.y+48)
					else
						s := chr(src.x+96) + s;

					CheckForMulPiece := s;
					exit;
				end;

				move(game, g2, sizeof(game));
			end;
		end;
	end;

	CheckForMulPiece := '';
end;


procedure AddToAlge(var game : gamet; alges : string);
var
	p : ^historyt;
	np: position;
begin
	np.x := 0;
	np.y := 0;

	getmem(p, sizeof(historyt));

	game.historyend^.next := p;

	fillchar(p^, sizeof(historyt), 0);
	p^.prev := @game.historyend^;

	game.historyend := @p^;

	with p^ do
	begin
		moven := game.moven;
		src := np;
		dest := np;
		pmove := None;
		alge := alges;
	end;
end;


procedure AddToHistory(var game : gamet; old, new : position; col : colortype; taken, proto : piece; IsEnPas : boolean);
var
	p : ^historyt;
begin
	getmem(p, sizeof(historyt));

	game.historyend^.next := p;

	fillchar(p^, sizeof(historyt), 0);
	p^.prev := @game.historyend^;

	game.historyend := @p^;

	with p^ do
	begin
		moven := game.moven;
		src := old;
		dest := new;
		if proto <> None then
		begin
			if col = PWhite then
				pmove := BPawn
			else
				pmove := WPawn;
		end
		else
			pmove := GetP(game, new);
		promoted := proto;

		if (pmove in [WKing, BKing]) and (src.x = 5) and (dest.x = 3) then
		begin
			alge := 'O-O-O';
			castled := true;
		end
		else if (pmove in [WKing, BKing]) and (src.x = 5) and (dest.x = 7) then
		begin
			alge := 'O-O';
			castled := true;
		end
		else
		begin
			alge := chr(dest.x+96)+chr(dest.y+48);

			if not (pmove in [WPawn, BPawn]) then
			begin
				alge := stripcol(PieceName[pmove]) + alge;

				if taken <> None then
				begin
					insert('x', alge, 2);
					captured := taken;
				end;

				insert(CheckForMulPiece(game, col, old, new, GetP(game, new)), alge, 2);
			end
			else
			begin
				if IsEnPas then
				begin
					alge := chr(old.x+96)+'x'+chr(new.x+96);
					if pmove = BPawn then
						alge := alge + '4ep'
					else
						alge := alge + '5ep';
				end
				else
				begin
					if taken <> None then
						insert(chr(src.x+96)+'x', alge, 1);
				end;
			end;
		end;

		if proto <> None then
			alge := alge + '=' + StripCol(PieceName[proto]);

		if game.state = Check then
			alge := alge + '+';

		if game.state = CheckMate then
			alge := alge + '#';
	end;
end;


procedure disp_move(var game : gamet);
var
	h : ^historyt;
	n : integer;
	s : string;
begin
	h := @game.history;
	h := h^.next;
	n := 1;

	if expert then
	begin
		xtextcolor(white);
		while h <> Nil do
		begin
			s := strs(n)+'. '+h^.alge+' ';
			h := h^.next;
			if h <> Nil then
			begin
				s := s + h^.alge + '  ';
				h := h^.next;
			end;

			if length(s)+xwherex > scrbx then xwrite(#13#10);
			xwrite(s);
			inc(n);
		end;
	end
	else
	begin
		while h <> Nil do
		begin
			if n mod 2 = 1 then
				xtextcolor(white)
			else
				xtextcolor(lightgray);

			s := chr(h^.src.x+96)+strs(h^.src.y)+chr(h^.dest.x+96)+strs(h^.dest.y);
			if h^.promoted <> None then
				s := s + stripcol(PieceName[h^.promoted]);
			xwrite(s+sp(8-length(s)));

			h := h^.next;
			inc(n);
		end;
	end;

	xwriteln('');
end;


procedure MailGame(game : gamet; usecolor : boolean);
var
	p	: SetupPtr;
	msg : msgptr;
	header : headertype;

 procedure caddline(s : string);
 begin
	if usecolor = false then
		s := stripcol(s);

	addline(msg, s);
 end;

var
	nextwhite 		: boolean;
	lp, pp			: word;
	s, ss			: string;
	po				: position;

	h 				: ^historyt;
	n 				: integer;


begin
	p := TempListIndex('MAIL', subboards);
	if p = Nil then
		exit;

	if OpenSub('MAIL', mainsub, allfiles) = false then
		exit;

	fillchar(header, sizeof(header), 0);
	with header do
	begin
		from := 'MOGCHESS';
		touser := myuser.name;
		subj := 'Status report of chess game '+strs(viewing);
		dosdate(date);
		dostime(time);
	end;

	new(msg);
	clearmsg(msg);


	caddline('\CYThe following is a status report for MogChess game \WH'+strs(viewing)+'\CY.');
	caddline('');
	caddline('\LGGame state: \WH'+states[game.state]);

	if game.state < Finished then
	begin
		s := '\LG Next turn: ';
		if game.turn = PWhite then
			s := s + cfg.defusrcol+GetAName(game.name_w)
		else
			s := s + cfg.defusrcol+GetAName(game.name_b);
	end
	else
	begin
		if game.state in [DrawMut, StaleMate] then
			s := ''
		else
		begin
			s := '\LG Winner is: ';

			if game.winner = PWhite then
				s := s + cfg.defusrcol+GetAName(game.name_w)
			else
				s := s + cfg.defusrcol+GetAName(game.name_b);
		end;
	end;

	if s <> '' then caddline(s);
	caddline('');
	caddline('\CYPlayer information for this game:');
	caddline('');
	caddline('\LGWhite: '+cfg.defusrcol+GetAName(game.name_w));
	caddline('\LG Time: \WH');
{	caddline('\LG  Str: \WH'+strs(GetStrength(game, PWhite)));}
	caddline('');
	caddline('\LGBlack: '+cfg.defusrcol+GetAName(game.name_b));
	caddline('\LG Time: \WH');
{	caddline('\LG  Str: \WH'+strs(GetStrength(game, PBlack)));}
	caddline('');
	caddline('');
	caddline('\CYBoard Position:');
	caddline('');

	nextwhite := true;

	for lp := 8 downto 1 do
	begin
		s := '     ';
		po.y := lp;

		for pp := 1 to 8 do
		begin
			po.x := pp;
			if nextwhite = true then
				s := s + '\GY\IV '
			else
				s := s + '\NO ';

			nextwhite := not nextwhite;

			s := s + PieceName[GetP(game, po)] + ' ';
		end;
		s := s + '\NO';

		caddline(s);

		nextwhite := not nextwhite;
	end;

	caddline('');
	caddline('');
	caddline('\CYHistory of Moves:\WH');
	caddline('');

	h := @game.history;
	h := h^.next;
	n := 1;
	ss := '';

	while h <> Nil do
	begin
		s := strs(n)+'. '+h^.alge+' ';
		h := h^.next;
		if h <> Nil then
		begin
			s := s + h^.alge + '  ';
			h := h^.next;
		end;

		if length(s)+length(ss) > 77 then
		begin
			caddline(ss);
			ss := s;
		end
		else
			ss := ss + s;

		inc(n);
	end;

	if ss <> '' then caddline(ss);

	caddline('');
	caddline('\cy--- MogTalk MogChess v'+_ver);

{	if LockSubboard(15, true) then}
	begin
		MsgPost(msg, header, 0, false, true, false);
{		UnlockSubboard;}
	end;

	DisposeMsg(msg);

	CloseSub(Mainsub);
end;


var
	g : gamet;

procedure chessupdscr(n : integer);
begin
	if n = viewing then
	begin
		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		GetGame(viewing, g);
		DisplayScreen(g);
		DisplayInfo(g);
		DisplayHistory(g);
		ResetScr;
	end;
end;


procedure listchessgames(openonly : boolean);
var
	sr		: searchrec;
	gr  	: gamet;
	s, t	: string;
	n		: integer;
	pycg 	: boolean;

begin
	findfirst(cfg.gamedir+'*.CHS', 0, sr);

	if openonly then
		slwriteln('\WH * Open chess games:')
	else
		slwriteln('\WH * Active chess games:');

	n := 0;
	pycg := false;

	while DosError = 0 do
	begin
		OpenSharedFile(cfg.gamedir+sr.name, IRead+DenyNone);
		blockread(sf.f, gr, sizeof(gr));
		CloseSharedFile;

		if (gr.state < Finished) and
		   ( (not openonly) or ((gr.name_w = '') or (gr.name_b = ''))) then
		begin
			s := copy(sr.name, 1, pos('.', sr.name)-1);
			t := '';

			slwrite('\LG   Game \YE'+s+'\LG:  ');

			if (gr.name_w = '') then
			begin
				slwriteln('\YEOpen game with \WH'+stripcol(GetAName(gr.name_b))+'\YE.');
			end
			else if (gr.name_b = '') then
			begin
				slwriteln('\YEOpen game with \WH'+stripcol(GetAName(gr.name_w))+'\YE.');
			end
			else
			begin
				slwriteln('\WH' + stripcol(GetAName(gr.name_w))+
						  ' \LGvs\WH '+ stripcol(GetAName(gr.name_b))+'\LG.');
			end;
		end;

		FindNext(sr);
	end;
end;



procedure help;
begin
	PutHeading('MogTalk MogChess Help', false);
	slwriteln('  \WH/chess                 \GYEnables/disables the chess module.');
	slwriteln('  \WH/mine                  \GYLists the games that you are playing in.');
	slwriteln('  \WH/move [x1y2]           \GYMoves piece from position X1 to position X2.');
	slwriteln('  \WH/move [algebraic]      \GYMoves using the algebraic notation.');
	slwriteln('  \WH/view [game]           \GYViews game number [game].');
	slwriteln('  \WH/new [white | black]   \GYStarts a new game with anyone who wants to play.');
	slwriteln('  \WH/join [game]           \GYJoin yourself to game number [game].');
	slwriteln('  \WH/flip                  \GYFlips the board around.');
	slwriteln('  \WH/history               \GYDisplays a history list of the current game.');
	slwriteln('  \WH/expert                \GYToggles algebraic and co-ordinate history mode.');
	slwriteln('  \WH/resign                \GYResign from the current game.');
	slwriteln('  \WH/draw                  \GYSubmit a draw for the current game.');
	slwriteln('  \WH/takeback              \GYOffers or accepts to take back the last move.');
	slwriteln('  \WH/mail                  \GYMail the progress of the current game to yourself.');
	PutTrailer(false);
end;


function TransAlge(game : gamet; s : string; col : colortype; var src, dest : position;
					var prom : string; DispErrors : boolean) : boolean;
var
	ss 				: string;
	pi, lpp			: piece;
	po				: position;

	found 			: boolean;
	tx, ty, bx, by 	: word;
	lp, pp			: word;
	dum				: boolean;
begin
	s := ups(s);

	TransAlge := true;

	if s = 'O-O-O' then
	begin
		if col = PWhite then
		begin
			MakePos(5, 1, src);
			MakePos(3, 1, dest);
			exit;
		end;

		MakePos(5, 8, src);
		MakePos(3, 8, dest);
		exit;
	end;

	if s = 'O-O' then
	begin
		if col = PWhite then
		begin
			MakePos(5, 1, src);
			MakePos(7, 1, dest);
			exit;
		end;

		MakePos(5, 8, src);
		MakePos(7, 8, dest);
		exit;
	end;

	TransAlge := false;

	while s[length(s)] in ['+', '#', '!'] do
		delete(s, length(s), 1);

	prom := '';
	if s[length(s)-1] = '=' then
	begin
		prom := s[length(s)];
		delete(s, length(s)-1, 2);
	end;

	if PosTranslate(copy(s, length(s)-1, 2), dest) = false then
		exit;

	delete(s, length(s)-1, 2);
	if s = '' then
	begin
		src.x := dest.x;
		if col = PWhite then
		begin
			src.y := dest.y - 1;
			if GetP(game, src) <> WPawn then
				dec(src.y);
		end
		else
		begin
			src.y := dest.y + 1;
			if GetP(game, src) <> BPawn then
				inc(src.y);
		end;

		TransAlge := true;
		exit;
	end;

	ss := s[1];
	if col = PWhite then
		ss := '\WH' + ss
	else
		ss := '\DG' + ss;

	pi := None;
	for lpp := None to BPok do
	begin
		if ss = PieceName[lpp] then
			pi := lpp;
	end;

	if pi = None then
		exit;

	delete(s, 1, 1);
	if s[length(s)] = 'X' then
		delete(s, length(s), 1);

	if length(s) = 2 then
	begin
		if PosTranslate(s, src) = false then
			exit;
		TransAlge := true;
		exit;
	end;

	tx := 1;
	ty := 1;
	bx := 8;
	by := 8;

	if length(s) = 1 then
	begin
		if s[1] in ['A'..'H'] then
		begin
			tx := ord(s[1]) - 64;
			bx := tx;
		end

		else if s[1] in ['1'..'8'] then
		begin
			ty := ord(s[1]) - 48;
			by := ty;
		end

		else exit;
	end;

	found := false;

	for lp := ty to by do
	begin
		po.y := lp;
		for pp := tx to bx do
		begin
			po.x := pp;
			if GetP(game, po) = pi then
			begin
				if IsValidMove(game, po, dest, false, dum) = true then
				begin
					if found then
					begin
						if DispErrors then
						begin
							ResetScr;
							slwriteln('\WH * Ambiguous move.');
						end;
						exit;
					end;

					src.x := po.x;
					src.y := po.y;

					found := true;
				end;
			end;
		end;
	end;

	if found = false then exit;

	TransAlge := true;
end;


function Chess_Parse(s : string) : boolean;
var
	w1 		: string;
	p1, p2 	: position;
	c		: colortype;
	g2  	: gamet;
	n, nn 	: integer;
	ret 	: word;
	cut 	: cusertype;
	lpp 	: piece;
	fptr 	: file;
	taken 	: piece;
	ss	 	: string;
	proto	: piece;
	isincm	: boolean;
	bo		: boolean;
	isenpas : boolean;
begin
	w1 := aword(s, 1, false);

	chess_parse := true;

	if w1 = '/chess' then
	begin
		enteruserline;

		if inited = false then
		begin
			if scrty0 <> 0 then
			begin
				slwriteln('\WH * You can only open one game window at a time.');
				exit;
			end;

			expert := myuser.chessexp;

			SaveScr;
			ChessScrOn;
			ResetScr;

{			LoadBook;}

			inited := true;
			slwriteln('\WH * MogChess v'+_ver+' initialised.  Have a nice day :-)');
			exit;
		end
		else
		begin
			SaveScr;
			ChessScrOff;

			xwindow(1, 1, scrbx, scrby);
			xgotoxy(sx, sy);

			inited := false;
			viewing := 0;
			exit;
		end;
	end;

	if w1 = '/mine' then
	begin
		listmychessgames(true);
	end;

	if w1 = '/chess-help' then
	begin
		enteruserline;
		help;
		exit;
	end;

	if inited = false then
	begin
		chess_parse := false;
		exit;
	end;

	if w1 = '/new' then
	begin
		enteruserline;
		n := MakeNewGame(aword(s, 2, false));
		if n = 0 then
			exit;

		w1 := '/view';
		s := '/view '+strs(n);
	end;

	if w1 = '/join' then
	begin
		enteruserline;
		if CheckForTooManyGames then exit;

		if (s = '/join') and (viewing > 0) then
			n := viewing
		else
			val(aword(s, 2, false), n, nn);

		if GetGame(n, g) = false then
		begin
			slwriteln('\WH * That game does not exist!');
			exit;
		end;

		if (g.name_w <> '') and (g.name_b <> '') then
		begin
			slwriteln('\WH * That game already has two players.');
			exit;
		end;

		if (g.name_w = myrec.name) or
		   (g.name_b = myrec.name) then
		begin
			slwriteln('\WH * You can''t have a game against yourself!');
			exit;
		end;

		if g.name_w = '' then
		begin
			g.name_w := myrec.name;
			nn := GetUserNode(GetAName(g.name_b), true);
		end
		else
		begin
			g.name_b := myrec.name;
			nn := GetUserNode(GetAName(g.name_w), true);
		end;

		PutGame(n, g);

		if nn > 0 then
			SendThisMsgP('\WH * User \LG'+myrec.alias+'\WH has joined your game number \LG'+strs(n)+'\WH.'#13#10, 1, nn);

		SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);
		exit;
	end;

	if s = '/view' then
	begin
		enteruserline;
		listchessgames(false);
		exit;
	end;

	if s = '/view-open' then
	begin
		enteruserline;
		listchessgames(true);
		exit;
	end;

	if w1 = '/view' then
	begin
		enteruserline;
		val(aword(s, 2, false), n, nn);
		if GetGame(n, g) = false then
		begin
			slwriteln('\WH * That game does not exist.');
			exit;
		end;

		SaveScr;
		viewing := n;
		xwindow(1, 1, scrbx, scrby);
		if ((g.name_w = myrec.name) and (flipped = true)) or
		   ((g.name_b = myrec.name) and (flipped = false)) then
		begin
			flipped := not flipped;
			DisplayNumbers;
		end;
		DisplayScreen(g);
		DisplayInfo(g);
		DisplayHistory(g);
		ResetScr;
		exit;
	end;

	if w1 = '/expert' then
	begin
		enteruserline;
		expert := not expert;

		slwrite('\WH * You are now ');
		if expert then
			xwriteln('an expert.')
		else
			xwriteln('no longer an expert.');

		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		DisplayHistory(g);
		ResetScr;
		exit;
	end;

{	if w1 = '/mail' then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You must \LC/view\WH a game before you can play it.');
			exit;
		end;

		MailGame(g, true);
		slwriteln('\WH * Done.');
		exit;
	end;}

	if w1 = '/draw' then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You must \LC/view\WH a game before you can play it.');
			exit;
		end;

		if (g.name_w <> myrec.name) and (g.name_b <> myrec.name) then
		begin
			slwriteln('\WH * You are not playing in this game!');
			exit;
		end;

		if g.state > Finished then
		begin
			slwriteln('\WH * This game has finished.');
			exit;
		end;

		GetGame(viewing, g);

		if g.name_w = myrec.name then
		begin
			g.draw_w := not g.draw_w;
			bo := g.draw_w;
		end
		else
		begin
			g.draw_b := not g.draw_b;
			bo := g.draw_b;
		end;

		if bo then
			slwriteln('\WH * You have submitted a draw for this game.')
		else
			slwriteln('\WH * You have withdrawn your draw offer for this game.');

		if g.draw_w and g.draw_b then
		begin
			slwriteln('\WH * This game has been drawn.');
			g.state := DrawMut;
			AddToAlge(g, '-');

			SaveScr;
			xwindow(1, 1, scrbx, scrby);
			DisplayInfo(g);
			DisplayHistory(g);
			ResetScr;

			SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);
		end;

		PutGame(viewing, g);

		exit;
	end;

	if w1 = '/wop' then
	begin
		enteruserline;
		MakeComputerMove(g, g.turn, p1, p2);

		s := '/fmove ' + chr(p1.x+96) + chr(p1.y+48) +
							 chr(p2.x+96) + chr(p2.y+48);
		w1 := '/fmove';

		slwriteln('\WH * '+s);
	end;

	if w1 = '/takeback' then
	begin
		enteruserline;

		TakeBack(g);
		exit;
	end;

	if w1 = '/resign' then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You must \LC/view\WH a game before you can play it.');
			exit;
		end;

		if (g.name_w <> myrec.name) and (g.name_b <> myrec.name) then
		begin
			slwriteln('\WH * You are not playing in this game!');
			exit;
		end;

		if g.state > Finished then
		begin
			slwriteln('\WH * This game has finished.');
			exit;
		end;

		GetGame(viewing, g);

		g.state := Resigned;
		if g.name_w = myrec.name then
		begin
			g.winner := PBlack;
			AddToAlge(g, '0-1');
		end
		else
		begin
			g.winner := PWhite;
			AddToAlge(g, '1-0');
		end;

		PutGame(viewing, g);

		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		DisplayInfo(g);
		DisplayHistory(g);
		ResetScr;

		slwriteln('\WH * You have resigned.');

		SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);
		exit;
	end;


	if (w1 = '/put') and (GetAccLvl = 255) then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You must \LC/view\WH a game before you can play it.');
			exit;
		end;

		if (PosTranslate(aword(s, 2, false), p1) = false) then
		begin
			ResetScr;
			slwriteln('\WH * Illegal coordinates.  Type /chess-help for syntax.');
			exit;
		end;

		GetGame(viewing, g);

		s := ups(aword(s, 3, false));
		if s = '' then
		begin
			SaveScr;
			xwindow(1, 1, scrbx, scrby);
			PutP(g, p1, None);
			WritePiece(p1, None);
			PutGame(viewing, g);
			ResetScr;
			SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);
			exit;
		end;

		if not (s[1] in ['W','B']) then
		begin
			slwriteln('\WH * Must specify piece to be either white or black.');
			exit;
		end;

		if s[1] = 'W' then
			s := '\WH'+s[2]
		else
			s := '\DG'+s[2];

		for lpp := None to BPok do
		begin
			if s = PieceName[lpp] then
			begin
				SaveScr;
				xwindow(1, 1, scrbx, scrby);
				PutP(g, p1, lpp);
				WritePiece(p1, lpp);
				PutGame(viewing, g);
				ResetScr;
				SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);
				exit;
			end;
		end;

		slwriteln('\WH * Piece not found.');
		exit;
	end;

	if w1 = '/flip' then
	begin
		enteruserline;
		if viewing = 0 then exit;

		flipped := not flipped;

		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		DisplayScreen(g);
		DisplayNumbers;
		DisplayInfo(g);
		DisplayHistory(g);
		ResetScr;
		exit;
	end;

	if (w1 = '/delete') and (GetAccLvl = 255) then
	begin
		enteruserline;
		val(aword(s, 2, false), n, nn);
		if (n = 0) or (nn <> 0) then
		begin
			slwriteln('\WH * No such game.');
			exit;
		end;
		assign(fptr, cfg.gamedir+strs(n)+'.CHS');
		{$i-} erase(fptr); {$I+}
		if ioresult <> 0 then
			slwriteln('\WH * No such game.')
		else
			slwriteln('\WH * Game successfully deleted.');
		exit;
	end;

	if (w1 = '/move') or (w1 = '/m') or ((w1 = '/fmove') and (GetAccLvl = 255)) then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You must \LC/view\WH a game before you can play it.');
			exit;
		end;

		if w1 <> '/fmove' then
		begin
			if (g.name_w <> myrec.name) and (g.name_b <> myrec.name) then
			begin
				slwriteln('\WH * You are not playing in this game!');
				exit;
			end;

			if g.state > Finished then
			begin
				slwriteln('\WH * This game has finished.');
				exit;
			end;

			if ( (g.turn = PWhite) and (g.name_w <> myrec.name) ) or
			   ( (g.turn = PBlack) and (g.name_b <> myrec.name) ) then
			begin
				slwriteln('\WH * It is not your turn in this game.');
				exit;
			end;
		end;

		SaveScr;
		xwindow(1, 1, scrbx, scrby);

		s := aword(s, 2, true);
		while pos(' ', s) > 0 do
			delete(s, pos(' ', s), 1);

		ss := ups(copy(s, 5, 1));

		if (PosTranslate(copy(s, 1, 2), p1) = false) or
		   (PosTranslate(copy(s, 3, 2), p2) = false) then
		begin
			if TransAlge(g, s, g.turn, p1, p2, ss, true) = false then
			begin
				ResetScr;
				slwriteln('\WH * Illegal coordinates.  Type /chess-help for syntax.');
				exit;
			end;
		end;

		c := GetColor(g, p1);

		if c = PNone then
		begin
			ResetScr;
			slwriteln('\WH * There is no piece on that square to move.');
			exit;
		end;

		if c <> g.turn then
		begin
			ResetScr;
			slwriteln('\WH * You must move one of your pieces.');
			exit;
		end;

		GetGame(viewing, g);
		move(g, g2, sizeof(gamet));

		taken := GetP(g, p2);

		if not IsValidMove(g, p1, p2, true, IsEnPas) then
		begin
			ResetScr;
			slwriteln('\WH * That is an illegal move.');
			exit;
		end;

		MovePiece(g, p1, p2);

		if CheckCheck(g, g.turn) then
		begin
			move(g2, g, sizeof(gamet));
			ResetScr;
			slwriteln('\WH * You may not put yourself in check.');
			exit;
		end;

		proto := None;

		if (GetP(g, p2) in [WPawn, BPawn]) and
		   (( (c = PWhite) and (p2.y = 8) ) or
			( (c = PBlack) and (p2.y = 1) )) then
		begin
			if (length(ss) = 1) and (ss[1] in ['K', 'P']) then
			begin
				ResetScr;
				slwrite('\WH * You may not promote your pawn to a ');
				if ss = 'K' then
					xwriteln('king.')
				else
					xwriteln('pawn.');

				move(g2, g, sizeof(gamet));
				exit;
			end;

			if c = PWhite then
				ss := '\WH' + ss
			else
				ss := '\DG' + ss;

			for lpp := None to BPok do
			begin
				if ss = PieceName[lpp] then
					proto := lpp;
			end;

			if proto = None then
			begin
				if c = PWhite then
					proto := WQueen
				else
					proto := BQueen;
			end;

			PutP(g, p2, proto);
		end;

		WritePiece(p1, GetP(g, p1));
		WritePiece(p2, GetP(g, p2));

		inc(g.moven);

		if g.turn = PWhite then
			g.turn := PBlack
		else
			g.turn := PWhite;

		isincm := CheckCheckMate(g, g.turn);

		if CheckCheck(g, g.turn) then
		begin
			g.state := Check;

			if isincm then
			begin
				g.state := CheckMate;
				g.winner := invcolor(g.turn);
			end;
		end
		else
		begin
			if isincm then
				g.state := StaleMate
			else
				g.state := InProgress;
		end;

		AddToHistory(g, p1, p2, g.turn, taken, proto, isenpas);

		if CheckInsufPieces(g) = true then
		begin
			g.state := DrawIns;
			AddToAlge(g, '-');
		end;

		if CheckDraw50(g) = true then
		begin
			g.state := Draw50;
			AddToAlge(g, '-');
		end;

		g.lastmove := Time;
		g.takeback := false;

		proto := None;

		PutGame(viewing, g);

		DisplayHistory(g);
		DisplayInfo(g);

		ResetScr;

		if CheckInsufPieces(g) = true then
			slwriteln('\WH * Insufficent pieces to force mate.');

		SendThisMsgAll('CHESS-UPD '+strs(viewing), 5);

		if g.turn = PWhite then
			n := GetUserNode(GetAName(g.name_w), true)
		else
			n := GetUserNode(GetAName(g.name_b), true);

		if n > 0 then
			SendThisMsgP('\WH[\LGC'+strs(viewing)+'\WH]'#13#10, 1, n);
		exit;
	end;

	if w1 = '/history' then
	begin
		enteruserline;
		disp_move(g);
		exit;
	end;

	chess_parse := false;
end;

procedure DeleteOldGames;
var
  sr		: searchrec;
  gr		: gamet;
  d			: longint;
begin
	findfirst(cfg.gamedir+'*.CHS', 0, sr);

	while DosError = 0 do
	begin
		OpenSharedFile(cfg.gamedir+sr.name, IRead+DenyNone);
		blockread(sf.f, gr, sizeof(gr));
		CloseSharedFile;

		d := Time;

		if (gr.state = NotStarted) and (gr.lastmove + 7 * 86400 < d) then
			{$i-} erase(sf.f); {$I+}

		findnext(sr);
	end;
end;


procedure ChessMaint;
begin
	DeleteOldGames;

end;


var
	oldp : pointer;

procedure newp; far;
begin
	if inited = true then
	begin
		inited := false;
		xstrwrite(#27'[1r');
	end;

	exitproc := oldp;
end;

begin
	oldp := exitproc;
	exitproc := @newp;
end.

