unit ch_book;

interface

uses
	ch_def, defs, general, ch_gen, mogutils,
	xcrt, dos;


procedure LoadBook;

implementation

type
	booktree = record
		src, dest	: position;

		opening		: word;

		left, right,
		prev, next	: pointer;
	end;

var
	book	: booktree;


function Eq(p1, p2 : position) : boolean;
begin
	Eq := (p1.x = p2.x) and (p1.y = p2.y);
end;


procedure LoadBook;
var
	fptr 	: text;
	s, ss  	: string;
	n       : word;
	nb, b	: ^booktree;
	src, dest	: position;
	done		: boolean;
begin
	filemode := DenyNone + $2;
	assign(fptr, 'mogchess.bok');
	{$I-} reset(fptr); {$I+}
	if ioresult <> 0 then exit;

	n := 1;
	b := @book;
	s := '';

	while not eof(fptr) do
	begin
		if s = '' then
			readln(fptr, s);
		if s[1] <> '!' then
		begin
			if length(s) > 6 then
			begin
				ss := copy(s, 1, 6);
				delete(s, 1, 6);
				stripspaces(ss);

				if ss = 'o-o' then
					ss := 'e1g1';
				if ss = 'o-o-o' then
					ss := 'e1c1';
			end
			else
			begin
				ss := s;
				s := '';
				stripspaces(ss);

				if ss = 'o-o' then
					ss := 'e8g8';
				if ss = 'o-o-o' then
					ss := 'e8c8';
			end;

			if (PosTranslate(copy(ss, 1, 2), src) = false) or
			   (PosTranslate(copy(ss, 3, 2), dest) = false) then
			begin
				slwriteln('\WH * Error while loading chess book.');
				close(fptr);
				exit;
			end;

			done := false;
			while (b^.right <> Nil) and (not done) do
			begin
				if (eq(b^.src, src)) and (eq(b^.dest, dest)) then
					done := true
				else
					b := b^.right;
			end;

			if not done then
			begin
				getmem(nb, sizeof(booktree));
				fillchar(nb^, sizeof(booktree), 0);

				b^.right := nb;
				nb^.left := b;
				b := nb;
				b^.src := src;
				b^.dest := dest;
			end;

			if b^.next <> Nil then
			begin
				b := b^.next;
				while b^.right <> Nil do
					b := b^.right;

				getmem(nb, sizeof(booktree));
				fillchar(nb^, sizeof(booktree), 0);

				b^.right := nb;
				nb^.left := b;
				b := nb;
			end
			else
			begin
				getmem(nb, sizeof(booktree));
				fillchar(nb^, sizeof(booktree), 0);

				b^.next := nb;
				nb^.prev := b;
				b := nb;
			end;

			b^.opening := n;
		end
		else
		begin
			b := @book;
			inc(n);
			s := '';
		end;
	end;

	close(fptr);
end;



procedure GetNextMove(game : gamet; var src, dest : position);
begin



end;


end.
