unit ch_def;

interface

uses
	dos, dtime;

const _ver = '1.20';

type
	statet = ( NotSetup, NotStarted, InProgress, Check, Finished,
			   CheckMate, StaleMate, Resigned, DrawMut, Draw50, DrawRep, DrawIns, OutOfTime );

	piece = ( None,
			  WKing, WQueen, WBishop, WKnight, WRook, WPawn, WPok,
			  BKing, BQueen, BBishop, BKnight, BRook, BPawn, BPok );
	colortype = (PNone, PBlack, PWhite);

	boardtype = array [1..8,1..8] of piece;

	position = record
		x, y	: byte;
	end;

	historyt = record
		moven		: integer;
		src, dest  	: position;
		pmove		: piece;
		promoted	: piece;
		captured	: piece;
		castled		: boolean;
		alge		: string[10];
		prev, next	: pointer;
	end;

	gamet = record
		name_w, name_b		: string[25];
		time_w, time_b		: longint;
		maxtime				: longint;
		start_time, end_time: longint;
		turn				: colortype;
		state				: statet;
		moven				: longint;
		board				: boardtype;
		history				: historyt;
		historyend			: ^historyt;
		winner				: colortype;
		draw_w, draw_b		: boolean;
		lastmove			: time_t;
		takeback			: boolean;

		spare				: array [1..199] of byte;
	end;


const
	PieceName : array [None..BPok] of string[6] =
		( ' ', '\WHK', '\WHQ', '\WHB', '\WHN', '\WHR', '\WHP', '\WH!',
			   '\DGK', '\DGQ', '\DGB', '\DGN', '\DGR', '\DGP', '\DG!' );


	states : array [NotSetup..OutOfTime] of string[20] =
		( 'Not Setup', 'Not Started', 'In Progress', 'Check', 'Finished', 'CheckMate',
		  'StaleMate', 'Resigned', 'Draw Agreed', 'Draw (50)', 'Draw (Rep)', 'Draw (Insuf)', 'Out Of Time' );




var
	viewing 	: word;
	expert	 	: boolean;
	sx, sy 		: word;
	inited		: boolean;
	flipped		: boolean;


implementation


begin
	inited := false;
	viewing := 0;
	flipped := false;
	expert := false;
end.
