unit defs;

interface

uses
	filedef, dtime;

const
	_ver = '1.60';

type
	acttype = ( Replace );

	sharedrec	= record
		name		: string[25];
		alias		: string[50];
		abbrname	: string[10];
		node		: word;
		channel		: word;
		listed		: boolean;
		silenced	: boolean;
		ischanop	: boolean;
		afk			: boolean;
		ismoderator : boolean;
		invisible	: boolean;
	end;

	channelrec	= record
		things		: byte;
		name	 	: string[65];
		password	: string[10];
		stuff   	: string[9];
		frozen		: boolean;
		users		: word;
		credpermin	: word;			{ credits per minute }
		spamlvl		: byte;			{ lines per ten seconds }
		moderated	: boolean;
		nowhispers  : boolean;
		quiet		: boolean;
		b1ff		: boolean;
		stuffs		: byte;
	end;

	cfgtype		= record
		maxnodes	: word;
		channeldir	: string[45];
		realtimedir : string[45];
		gamedir		: string[45];
		logmgrdir	: string[45];

		PrivLvl, WeenieLvl, BeepLvl, ViewOpCmds, ChanOpLvl,
		RenameLvl, ConfOpLvl, CantSilenceLvl, CantKickLvl, BootLvl,
		SysLvl, AllowTabLvl, BanLvl, MacroLvl, IgnorePasswordLvl,
		DispRealNameLvl, SetConfOpLvl, AdjTimeLvl, AdjMPLvl, NoTimeLvl,
		OrderLvl, FreezeLvl, SetLvl, WriteLvl, CantBanLvl,
		RenameOverrideLvl, CantBootLvl, SetAbbrLvl, ScanAllLvl,
		InvisibleLvl : byte;

		WritingIndent, NoticeIndent : byte;

		PointsForSuccessfulWeenie, PointsForFailedWeenie : longint;
		CostToWeenie, CostToNosui : longint;

		defusrcol	: string[15];
		defmsgcol	: string[15];
		defwhiscol	: string[15];
	end;

	msghdr		= record
		msgtype		: word;
		msglen		: word;
		msgfrom		: string[25];
		noignore	: boolean;
		msgufrom	: string[25];
		room		: array [1..4] of byte;
	end;

	cusertype	= record
		name		: string[25];
		alias		: string[50];
		banned		: boolean;
		nopagewarn	: boolean;
		ignoreusers	: longint;
		unused   	: boolean;

		notignore   : boolean;

		notifysend	: boolean;
		notifypage  : boolean;
		unused2 	: boolean;
		usewindow	: boolean;

		entrynotice	: longint;

		accesslvl	: byte;

		weenietry	: byte;
		iamweenie	: boolean;

		whisperbeep : boolean;
		norename    : boolean;

		abbrname	: string[10];
		banabbrset	: boolean;

		banneduntil : time_t;

		points		: longint;
		superrahtry : byte;

		allowsex	: boolean;
		invisible   : boolean;

		tabbeep		: boolean;

		chessexp	: boolean;

		left, right : longint;
		macros		: longint;

		binktab		: longint;

		spare		: array [1..38] of byte;
	end;


	sfhtype		= record
		f			: file;
		isopen		: boolean;
	end;

	ignore_t 	= record
		name 		: string[25];
		isperm		: boolean;
	end;

	ignorerec	= record
		name		: string[25];
		next		: longint;
		deleted		: boolean;
	end;

	vsptype		= record
		x, y		: word;
	end;

	badwordlist = record
		wrd		: ^string;
		repl	: ^string;
		next	: pointer;
	end;

	dmacrolist = record
		key		: byte;
		ext		: boolean;
		action	: acttype;
		str		: string;
		next	: longint;
	end;

	macrolist = record
		key		: byte;
		ext		: boolean;
		action	: acttype;
		str		: string;
		next	: pointer;
	end;

	logintype = ( TSlbbs, TLogin, TChat );

const
	MaxSpamLvl	= 30;

	DenyAll		= $10;
	DenyWrite 	= $20;
	DenyRead  	= $30;
	DenyNone  	= $40;

	IRead		= $0;
	IWrite		= $1;
	IRW			= $2;

	scrbx				= 80;
	scrby				= 24;

	hmaxnodes	= 20;



var
	timelimit		: integer;

	myrec			: sharedrec;
	mychan			: channelrec;
	myuser			: cusertype;
	myurec			: longint;

	sf				: sfhtype;
	usf				: sfhtype;

	ccnodes			: array [1..hmaxnodes] of ^sharedrec;
	topnode			: word;

	cfg				: cfgtype;

	filemode95		: word;

	watchtime		: boolean;

	ignore			: array [1..30] of ignore_t;

	LoginSuccessful	: boolean;

	WarnTime		: word;

	heldmsg			: string;
	heldpos			: word;

	laststr			: string;

	upos			: longint;

	linetime		: array [1..MaxSpamLvl] of longint;
	lineptr			: byte;
	linefull		: boolean;

	badword			: badwordlist;

	realusername	: string[25];

	alarm			: timetype;
	alarmset		: boolean;

	boottime		: timetype;
	bootset			: boolean;

	mymacro			: ^macrolist;

	login			: logintype;


implementation
end.
