unit lmsg;

interface

uses
	xcrt, output, utils,
	defs,
	users, filedef;

procedure loginmsg(s : string);

implementation

type
	lmusrtype = record
		left, right	: word;
		name		: string[25];
		msg			: string[70];
		space		: array [1..155] of byte;
	end;


procedure loginmsg(s : string);
var
	lmusr	: lmusrtype;
	n,
	lastn   : word;
	fptr	: file;
	ss		: string;

begin
	filemode := FileMode95 + IRW + DenyNone;
	assign(fptr, cfg.logmgrdir+'logmgr.usr');
	{$i-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
	begin
		rewrite(fptr, 1);
		fillchar(lmusr, sizeof(lmusr), 0);
		blockwrite(fptr, lmusr, sizeof(lmusr));
		reset(fptr, 1);
		n := 0;
	end
	else
	begin
		blockread(fptr, lmusr, sizeof(lmusr));
		n := lmusr.right;
		lastn := 0;

		while n > 0 do
		begin
			seek(fptr, n*sizeof(lmusr));
			blockread(fptr, lmusr, sizeof(lmusr));

			if lmusr.name = user.name then
				break;

			lastn := n;

			if lmusr.name < user.name then
				n := lmusr.right
			else n := lmusr.left;
		end;
	end;

	if s = '' then
	begin
		close(fptr);

		if n = 0 then
			slwriteln('\WH * You don''t currently have a login message set.')
		else
		begin
			slwriteln('\WH * Your login message will be displayed like this: ');

			ss := lmusr.msg;
			if (length(ss) = 0) or not (ss[length(ss)] in ['!'..')','.',',',':',';']) then
				ss := ss + '.';

			if (length(ss) > 0) and (ss[1] in ['A'..'Z','a'..'z']) then
				insert(' ', ss, 1);

			slwriteln('\WH * Node \LG'+strs(cf.node)+'\WH: '+NameCaps(user.alias)+' has logged on' + ss);
		end;

		exit;
	end;

	if user.access.msglevel < 100 then
	begin
		close(fptr);
		slwriteln('\WH * Only donating users and above can set their login messages!');
		exit;
	end;

	if length(s) > 60 then
	begin
		close(fptr);
		slwriteln('\WH * Login messages must be less than 60 characters long.');
		exit;
	end;

	if n > 0 then
	begin
		lmusr.msg := stripcol(s);
		seek(fptr, n*sizeof(lmusr));
		blockwrite(fptr, lmusr, sizeof(lmusr));
	end
	else
	begin
		seek(fptr, lastn*sizeof(lmusr));
		blockread(fptr, lmusr, sizeof(lmusr));
		if lmusr.name < user.name then
			lmusr.right := filesize(fptr) div sizeof(lmusr)
		else
			lmusr.left := filesize(fptr) div sizeof(lmusr);
		seek(fptr, lastn*sizeof(lmusr));
		blockwrite(fptr, lmusr, sizeof(lmusr));

		seek(fptr, filesize(fptr));
		fillchar(lmusr, sizeof(lmusr), 0);
		lmusr.name := user.name;
		lmusr.msg := stripcol(s);
		blockwrite(fptr, lmusr, sizeof(lmusr));
	end;

	close(fptr);

	slwriteln('\WH * Your login message has been set.');
end;




end.


