unit lng;

interface

uses
	filedef;


type TLang = object
	StrHdr	: array [1..2048] of byte;

	constructor GetHeader;
	function GetString(n : integer) : string;
	function Replace(s : string; sub : string) : string;
end;

implementation


constructor TLang.GetHeader;
var
	fptr : file;
begin
	assign(fptr, cf.datapath+'DEFAULT.LNG');
	reset(fptr, 1);
	blockread(fptr, StrHdr, 2048);
	close(fptr);
end;

function TLang.GetString(n : integer) : string;
var
	lp, tot  : integer;
	fptr : file;
	s : string;
begin
	tot := $800;
	for lp := 1 to n-1 do
		inc(tot, StrHdr[lp]);

	assign(fptr, cf.datapath+'DEFAULT.LNG');
	reset(fptr, 1);
	seek(fptr, tot);
	blockread(fptr, s[1], StrHdr[n]);
	s[0] := chr(StrHdr[n]);
	close(fptr);
	GetString := s;
end;

function TLang.Replace(s : string; sub : string) : string;
var
	n : integer;
begin
	n := pos('$', s);
	if (n > 0) then
		s := copy(s, 1, n-1) + sub + copy(s, n+1, length(s));

	Replace := s;
end;

end.
