unit mogcmd;

interface

uses
	users, multi, chat, statlog, modem, sublist, general, filedef,
	dos, xcrt,
	slget,
	mogutils, mogfile, mogsend, utils, dtime,
	g_mind, chess, othello, ext, defs, scr;


procedure killuserline(x : word);

procedure WriteMyInfo;
procedure WriteMyUser;

procedure PrintUserList;
procedure ConfUserList(s : string);
procedure ScanChannel;

procedure LoadIgnores;
procedure IgnoreUser(s : string; perm : boolean);

procedure PrivateMsg(touser, msg : string; x : integer);
procedure SendOrder(name, order : string; perror : boolean);
procedure SendPage(tonode, msg : string; x : integer);
procedure AdjTime(u : string; tm : string);

procedure WriteLog(s : string);

implementation


procedure killuserline(x : word);
var
  h, n, lp : word;
begin
	h := (xwherey-1) * scrbx + (xwherex-1);
	n := h - (x);
	h := h div scrbx + 1;
	n := n div scrbx + 1;

	for lp := h downto n do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;
end;



function MogChatStatus(a : integer) : string;
begin
	if a = 99 then
		MogChatStatus := 'Using Main Program'
	else
		MogChatStatus := ChatStatus(a);
end;

procedure WriteMyInfo;
begin
	seek(usf.f, sizeof(myrec)*myrec.node);
	blockwrite(usf.f, myrec, sizeof(myrec));
end;


procedure WriteMyUser;
begin
	OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IWrite+DenyWrite);
	seek(sf.f, myurec);
	blockwrite(sf.f, myuser, sizeof(myuser));
	CloseSharedFile;
end;


procedure PrintUserList;
var
	n : integer;
	r : sharedrec;
	nr : nodetype;
begin
	seek(usf.f, sizeof(sharedrec));

	PutHeading('Users currently on line', false);

	n := 1;
	while not eof(usf.f) do
	begin
		blockread(usf.f, r, sizeof(r));

		if not r.invisible then
		begin
			if r.node > 0 then
			begin
				slwriteln('   \GYNode '+strs(r.node)+':'+sp(3-length(strs(r.node)))+' \WH'+stripcol(r.alias)+'\DG '+
					spc(25-length(stripcol(r.alias)), '.')+' \GYchatting in teleconference.');
			end
			else
			begin
				if n <= maxnode then
				begin
					readnode(nr, n);
					if (nr.name <> '') then
						slwriteln('   \GYNode '+strs(n)+':'+sp(3-length(strs(n)))+' \WH'+namecaps(nr.name)+'\DG '+
							spc(25-length(stripcol(nr.name)), '.')+' \GY'+strlwr(mogchatstatus(nr.stat))+'.');
				end;
			end;
		end;

		inc(n);
	end;

	PutTrailer(false);
end;

procedure ConfUserList(s : string);
var
  au		: cusertype;
  u			: usertype;
  n 		: longint;
  plines	: integer;

begin
	PutHeading('MogTalk Userlist', false);

{	slwrite('\LGUser Name                BBS Alias        ');
	if GetAccLvl >= DispRealNameLvl then
		slwriteln('        Real Name               Acc')
	else
		xwriteln('');
}
	plines := 2;

	upstr(s);

	OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRead+DenyNone);
	while not eof(sf.f) do
	begin
		blockread(sf.f, au, sizeof(au));
		usearch(au.name, u, n);

		if n = 0 then
			continue;

		if (s = '') or (pos(s, ups(stripcol(au.alias))) > 0) or
		   ( (GetAccLvl >= cfg.DispRealNameLvl) and (pos(s, ups(u.name)) > 0) ) then
		begin
			slwrite(cfg.defusrcol + au.alias + sp(24-length(stripcol(au.alias))));

			if au.banned and (GetAccLvl >= cfg.DispRealNameLvl) then
				xtextcolor(darkgray)
			else if au.accesslvl >= cfg.ConfOpLvl then
				xtextcolor(white)
			else
				xtextcolor(lightgray);

			slwrite(u.alias + sp(24-length(u.alias)));
			if GetAccLvl >= cfg.DispRealNameLvl then
				slwriteln(u.name+sp(24-length(u.name))+strsn(au.accesslvl, 3)+strsn(au.points, 3))
			else
				slwriteln('');

			if plines = ScreenLength-scrty0-1 then
			begin
				plines := 0;

				case csn of
				  'S':
				  begin
					CloseSharedFile;
					exit;
				  end;

				  'N': plines := ScreenLength-scrty0-1;
				end;
			end;

			inc(plines);
		end;
	end;

	CloseSharedFile;
end;



procedure ScanChannel;
var
	r : sharedrec;
	nr : nodetype;
begin
	seek(usf.f, sizeof(sharedrec));

	PutHeading('MogTalk Channels', false);

	while not eof(usf.f) do
	begin
		blockread(usf.f, r, sizeof(r));
		if (r.node > 0) and not r.invisible then
		begin
			slwrite(' \GY'+strs2(r.node)+'   \WH'+stripcol(r.alias)+' \DG'+spc(31-length(stripcol(r.alias)), '.')+' \WH');
			if r.channel > 60000 then
				slwrite('(realtime chat)')
			else if (r.listed = false) and (GetAccLvl < cfg.ScanAllLvl) then
				slwrite('\GY(unlisted)')
			else
				slwrite(strsn(r.channel, 5));

			if r.afk then
				slwrite('    \WH'+blinky+'[AFK]\YE');

			slwriteln('');
		end
	end;

	PutTrailer(false);
end;



procedure addignoreuser(s : string);
var
	ir 		: ignorerec;
	ip		: longint;
begin
	OpenSharedFile(cfg.channeldir+'MOGTALK.IGN', IRW+DenyWrite);

	if filesize(sf.f) = 0 then
	begin
		fillchar(ir, sizeof(ir), 0);
		blockwrite(sf.f, ir, sizeof(ir));
		seek(sf.f, 0);
	end;

	ip := -1;

	while (not eof(sf.f)) and (ip = -1) do
	begin
		blockread(sf.f, ir, sizeof(ir));
		if ir.deleted then
			ip := filepos(sf.f) - sizeof(ir)
	end;

	if ip = -1 then ip := filesize(sf.f);

	if myuser.ignoreusers = 0 then
	begin
		myuser.ignoreusers := ip;
		ir.next := ip;
	end
	else
	begin
		seek(sf.f, myuser.ignoreusers);

		while ip <> -1 do
		begin
			blockread(sf.f, ir, sizeof(ir));
			if ir.next = 0 then
			begin
				ir.next := ip;
				seek(sf.f, filepos(sf.f)-sizeof(ir));
				blockwrite(sf.f, ir, sizeof(ir));
				ip := -1;
			end;
		end;
	end;

	seek(sf.f, ir.next);
	fillchar(ir, sizeof(ir), 0);
	ir.name := s;
	blockwrite(sf.f, ir, sizeof(ir));

	CloseSharedFile;

	WriteMyUser;
end;

procedure deleteignoreuser(s : string);
var
	ir, irb	: ignorerec;
	lp		: longint;
begin
	if myuser.ignoreusers = 0 then exit;

	OpenSharedFile(cfg.channeldir+'MOGTALK.IGN', IRW+DenyWrite);
	seek(sf.f, myuser.ignoreusers);

	lp := -1;
	ir.next := 1;

	while ir.next <> 0 do
	begin
		blockread(sf.f, ir, sizeof(ir));

		if (ir.name = s) then
		begin
			ir.deleted := true;
			seek(sf.f, filepos(sf.f)-sizeof(ir));

			if lp = -1 then
				myuser.ignoreusers := ir.next
			else
			begin
				seek(sf.f, lp);
				irb.next := ir.next;
				blockwrite(sf.f, irb, sizeof(irb));
			end;

			CloseSharedFile;
			WriteMyUser;
			exit;
		end;

		if lp = -1 then
			lp := myuser.ignoreusers
		else
			lp := irb.next;

		move(ir, irb, sizeof(irb));

		seek(sf.f, ir.next);
	end;

	CloseSharedFile;

	slwriteln(' * PROGRAM ERROR:  DeleteIgnoreUser at end of proc.  Please report to Sysop.');
end;

procedure LoadIgnores;
var
	lp : integer;
	ir : ignorerec;
begin
	if myuser.ignoreusers = 0 then exit;

	slwrite(#13#10' \WH* You have permanently ignored users active in your user profile!'#13#10+
			'   Type \LC/ignore\WH to view them.'#13#10);

	OpenSharedFile(cfg.channeldir+'MOGTALK.IGN', IRead+DenyNone);
	seek(sf.f, myuser.ignoreusers);

	lp := 1;

	repeat
	begin
		blockread(sf.f, ir, sizeof(ir));

		ignore[lp].name := ir.name;
		ignore[lp].isperm := true;
		inc(lp);

		if ir.next > 0 then seek(sf.f, ir.next);
	end
	until ir.next = 0;

	CloseSharedFile;
end;


procedure IgnoreUser(s : string; perm : boolean);
var
  free 		: integer;
  lp 		: integer;
  cut		: cusertype;
begin
	if GetCUserRec(s, cut) = false then
		exit;

	CloseSharedFile;

	if cut.alias = myrec.alias then
	begin
		slwrite('\WH * Unfortunately, you can''t ignore yourself!'#13#10);
		exit;
	end;

	free := 31;
	for lp := 1 to 30 do
	begin
		if ignore[lp].name = cut.name then
		begin
			ignore[lp].name := '';
			if ignore[lp].isperm then
				deleteignoreuser(cut.name);

			slwrite('\WH * User '+cfg.defusrcol+cut.alias+'\WH is now NOT ignored!'#13#10);
			exit;
		end;

		if (ignore[lp].name = '') and (lp < free) then
			free := lp;
	end;

	if free = 31 then
	begin
		slwrite('\WH * Error : You can only ignore up to 30 users!'#13#10);
		exit;
	end;

	ignore[free].name := cut.name;
	ignore[free].isperm := perm;

	if perm then
	begin
		addignoreuser(cut.name);
		slwrite('\WH * User '+cfg.defusrcol+cut.alias+'\WH now PERMANENTLY ignored!'#13#10);
	end
	else
		slwrite('\WH * User '+cfg.defusrcol+cut.alias+'\WH now ignored!'#13#10);
end;


procedure PrivateMsg(touser, msg : string; x : integer);
type
  blah = 1..hmaxnodes;

var
  lp, pp, n	: integer;
  sr 	: sharedrec;
  s, t	: string;
  send	: set of blah;

begin
	while pos(';', touser) > 0 do
		touser[pos(';', touser)] := ' ';

	stripspaces(touser);

	if touser = '' then
	begin
		enteruserline;
		exit;
	end;

	killuserline(x);

	send := [];
	s  := '';
	lp := 1;
	n  := 0;

	while aword(touser, lp, false) <> '' do
	begin
		if GetUserRec(aword(touser, lp, false), CurrentChannel, true, sr) = Okay then
		begin
			if not (sr.node in send) then
			begin
				send := send + [sr.node];
				inc(n);
				s := s + cfg.defusrcol + sr.alias + ', ';

				if sr.afk then
					slwrite('\WH * \LRNOTE: \WHUser '+cfg.defusrcol+sr.alias+'\WH is Away From Keyboard and may not see your message.'#13#10);
			end;
		end;

		inc(lp);
	end;

	if n = 0 then
	begin
		laststr := ';'+touser+' '+msg;
		exit;
	end;

	delete(s, length(s)-1, 2);

	for lp := 1 to topnode do
	begin
		if lp in send then
		begin
			if (n > 1) and (lp <> myrec.node) then
			begin
				t := '\WHFrom '+cfg.defusrcol+myrec.alias+', \GYalso to ';

				for pp := 1 to topnode do
				begin
					if (pp in send) and (pp <> lp) then
						t := t + cfg.defusrcol+ccnodes[pp]^.alias+', ';
				end;
				delete(t, length(t)-1, 2);

				SendThisMsgP(t+': \YE'+msg+#13#10, 3, lp)
			end
			else
				SendThisMsgP('\WHFrom '+cfg.defusrcol+myrec.alias+': \YE'+msg+#13#10, 3, lp);
		end;
	end;

	if myuser.notifysend then
		SendThisMsgP('\WH * Message only sent to '+s+'.'#13#10, 1, myrec.node);

	Indent := cfg.WritingIndent;
	slwrite('\WHTo '+s+': \YE'+msg+#13#10);
	Indent := 0;

end;

procedure SendOrder(name, order : string; perror : boolean);
var
	sr	: sharedrec;
begin
	if order = '' then
	begin
		slwrite('\WH * Order takes two parameters.  Type /? for help.'#13#10);
		exit;
	end;

	upstr(name);
	if name = 'CHANNEL' then
	begin
		SendThisMsg(order, 5);
		exit;
	end;

	if name = 'ALL' then
	begin
		SendThisMsgAll(order, 5);
		exit;
	end;

	if GetUserRec(name, AllChannels, perror, sr) = Okay then
		SendOrdMsg(order, sr.node);
end;


procedure SendPage(tonode, msg : string; x : integer);
var
  n, nn : integer;
  mynr : nodetype;
  ch : char;
  usr : sharedrec;
  s : string;
begin
	if (tonode = '') or (msg = '') then
	begin
		slwriteln('\WH * Incorrect use of /p.  Type /? for help.');
		exit;
	end;

	val(tonode, n, nn);
	if nn = 0 then
	begin
		if n > cfg.maxnodes then
		begin
			slwrite('\WH * You can only page nodes 1 through to '+strs(cfg.maxnodes)+'.'#13#10);
			exit;
		end;

		seek(usf.f, n*sizeof(usr));
		blockread(usf.f, usr, sizeof(usr));
	end
	else
	begin
		if GetUserRec(tonode, AllChannels, false, usr) <> Okay then
		begin
			indent := 3;
			slwriteln('\WH * User '+cfg.defusrcol+tonode+'\WH is not currently in teleconference!  Use a node number to page '+
				'someone that is logged in but not in MogTalk.');
			indent := 0;
			exit;
		end;
	end;

	if usr.node <> 0 then
	begin
		if (GetAccLvl < cfg.PrivLvl) then
		begin
			slwriteln('\WH * You are not permitted to /page people in teleconference.');
			exit;
		end;

		SendThisMsgP('\WHFrom '+cfg.defusrcol+myuser.alias+
			' \GY(channel \WH'+strs(myrec.channel)+'\GY): \YE'+msg+#13#10, 1, usr.node);
		killuserline(x);
		slwriteln('\WHTo '+cfg.defusrcol+usr.alias+' \GY(channel \WH'+strs(usr.channel)+'\GY): \YE'+msg);

		if myuser.notifypage then
			SendThisMsgP('\WH * Page sent.'#13#10, 1, myrec.node);
	end
	else
	begin
		if n > maxnode then
		begin
			slwriteln('\WH * There is no one on that node.');
			exit;
		end;

		if cf.node > maxnode then
		begin
			slwrite('\WH * You can only send outside pages from actual BBS nodes.'#13#10);
			exit;
		end;

		readnode(mynr, cf.node);

		if not mynr.isalias then
			s := user.name
		else
			s := user.alias;

		if (not mynr.isalias) and (not myuser.nopagewarn) then
		begin
			slwrite('\LR * Warning:'#13#10+'\WH');
			slwrite(  '   This page will be sent using your REAL NAME since you have logged in with'+#13#10+
					  '   your real name and the recipient is not in teleconference.'+#13#10+
					  '   Are you sure you want to do this? \LG');
			ch := xreadkey;
			if (ch <> 'Y') and (ch <> 'y') then
			begin
				slwriteln('No');
				exit;
			end;
				slwriteln('Yes');
		end;

		if SendMsg(n, s, msg) then
			SendThisMsgP('\WH * Page sent.'#13#10, 1, myrec.node)
		else
			SendThisMsgP('\WH * Unable to send page.  Try again later.'#13#10, 1, myrec.node);
	end;

end;

procedure adjtime(u : string; tm : string);
var
	n, nn : integer;
	sr : sharedrec;
begin
	if GetUserRec(u, CurrentChannel, true, sr) <> Okay then
		exit;

	if tm = '' then
		SendOrdMsg('QTIME', sr.node)
	else
	begin
		SendOrdMsg('ATIME '+tm, sr.node);
		SendOrdMsg('QTIME', sr.node);
	end;
end;

procedure WriteLog(s : string);
var
  t : string;
begin
	OpenSharedFile(cfg.channeldir+'MOGTALK.LOG', IRW+DenyWrite);

	t := '['+user.name+'|'+strs(myrec.node)+'] ['+StrT(Time)+'] '+s+#13#10;

	seek(sf.f, filesize(sf.f));
	blockwrite(sf.f, t[1], length(t));
	CloseSharedFile;
end;


end.
