unit mogsend;

interface

uses mogutils, defs, mogfile, utils;


procedure SendThisMsg(s : string; msgtype : word);
procedure SendThisMsgP(s : string; msgtype : word; tonode : word);
procedure SendThisMsgAll(s : string; msgtype : word);
procedure SendSysMsg(s : string);
procedure SendOrdMsg(s : string; n : word);
procedure SendPublicMsg(s : string);
procedure SendPublicMsgAll(s : string);

implementation



procedure SendThisMsg(s : string; msgtype : word);
var
	lp  : integer;
	mh  : msghdr;
begin
	fillchar(mh, sizeof(mh), 0);

	mh.msgtype := msgtype;
	mh.msglen := length(s);
	mh.msgfrom := myrec.alias;
	mh.msgufrom := myrec.name;
	mh.noignore := myuser.notignore;

	for lp := 1 to topnode do
	begin
		if (ccnodes[lp] <> Nil) and (lp <> myrec.node) then
		begin
			OpenSharedFile(cfg.channeldir+strs(lp)+'.ICM', IWrite+DenyWrite);
			seek(sf.f, filesize(sf.f));
			blockwrite(sf.f, mh, sizeof(mh));
			blockwrite(sf.f, s[1], mh.msglen);
			CloseSharedFile;
		end;
	end;

	if msgtype = 1 then
		ReadChannelInfo;
end;



procedure SendThisMsgAll(s : string; msgtype : word);
var
	lp  : integer;
	mh  : msghdr;
	rec : sharedrec;

begin
	fillchar(mh, sizeof(mh), 0);
	mh.msgtype := msgtype;
	mh.msglen := length(s);
	mh.msgfrom := myrec.alias;
	mh.msgufrom := myrec.name;
	mh.noignore := myuser.notignore;

	seek(usf.f, 0);
	while not eof(usf.f) do
	begin
		blockread(usf.f, rec, sizeof(rec));
		if rec.node <> 0 then
		begin
			OpenSharedFile(cfg.channeldir+strs(rec.node)+'.ICM', IWrite+DenyWrite);
			seek(sf.f, filesize(sf.f));
			blockwrite(sf.f, mh, sizeof(mh));
			blockwrite(sf.f, s[1], mh.msglen);
			CloseSharedFile;
		end;
	end;
end;



procedure SendThisMsgP(s : string; msgtype : word; tonode : word);
var
	mh	: msghdr;
begin
	fillchar(mh, sizeof(mh), 0);
	mh.msgtype := msgtype;
	mh.msglen := length(s);
	mh.msgfrom := myrec.alias;
	mh.msgufrom := myrec.name;
	mh.noignore := myuser.notignore;

	OpenSharedFile(cfg.channeldir+strs(tonode)+'.ICM', IWrite+DenyWrite);
	seek(sf.f, filesize(sf.f));
	blockwrite(sf.f, mh, sizeof(mh));
	blockwrite(sf.f, s[1], mh.msglen);
	CloseSharedFile;
end;


procedure SendSysMsg(s : string);
begin
	if myrec.invisible then
		exit;

	SendThisMsg('\WH * '+s+#13#10, 1);
end;


procedure SendOrdMsg(s : string; n : word);
var
	mh		: msghdr;
begin
	fillchar(mh, sizeof(mh), 0);
	mh.msgtype := 5;
	mh.msglen := length(s);
	mh.msgfrom := myrec.alias;
	mh.msgufrom := myrec.name;
	mh.noignore := true;

	OpenSharedFile(cfg.channeldir+strs(n)+'.ICM', IWrite+DenyWrite);
	seek(sf.f, filesize(sf.f));
	blockwrite(sf.f, mh, sizeof(mh));
	blockwrite(sf.f, s[1], mh.msglen);
	CloseSharedFile;
end;

procedure SendPublicMsg(s : string);
begin
	if myrec.invisible then
		exit;

	SendThisMsg(cfg.defusrcol+myrec.alias+': '+cfg.defmsgcol+s+#13#10, 2);

	if myuser.notifysend then
		SendThisMsgP('\WH * Message sent.'#13#10, 1, myrec.node);
end;

procedure SendPublicMsgAll(s : string);
begin
	if myrec.invisible then
		exit;

	SendThisMsgAll(cfg.defusrcol+myrec.alias+': '+cfg.defmsgcol+s+#13#10, 2);

	if myuser.notifysend then
		SendThisMsgP('\WH * Message sent.'#13#10, 1, myrec.node);
end;


end.
