{
  *
  * MogTalk!
  *
  *
  * This program is free software; you can redistribute it and/or
  *	modify it under the terms of the GNU General Public License
  *	as published by the Free Software Foundation; either version 2
  *	of the License, or (at your option) any later version.
  *
  *	This program is distributed in the hope that it will be useful,
  *	but WITHOUT ANY WARRANTY; without even the implied warranty of
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
  *	You should have received a copy of the GNU General Public License
  *	along with this program; if not, write to the Free Software
  *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  *
  *
  * Written by Roger Nesbitt.
  * Copyright (C)1996-2000 LastByte Software
  *
}

{$M $4000, 0, $4000}

uses
	users, multi, chat, statlog, modem, sublist, general, filedef, syslog,
	dos, xcrt,
	slget,
	recent,
	defs, mogcmd, mogutils, mogfile, mogsend, utils, dtime, scr,
	{g_mind,} chess, othello, binkbar, ext;




function timeon : integer;
var
	h,m,s,hs : word;
	a, b : word;
begin
	gettime(h, m, s, hs);
	a := h * 60 + m;
	b := cf.logtime.hour * 60 + cf.logtime.minute;

	if (a < b) then
		inc(a, 1440);

	timeon := a - b;
end;



function TimeExpired : boolean;
var t : word;
begin
	if (xCarrierDetect = false) then
	begin
		TimeExpired := true;
		exit;
	end;

	if (watchtime = false) then
	begin
		TimeExpired := false;
		exit;
	end;

	TimeExpired := timelimit-timeon < 1;
end;







procedure LeaveConference(notify : boolean);
var
	blank : sharedrec;

begin
	if notify and not myrec.invisible then
		SendThisMsgAll('\WH * '+cfg.defusrcol+myrec.alias+' \WHhas left teleconference.'#13#10, 1)
	else
		SendThisMsgAll('', 1);

	fillchar(blank, sizeof(blank), 0);
	seek(usf.f, sizeof(myrec)*myrec.node);
	blockwrite(usf.f, blank, sizeof(blank));
end;


procedure LeaveChannel(notify : boolean);
var
	blankrec	: sharedrec;
	lp			: integer;
	s			: string;
	fptr		: file;
begin
	fillchar(blankrec, sizeof(blankrec), 0);

	if notify and not myrec.invisible then
		SendSysMsg(cfg.defusrcol+myrec.alias+' \WHhas left this channel.');

	WriteLog(#1' Leaving channnel '+strs(myrec.channel));

	s := cfg.channeldir+strs(myrec.channel)+'.CHA';
	myrec.channel := 0;

	WriteMyInfo;

	for lp := 1 to topnode do
	begin
		if (ccnodes[lp] <> Nil) and (lp <> myrec.node) then
			exit;
	end;

	assign(fptr, s);
	{$I-} erase(fptr); {$I+}
end;



function JoinChannel(n : word; notify : boolean) : word;
var
	cha		: channelrec;
	s 		: string;
	rec  	: sharedrec;
begin
	if (myrec.channel > 0) then
		LeaveChannel(true);

	JoinChannel := n;

	myrec.channel := n;
	myrec.ischanop := false;
	myrec.silenced := false;

	ReadCInfo;

	if (cha.password <> '') and (n <> 1) then
	begin
		slwrite('\WH * The channel you wish to change to is password protected.'#13#10);
		if GetAccLvl < cfg.IgnorePasswordLvl then
		begin
			slwrite('\WH   Please enter the password: \LC');
			s := getline('', 10, false, false);
			stripspaces(s);
			upstr(s);
			if s <> cha.password then
			begin
				slwrite('\LR * Incorrect password!  Returning to channel 1.'#13#10);
				xdelay(1000);

				JoinChannel := JoinChannel(1, notify);
				exit;
			end;
		end;
	end;

	WriteMyInfo;
	ReadChannelInfo;

	WriteLog(#1' Joining channnel '+strs(myrec.channel));

	if notify and not myrec.invisible then
		SendSysMsg(cfg.defusrcol+myrec.alias+' \WHhas joined this channel.')
	else
		SendThisMsg('', 1);
end;



procedure Nosui;
begin
	enteruserline;

	if myuser.points < cfg.CostToNosui then
	begin
		slwriteln('\WH * You don''t have enough points to Nosui!');
		exit;
	end;

	dec(myuser.points, cfg.CostToNosui);
	WriteMyUser;

	SendThisMsg('\WH * Aaaaaaaaaaaawwwwwwwwwhhhhhhhhhhhhhhhhhhhh................'#13#10, 1);
	SendThisMsg('BEEP', 5);

	SendThisMsg('\lr'+blinky+'                '#13#10, 1);
	SendThisMsg('\lr'+blinky+'          '#13#10, 1);
	SendThisMsg('\lr'+blinky+'                '#13#10, 1);
	SendThisMsg('\lr'+blinky+'                '#13#10, 1);
	SendThisMsg('\lr'+blinky+'        '#13#10, 1);
	SendThisMsg('\lr'+blinky+'               '#13#10, 1);
end;



procedure ToggleChanOp(s : string);
var
	sr : sharedrec;
begin
	if GetUserRec(s, CurrentChannel, true, sr) <> Okay then
		exit;

	if (sr.ischanop = false) then
	begin
		slwrite('\WH * You have made user '+cfg.defusrcol+sr.alias+'\WH a channel operator.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH is now a channel operator.');
	end
	else
	begin
		slwrite('\WH * User '+cfg.defusrcol+sr.alias+'\WH is no longer a channel operator.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH is no longer a channel operator.');
	end;

	SendOrder(sr.alias, 'CHANOP', false);
end;


procedure ToggleModerator(s : string);
var
	sr : sharedrec;
begin
	if GetUserRec(s, CurrentChannel, true, sr) <> Okay then
		exit;

	if (sr.ismoderator = false) then
	begin
		slwrite('\WH * You have made user '+cfg.defusrcol+sr.alias+'\WH a moderator.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH is now a moderator.');
	end
	else
	begin
		slwrite('\WH * User '+cfg.defusrcol+sr.alias+'\WH is no longer a moderator.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH is no longer a moderator.');
	end;

	SendOrder(sr.alias, 'MODERATOR', false);
end;

(*
const nquests : integer = 20;
type questset = set of 1..20;
const quests : array[1..20] of string[60] =
	( 'What year was Little born?1987',
	  'How many singers are there in a wind quartet?none',
	  'How many keys are there on a trumpet?3',
	  'What is the first letter of Mogest''s password?w',
	  'A lemon with a twist is a...?twisted lemon',
	  'He hardly knows which way is up, and which way...?down',
	  'Seal my fate, what do I get in mail?your tongue',
	  'What is blah encrypted with Dvorak?xnad',
	  'How many lines of source was MogTalk v1.416 (to 2sf)?11000',
	  'When was Chopin born?1810',
	  'Why is it?Why isn''t it?',
	  'Does Pok exist?If Pok exists',
	  'How many poks are there in a pok?many',
	  'How many CPUs are there in Mogest''s room?4',
	  'What does NPT stand for?nothing',
	  'Not so fast Mike, turn on your...?television',
	  'What did we have for tea on 27/02/97?stuff',
	  'NOL is dead!  And?no one cares',
	  'Rah?Rahhhhhh',
	  'What colour are Eclipse''s curtains?green'
	);
*)

procedure Weenie(s : string);
var
	sr : sharedrec;
	today : word;
	lp, n : word;
{	qs : questset;}
	t : string;

label doit;

begin
{	qs := [];}

	getdate(n, n, today, n);
	if (myuser.weenietry = today) and (GetAccLvl < 255) then
	begin
		slwrite('\WH * Sorry, you''ve already weenied once today!'#13#10);
		exit;
	end;

	if GetUserRec(s, CurrentChannel, true, sr) <> Okay then
		exit;

	myuser.weenietry := today;
	WriteMyUser;

(*
{	if sr.name = 'BEN AITCHISON' then
	begin
		slwriteln(#10'\WHYour weenie victim is labelled as an automatic FreeWeenie (tm).');
		goto doit;
	end;}

	slwrite(#10'\WHSo... you think '+defusrcol+sr.alias+'\WH is a weenie, eh?  Well, '+
		'to prove that you''re not a weenie yourself, you''d better answer these following '+
		'questions correctly!'#13#10#10);

	randomize;

	for lp := 1 to 5 do
	begin
		repeat
			n := random(nquests)+1;
		until not (n in qs);

		qs := qs + [n];

		s := copy(quests[n], pos('?',quests[n])+1, 1000);
		slwrite(' \YE'+strs(lp)+') \LG'+copy(quests[n], 1, pos('?', quests[n]))+' \LM('+strs(length(s))+' characters) \LC');

		t := getline('', length(s), false, false);

		upstr(s);
		upstr(t);

		if s <> t then
		begin
			slwriteln(#10'\WHIncorrect answer!  Try again another day.'#13#10);
			if PointsForFailedWeenie <> 0 then
			begin
				slwriteln(#10'\WHYou have lost \LG'+strs(-PointsForFailedWeenie)+'\WH MogPoints for your failed weenie!');
				inc(myuser.points, PointsForFailedWeenie);
				WriteMyUser;
			end;
			SendSysMsg('User '+defusrcol+myuser.alias+'\WH tried to weenie '+defusrcol+sr.alias+'\WH and FAILED\WH!');
			exit;
		end;
	end;

doit:
	slwriteln(#10'\WHWell done!  '+defusrcol+sr.alias+'\WH is now receiving your weenie message.');

	if PointsForSuccessfulWeenie <> 0 then
	begin
		slwriteln('\WHYou have gained \LG'+strs(PointsForSuccessfulWeenie)+'\WH MogPoints for your weenie!');
		inc(myuser.points, PointsForSuccessfulWeenie);
		WriteMyUser;
	end;

	xwriteln('');
*)
	SendSysMsg('User '+cfg.defusrcol+myuser.alias+'\WH thinks that '+cfg.defusrcol+sr.alias+'\WH is a weenie!');
	SendOrdMsg('WEENIE', sr.node);
end;

procedure ToggleSilence(s : string);
var
	sr : sharedrec;
begin
	if GetUserRec(s, CurrentChannel, true, sr) <> Okay then
		exit;

	SendOrder(sr.alias, 'SILENCE', false);

	if not sr.silenced then
	begin
		slwrite('\WH * You have silenced user '+cfg.defusrcol+sr.alias+'\WH.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH has been silenced.');
	end
	else
	begin
		slwrite('\WH * User '+cfg.defusrcol+sr.alias+'\WH is now allowed to talk.'#13#10);
		SendSysMsg('User '+cfg.defusrcol+sr.alias+'\WH is no longer silenced.');
	end;
end;


procedure BanUser(un : string; mins : longint);
var
  au	: cusertype;
  t		: time_t;
  r 	: word;
  date	: datetype;
begin
	if GetCUserRec(un, au) = false then
		exit;

	if (au.accesslvl >= GetAccLvl) and (GetAccLvl < 255) then
	begin
		slwriteln('\WH * You must have higher access than the person you wish to ban.');
		CloseSharedFile;
		exit;
	end;

	if au.banned = false then
	begin
		if mins > 0 then
		begin
			t := Time;
			au.banneduntil := t + mins * 60;

			ConvTtoDT(au.banneduntil, date);
			slwrite('\WH * User '+cfg.defusrcol+au.alias+'\WH has been banned until \LG'+strdate(date)+'\WH at ');
			r := (au.banneduntil mod 86400) div 60;
			slwriteln('\LG'+strs2(r div 60)+':'+strs2(r mod 60)+'\WH.');
		end
		else
		begin
			slwriteln('\WH * User '+cfg.defusrcol+au.alias+'\WH has been banned permenantly.');
			au.banneduntil := 0;
		end;

		au.banned := true;
		blockwrite(sf.f, au, sizeof(au));
	end
	else
	begin
		if au.banneduntil = 0 then
			slwriteln('\WH * User '+cfg.defusrcol+au.alias+'\WH is already banned permenantly.')
		else
		begin
			ConvTToDT(au.banneduntil, date);
			slwrite('\WH * User '+cfg.defusrcol+au.alias+'\WH is already banned until \LG'+strdate(date)+'\WH at ');
			r := (au.banneduntil mod 86400) div 60;
			slwriteln('\LG'+strs2(r div 60)+':'+strs2(r mod 60)+'\WH.');
		end;
	end;

	CloseSharedFile;
end;


procedure UnbanUser(un : string);
var
	au	: cusertype;
	t	: time_t;
	time: timetype;
	date: datetype;
	r : word;
begin
	if GetCUserRec(un, au) = false then
		exit;

	if (au.accesslvl >= GetAccLvl) and (GetAccLvl < 255) then
	begin
		slwriteln('\WH * You must have higher access than the person you wish to unban.');
		CloseSharedFile;
		exit;
	end;

	if au.banned = false then
	begin
		slwrite('\WH * User '+cfg.defusrcol+au.alias+'\WH is not banned!'#13#10);
	end
	else
	begin
		slwrite('\WH * User '+cfg.defusrcol+au.alias+'\WH may now use teleconference.'#13#10);

		au.banned := false;
		blockwrite(sf.f, au, sizeof(au));
	end;

	CloseSharedFile;
end;



function MakeAbbrName(s : string) : string;
var
 t, u  : string;
 n	   : integer;
begin
	s := stripcol(s);
	stripspaces(s);

	if aword(s, 2, false) = '' then
	begin
		MakeAbbrName := copy(s, 1, 10);
		exit;
	end;

	t := '';
	n := 1;
	while aword(s, n, false) <> '' do
	begin
		u := aword(s, n, false);
		t := t + upcase(u[1]);

		inc(n);
	end;

	MakeAbbrName := t;
end;

procedure RenameUser(oldname, newname : string);
var
  au 			: cusertype;
  ur, uo, ss 	: string;
  n				: integer;
begin
	if oldname = '*' then
		oldname := myrec.alias;

	ur := stripcol(ups(newname));
	uo := stripcol(ups(oldname));

	if pos('"', newname) > 0 then
	begin
		slwriteln('\WH * The new name must not have a quote mark in it.');
		exit;
	end;

	if ur = '[OPEN]' then
	begin
		slwriteln('\WH * Hahaha!  Nice try, but not likely :-)');
		exit;
	end;

	if length(ur) > 20 then
	begin
		slwriteln('\WH * Length of new alias without colours must be less than 20 characters.');
		exit;
	end;

	if length(newname) > 50 then
	begin
		slwriteln('\WH * Length of new alias must be less than 50 characters.');
		exit;
	end;

	if ur <> uo then
	begin
		OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRead+DenyNone);
		while not eof(sf.f) do
		begin
			blockread(sf.f, au, sizeof(au));
			ss := stripcol(ups(au.alias));
			if ss = ur then
			begin
				slwriteln('\WH * A user already exists with that replacement name.');
				CloseSharedFile;
				exit;
			end
		end;
		CloseSharedFile;
	end;

	if GetCUserRec(oldname, au) = false then
		exit;

	CloseSharedFile;

	if (au.norename) and (GetAccLvl < cfg.RenameOverrideLvl) then
	begin
		slwriteln('\WH * This user is not renameable.');
		exit;
	end;

	ss := au.alias;
	n := GetUserNode(ss, false);

	OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRW+DenyWrite);
	while not eof(sf.f) do
	begin
		blockread(sf.f, au, sizeof(au));

		if au.alias = ss then
		begin
			au.alias := newname;
			au.abbrname := MakeAbbrName(newname);

			seek(sf.f, filepos(sf.f)-sizeof(au));
			blockwrite(sf.f, au, sizeof(au));
			CloseSharedFile;

			slwriteln('\WH * User '+cfg.defusrcol+ss+'\WH has been renamed as '+cfg.defusrcol+newname+'\WH.');

			if n > 0 then
			begin
				SendSysMsg('User '+cfg.defusrcol+ss+'\WH has been renamed as '+cfg.defusrcol+newname+'\WH.');
				SendOrdMsg('RESCAN', n);
			end;

			exit;
		end;
	end;

	CloseSharedFile;
	slwriteln('\LR * Something bad happened in RenameUser.');
end;

{
procedure SendFileZmodem(s : string);
var
	n : integer;
begin
	slwriteln('\WH * ZModem Download of file '+s+'.');

	xclrscr;
	xwriteln('User '+myuser.name+' downloading file '+s);
	SwapVectors;
	Exec('S:\PROTOCOL\ZSX\ZSX.EXE', 'port '+strs(cf.comport)+' line '+strs(cf.baudrate)+' D sz '+s);
	n := DosError;
	SwapVectors;

	xclrscr;
	ForceStatus;

	if n > 0 then
	begin
		slwriteln('\WH * DOSError '+strs(n)+' occurred.  Please inform \CYMogest\WH.');
		exit;
	end;
end;
}


procedure SetAlarm(t : string);
var
	n, a, c	: integer;
	now		: timetype;

	h, m	: integer;

  function psa(n : longint) : string;
  begin
	if n = 1 then
		psa := '''s'
	else
		psa := 's''';
  end;


begin
	dostime(now);
	n := timediff(alarm, now);

	if t = '' then
	begin
		if not alarmset then
			slwriteln('\WH * There is no scheduled alarm set.')
		else
		begin
			slwriteln('\WH * You have scheduled an alarm for \LG'+
				strs2(alarm.hour)+':'+strs2(alarm.minute)+
				'\WH which is in \LG'+strs(n)+'\WH minute'+psa(n)+' time.');
		end;

		exit;
	end;

	if t = 'cancel' then
	begin
		if not alarmset then
			slwriteln('\WH * There is no alarm set to cancel.')
		else
		begin
			slwriteln('\WH * Alarm cancelled.');
			alarmset := false;
		end;
		exit;
	end;


	if alarmset then
	begin
		slwriteln('\WH * An alarm has already been set.  Type \lc/alarm cancel\wh to cancel it.');
		exit;
	end;

	n := pos(':', t);
	if n > 0 then
	begin
		val(copy(t, 1, n-1), h, c);
		if c > 0 then
		begin
			slwriteln('\WH * Invalid date format.  Use \lc/alarm [mins]\wh or \lc/alarm [hh:mm]\wh.');
			exit;
		end;
		val(copy(t, n+1, 255), m, c);
		if (c > 0) or (h < 0) or (h > 23) or (m < 0) or (m > 59) then
		begin
			slwriteln('\WH * Invalid date format.  Use \lc/alarm [mins]\wh or \lc/alarm [hh:mm]\wh.');
			exit;
		end;

		alarm.hour := h;
		alarm.minute := m;
	end
	else
	begin
		val(t, a, c);
		if a = 0 then
		begin
			slwriteln('\WH * You can''t set an alarm for 0 minutes!');
			exit;
		end;

		if ((a > timelimit) and (watchtime)) or (a > 1439) then
		begin
			slwriteln('\WH * You can''t set an alarm for a period longer than your on-line time!');
			exit;
		end;

		dostime(alarm);
		inc(alarm.hour, a div 60);
		inc(alarm.minute, a mod 60);

		while alarm.minute > 59 do
		begin
			dec(alarm.minute, 60);
			inc(alarm.hour);
		end;

		while alarm.hour > 23 do
			dec(alarm.hour, 24);
	end;

	slwriteln('\WH * An alarm has been set for \LG'+strs2(alarm.hour)+':'+
		strs2(alarm.minute)+'\WH.');

	alarmset := true;
end;



procedure AdjMP(user, smp : string);
var
	cu 		: cusertype;
	n, c  	: integer;
	node	: integer;
begin
	if GetCUserRec(user, cu) = false then
		exit;

	val(smp, n, c);

	if n <> 0 then
	begin
		inc(cu.points, n);
		blockwrite(sf.f, cu, sizeof(cu));
	end;

	CloseSharedFile;

	node := GetUserNode(cu.alias, true);
	if node > 0 then
	begin
		SendOrder(cu.alias, 'RESCAN', false);

		if n > 0 then
			SendThisMsgP('\WH * User '+cfg.defusrcol+myrec.alias+'\wh has given you \LG'+strs(n)+'\WH MogPoint'+ps(n)+'!'#13#10,
				1, node);

		if n < 0 then
			SendThisMsgP('\WH * User '+cfg.defusrcol+myrec.alias+'\WH has taken \LG'+strs(-n)+'\WH MogPoint'+ps(-n)+' from you!'#13#10,
				1, node);
	end;

	slwriteln('\WH * User '+cfg.defusrcol+cu.alias+'\WH now has \LG'+strs(cu.points)+'\WH MogPoint'+ps(cu.points)+'.');
end;


procedure AccOverride;
var
	u 	: usertype;
	up 	: longint;
	s	: string;
	try : integer;
	ret : word;

begin
	if AccOverrideLvl > 0 then
	begin
		AccOverrideLvl := 0;
		slwriteln('\WH * Override disabled.');
		exit;
	end;

	{usearch('ROGER NESBITT', u, up);}

    usearch(cf.sysopname, u, up);
	if up = 0 then
	begin
		slwriteln('\WH * Unable to perform access override.');
		exit;
	end;

	try := 1;

	xwrite(#13#10);

	while true do
	begin
		slwrite('\CYEnter override password: \LC');
		s := getlinep('', 25, true, false, false, 0, 0, ret, #0, false, true);
		stripspaces(s);

		if checkpasswd(u.passwd, s) = false then
		begin
			slwriteln(#13#10'\LGIncorrect password!'#10);
			inc(try);
		end
		else
			break;

		if try = 3 then
		begin
			LeaveChannel(false);
			LeaveConference(true);
			xhangup;
			halt;
		end;
	end;

	AccOverrideLvl := 255;

	forcestatus;
	exit;
end;


procedure SetAbbrName(user, abbr : string);
var
	cu : cusertype;
begin
	if GetCUserRec(user, cu) = false then
		exit;

	if abbr = '' then
	begin
		slwriteln('\WH * The abbreviation name for user '+cfg.defusrcol+cu.alias+' \WHis '+cfg.defmsgcol+cu.abbrname+'\WH.');
		CloseSharedFile;
		exit;
	end;

	cu.abbrname := copy(abbr, 1, 10);
	blockwrite(sf.f, cu, sizeof(cu));

	CloseSharedFile;
	SendOrder(cu.alias, 'RESCAN', false);

	slwriteln('\WH * The abbreviation name for user '+cfg.defusrcol+cu.alias+' \WHis now '+cfg.defmsgcol+cu.abbrname+'\WH.');
end;


var
  cut : cusertype;



procedure SetUserOption(user, opt, setto : string);
type
  pboolean = ^boolean;
  plongint = ^longint;
  pbyte    = ^byte;
  blistype = record
	n : string[20];
	p : pointer;
	t : byte;
  end;
const
  blist : array [1..16] of blistype = (
  ( n: 'BANNED'; 		p: @cut.banned;		t: 1 ),
  ( n: 'NOPAGEWARN';	p: @cut.nopagewarn; t: 1 ),
  ( n: 'UNUSED';		p: @cut.unused;		t: 1 ),
  ( n: 'NOTIGNORE';		p: @cut.notignore; 	t: 1 ),
  ( n: 'NOTIFYSEND';	p: @cut.notifysend; t: 1 ),
  ( n: 'NOTIFYPAGE';	p: @cut.notifypage; t: 1 ),
  ( n: 'UNUSED2';		p: @cut.unused2;	t: 1 ),
  ( n: 'USEWINDOW';		p: @cut.usewindow;	t: 1 ),
  ( n: 'IAMWEENIE';		p: @cut.iamweenie;	t: 1 ),
  ( n: 'WHISPERBEEP';	p: @cut.whisperbeep;t: 1 ),
  ( n: 'NORENAME';		p: @cut.norename;	t: 1 ),
  ( n: 'BANABBRSET';	p: @cut.banabbrset; t: 1 ),
  ( n: 'POINTS';  		p: @cut.points;     t: 2 ),
  ( n: 'ACCESSLVL';     p: @cut.accesslvl;  t: 3 ),
  ( n: 'WEENIETRY';     p: @cut.weenietry;  t: 3 ),
  ( n: '' ) );

  function pt(a : pointer; t : word) : string;
  var
   pb : pboolean;
   pl : plongint;
   pa : pbyte;
   s  : string;
   n  : word;
  begin
	case t of
	  1:
	  begin
		pb := a;
		if pb^ then
			pt := 'True'
		else
			pt := 'False';
	  end;

	  2:
	  begin
		pl := a;
		str(pl^, s);
		pt := s;
	  end;

	  3:
	  begin
		pa := a;
		str(pa^, s);
		pt := s;
	  end;

	end;
  end;


  function st(a : pointer; t : word; setto : string) : boolean;
  var
   pb : pboolean;
   pl : plongint;
   pa : pbyte;
   n  : word;
  begin
	case t of
	  1:
	  begin
		if (setto <> 'TRUE') and (setto <> 'FALSE') then
		begin
			slwriteln('\WH * Invalid set value.');
			st := false;
			exit;
		end;

		pb := a;
		pb^ := (setto = 'TRUE');
	  end;

	  2:
	  begin
		pl := a;
		val(setto, pl^, n);
	  end;

	  3:
	  begin
		pa := a;
		val(setto, pa^, n);
	  end;

	end;

	st := true;
  end;

var
	n : integer;
	bp : pboolean;

begin
	upstr(opt);
	upstr(setto);

	if user = '' then
	begin
		PutHeading('User Options', false);

		n := 1;
		while blist[n].n <> '' do
		begin
			xwriteln('  \WH'+blist[n].n);
			inc(n);
		end;

		PutTrailer(false);
		exit;
	end;

	if GetCUserRec(user, cut) = false then
		exit;

	if opt = '' then
	begin
		CloseSharedFile;

		slwriteln('\WH * Options for user '+cfg.defusrcol+cut.alias+'\WH:');
		n := 1;
		while blist[n].n <> '' do
		begin
			slwriteln('\WH    The \LG'+blist[n].n+sp(15-length(blist[n].n))+
				'\WH option is set to \LG'+pt(blist[n].p, blist[n].t)+'\WH.');
			inc(n);
		end;
		exit;
	end;

	n := 1;
	while blist[n].n <> '' do
	begin
		if blist[n].n = opt then
			break;
		inc(n);
	end;

	if blist[n].n = '' then
	begin
		CloseSharedFile;
		slwriteln('\WH * Option \LG'+opt+'\WH not found.');
		exit;
	end;

	if setto = '' then
	begin
		CloseSharedFile;
		slwriteln('\WH * Option \LG'+opt+'\WH for user '+cfg.defusrcol+cut.alias+
			'\WH is set to \LG'+pt(blist[n].p, blist[n].t)+'\WH.');
		exit;
	end;

	if st(blist[n].p, blist[n].t, setto) = false then
	begin
		CloseSharedFile;
		exit;
	end;

	blockwrite(sf.f, cut, sizeof(cut));
	CloseSharedFile;

	SendOrder(cut.alias, 'RESCAN', false);

	slwriteln('\WH * Option \LG'+opt+'\WH for user '+cfg.defusrcol+cut.alias+
		'\WH has been set to \LG'+pt(blist[n].p, blist[n].t)+'\WH.');
end;

procedure BootAlarm;
begin
	if bootset then
	begin
		slwriteln('\WH * You are already set to be booted at \LG'+
			strs2(boottime.hour)+':'+strs2(boottime.minute)+'\WH.');

		exit;
	end;

	dostime(boottime);
	bootset := true;

	inc(boottime.minute, 2);

	while boottime.minute > 59 do
	begin
		if boottime.hour = 23 then
		begin
			slwriteln('\WH * Err, try again in a minute :-)');
			exit;
		end;

		inc(boottime.hour);
		dec(boottime.minute, 60);
	end;

	slwriteln('\WH * You will be booted off this BBS at \LG'+strs2(boottime.hour)+':'+strs2(boottime.minute)+'\WH.');
	SendThisMsg('\WH * User '+cfg.defusrcol+myrec.alias+' \WHhas set a personal /boot-alarm for \LG'+
		strs2(boottime.hour)+':'+strs2(boottime.minute)+'\WH.'#13#10, 1);

	exit;
end;


procedure SetKey(key, str : string);
var
  s : string;
  k : byte;
  e : boolean;

 function transkey : boolean;
 var
	nn, n : integer;
 begin
	transkey := false;

	if (length(key) > 1) and (key[1] = 'F') then
	begin
		s := copy(key, 2, 255);
		val(s, n, nn);
		if not (n in [1..10]) then
		begin
			slwriteln('\WH * Function keys must be from F1 to F10.');
			exit;
		end;

		k := 58 + n;
		e := true;

		transkey := true;
	end;
 end;


var
  dml 	: dmacrolist;
  m		: ^macrolist;
  n		: longint;

begin
	upstr(key);

	if not transkey then
		exit;

	OpenSharedFile(cfg.channeldir+'MOGTALK.MAC', IRW+DenyAll);
	if filesize(sf.f) = 0 then
	begin
		fillchar(dml, sizeof(dml), 0);
		blockwrite(sf.f, dml, sizeof(dml));
	end;

	if myuser.macros = 0 then
	begin
		n := filesize(sf.f);
		myuser.macros := n;
	end
	else
	begin
		n := myuser.macros;
		while true do
		begin
			seek(sf.f, n);
			blockread(sf.f, dml, sizeof(dml));

			if (dml.key = k) and (dml.ext = e) then
			begin
				dml.action := Replace;
				dml.str := str;
				seek(sf.f, n);
				blockwrite(sf.f, dml, sizeof(dml));
				CloseSharedFile;

				m := pointer(mymacro);
				while m^.next <> nil do
				begin
					if (m^.key = k) and (m^.ext = e) then
					begin
						m^.action := Replace;
						m^.str := str;
						exit
					end;

					m := m^.next;
				end;

				exit;
			end;

			if dml.next = 0 then
				break;

			n := dml.next;
		end;

		seek(sf.f, n);
		n := filesize(sf.f);
		dml.next := n;
		blockwrite(sf.f, dml, sizeof(dml));
	end;

	seek(sf.f, n);
	fillchar(dml, sizeof(dml), 0);
	dml.key := k;
	dml.ext := e;
	dml.action := Replace;
	dml.str := str;
	blockwrite(sf.f, dml, sizeof(dml));
	CloseSharedFile;

	WriteMyUser;

	if mymacro = nil then
	begin
		getmem(mymacro, sizeof(macrolist));
		m := pointer(mymacro);
	end
	else
	begin
		m := pointer(mymacro);
		while m^.next <> nil do
			m := m^.next;

		getmem(m^.next, sizeof(macrolist));
		m := m^.next;
	end;

	fillchar(m^, sizeof(macrolist), 0);
	m^.key := dml.key;
	m^.ext := dml.ext;
	m^.action := dml.action;
	m^.str := dml.str;
end;

procedure ListKey;
var
  m 	: ^macrolist;
  s		: string;

  function KeyName(k : byte; e : boolean) : string;
  begin
	KeyName := '';
	if e then
	begin
		case k of
		  59..68:
			KeyName := 'F'+strs(k-58);
		end;
	end;
  end;

begin
	slwriteln('\WH * You have the following macros set:');
	m := pointer(mymacro);
	while m <> nil do
	begin
		s := KeyName(m^.key, m^.ext);
		s := s + sp(15-length(s));
		slwrite('   \LG'+s+'\LC');
		xwriteln(m^.str);

		m := m^.next;
	end;
end;



function NameExpansion(var s: string; var x : word; cols : boolean) : boolean;
var
	t : string;
	l, n : integer;
begin
	t := '';
	n := x - 1;

	while (n > 0) and (s[n] in ['a'..'z','A'..'Z']) do
	begin
		t := s[n] + t;
		dec(n);
	end;

	l := length(t);
	t := GetUserAlias(t);
	if t = '' then
	begin
		if myuser.tabbeep then xwrite(#7);
		NameExpansion := false;
		exit;
	end;
	t := '\&S' + cfg.defusrcol + t + '\&L';

	if not cols then t := stripcol(t);

	delete(s, x-l, l);
	insert(t, s, x-l);

	x := x - l + length(t);

	NameExpansion := true;
end;

procedure TestColour;
var
  lp : integer;
  s  : string;
begin
	for lp := 0 to 255 do
	begin
		s := strs(lp);
		while length(s) < 3 do
			s := '0' + s;

		slwrite('\'+s+s+' ');
	end;

	slwriteln('');
end;


function MakeQuiet(s : string) : string;
const
	loudchar : string[10] = '!*';
	loudword : array [1..14] of string[10] =
		( 'bang', 'shout', 'yell', 'scream', 'argh', 'haha', 'hehe',
		  'hoho', 'hha', 'hhe', 'hho', 'wooho', 'wahoo', 'waahoo' );

	loudwords = 14;

var
	n, lp	: integer;
	t       : string;
	lastsp  : boolean;
	change	: boolean;

begin
	lastsp := true;

	s := stripcol(s);

	for lp := 1 to length(s) do
	begin
		if s[lp] in ['A'..'Z'] then
		begin
			if (s[lp] <> 'I') or not lastsp or not (s[lp+1] in [' ','.',',','''',';',':']) then
				s[lp] := chr(ord(s[lp])+32);
		end;

		lastsp := s[lp] = ' ';
	end;

	for lp := 1 to length(loudchar) do
	begin
		while pos(loudchar[lp], s) > 0 do
			delete(s, pos(loudchar[lp], s), 1);
	end;

	t := s;


	repeat

	change := false;

	for lp := 1 to loudwords do
	begin
		while pos(loudword[lp], t) > 0 do
		begin
			change := true;
			delete(t, pos(loudword[lp], t), length(loudword[lp]));
		end;
	end;

	lp := 1;
	while lp <= length(t) do
	begin
		if (t[lp] = '<') and (pos('>', copy(t, lp, 255)) > 0) then
		begin
			n := pos('>', copy(t, lp, 255));
			delete(t, lp, n);
			change := true;
		end;

		if (lp >= 3) and (t[lp] = t[lp-1]) and (t[lp] = t[lp-2]) then
		begin
			change := true;

			n := lp-2;
			while (lp < length(t)) and (t[lp] = t[lp-1]) do
				inc(lp);

			if t[lp] = t[lp-1] then
			begin
				delete(t, n, lp-n);
				dec(lp, lp-n+1);
			end
			else
			begin
				delete(t, n, lp-n-1);
				dec(lp, lp-n);
			end;
		end;

		if t[lp] > #127 then
		begin
			delete(t, lp, 1);
			dec(lp);
			change := true;
		end;

		inc(lp);
	end;

	until change = false;


	MakeQuiet := t;
end;


function MakeB1ff(s : string) : string;

const b1ffism : array ['A'..'Z'] of string[5] =
	( '4', '8', '(', '|)', '3', 'F', '6', '|-|', '1', 'J', '|<',
	  '|_', '|\/|', '|\|', '0', 'P', 'Q', 'R', '5', 'T', '|_|',
	  '\/', '\/\/', '><', 'Y', 'Z' );
var
	lp	: integer;
	ch  : char;

begin
	upstr(s);

	for lp := 1 to length(s) do
	begin
		if (s[lp] in ['A'..'Z']) and (random(10) < 4) then
		begin
			ch := s[lp];
			delete(s, lp, 1);
			insert(b1ffism[ch], s, lp);
		end;
	end;

	MakeB1ff := s;
end;



function CheckSpam : boolean;
var
	lp, m, s, h  : word;
	c, n, p 	: longint;

  procedure IncPtr;
  begin
	inc(lineptr);
	if lineptr > MaxSpamLvl then
	begin
		linefull := true;
		lineptr := 1;
	end;
  end;

begin
	CheckSpam := false;

	gettime(h, m, s, lp);

	c := s + m * 60 + h * 60 * 60;

	linetime[lineptr] := c;

	if (mychan.spamlvl = 0) or ( (linefull = false) and (lineptr < mychan.spamlvl) ) then
	begin
		IncPtr;
		exit;
	end;

	n := lineptr + MaxSpamLvl - mychan.spamlvl;

	if n > MaxSpamLvl then
		dec(n, MaxSpamLvl);

	p := c - 10;
	if p < 0 then
	begin
		inc(p, 86400);
		CheckSpam := (linetime[n] <= c) or (linetime[n] > p);
	end
	else
		CheckSpam := (linetime[n] > p) and (linetime[n] <= c);

	IncPtr;
end;


procedure LoadBadWord(wrd : string; repl : string);
var
	bw : ^badwordlist;
begin
	bw := @BadWord;

	upstr(wrd);

	while (bw^.next <> Nil) do
		bw := bw^.next;

	getmem(bw^.next, sizeof(badwordlist));
	bw := bw^.next;

	fillchar(bw^, sizeof(badwordlist), 0);

	getmem(bw^.wrd, length(wrd)+2);
	bw^.wrd^ := wrd;

	if repl <> '' then
	begin
		getmem(bw^.repl, length(repl)+2);
		bw^.repl^ := repl;
	end;
end;

procedure LoadBadWords(fname : string);
var
	s	: string;
	lp	: word;
	ch  : char;
begin
	OpenSharedFile(fname, IRead+DenyNone);

	while not eof(sf.f) do
	begin
		s := '';
		repeat
			blockread(sf.f, ch, 1, lp);
			if not (ch in [#13,#10]) then
				s := s + ch;
		until (ch = #13) or (lp <> 1);

		LoadBadWord(aword(s, 1, false), aword(s, 2, true));
	end;

	CloseSharedFile;
end;


var
	lh, lm, ls, lhu : word;
	KickTele,
	RejoinConf,
	WriteMy,
	IsWeenie,
	KickChan		: boolean;

	PullTo,
	ChessUpd,
	OthUpd			: word;

	SendTimeLeft,
	sendfile,
	sbadword,
	sbadlist
					: string[70];


procedure PerformOrder(mh : msghdr; s : string);
var
	n, nn 	: integer;
	w1 		: string;
begin
	w1 := aword(s, 1, false);

	if s = 'KICK' then
	begin
		if GetAccLvl >= cfg.CantKickLvl then
		begin
			enteruserline;
			slwrite('\WH * User '+cfg.defusrcol+mh.msgfrom+'\WH has tried to kick you.'#13#10);
			exit;
		end;

		if myrec.channel = 1 then
		begin
			enteruserline;
			slwrite('\WH * You have been kicked out of teleconference by '+cfg.defusrcol+mh.msgfrom+'\WH.'#13#10);
			KickTele := true;
		end
		else
		begin
			enteruserline;
			slwrite('\WH * You have been kicked out of this channel by '+cfg.defusrcol+mh.msgfrom+'\WH.'#13#10);
			slwrite('   You have been returned to channel 1.'#13#10);
			KickChan := true;
		end;
	end;

	if s = 'BOOT' then
	begin
		if GetAccLvl >= cfg.CantBootLvl then
		begin
			slwrite('\WH * User '+cfg.defusrcol+mh.msgfrom+'\WH has tried to boot you.'#13#10);
			exit;
		end;

		slwrite('\WH * You have been kicked out of teleconference by '+cfg.defusrcol+mh.msgfrom+'\WH.'#13#10);
		KickTele := true;
	end;

	if s = 'RESCAN' then
	begin
		slwrite('\WH * A conference operator has forced a rescan of your account.'#13#10);
		ReJoinConf := true;
	end;

	if s = 'SRESCAN' then
		ReJoinConf := true;

	if s = 'CHANOP' then
	begin
		myrec.ischanop := not myrec.ischanop;
		WriteMy := true;
	end;

	if s = 'MODERATOR' then
	begin
		myrec.ismoderator := not myrec.ismoderator;
		WriteMy := true;
	end;

	if s = 'SILENCE' then
	begin
		myrec.silenced := not myrec.silenced;
		WriteMy := true;
	end;

	if w1 = 'ATIME' then
	begin
		val(aword(s, 2, false), n, nn);
		if n <> 0 then
		begin
			inc(timelimit, n);
			slwrite('\WH * User '+cfg.defusrcol+mh.msgfrom+'\WH has ');
			if n < 0 then
				slwrite('taken away '+strs(-n))
			else
				slwrite('given you '+strs(n)+' more');
			slwriteln(' minute'+ps(abs(n))+' of on-line time.');
		end;

		ForceStatus;
	end;

	if s = 'QTIME' then
		SendTimeLeft := mh.msgfrom;

	if (s = 'WEENIE') and (GetAccLvl < 255) then
		IsWeenie := true;

	if s = 'HANGUP' then
	begin
		KickTele := true;
		xHangup;
	end;

	if aword(s, 1, false) = 'PULL' then
	begin
		val(aword(s, 2, false), n, nn);
		if n <> 0 then
		begin
			slwrite('\WH * User '+cfg.defusrcol+mh.msgfrom+'\WH is pulling you to channel \LG'+strs(n)+'\WH.'#13#10);
			PullTo := n;
		end;
	end;

	if s = 'CLRSCR' then xclrscr;

	if s = 'BEEP' then xwrite(#7);

	if w1 = 'BADWORD' then
		sbadword := aword(s, 2, true);

	if w1 = 'BADLIST' then
		sbadlist := aword(s, 2, true);

	if w1 = 'CHESS-UPD' then
		val(aword(s, 2, false), chessupd, n);

	if w1 = 'OTH-UPD' then
		val(aword(s, 2, false), othupd, n);

	if w1 = 'ZMODEM' then
		sendfile := aword(s, 2, false);

	if w1 = 'RESET' then
		bootset := false;

	if w1 = 'DEFMSGCOL' then
		cfg.defmsgcol := aword(s, 2, false);
end;


function idle(x : word) : boolean;
var
	s 		: string;
	n 		: integer;
	mh		: msghdr;
	rescan	: boolean;
	ban		: boolean;
	lp		: integer;
	h, m, se, hu : word;
	faraway	: boolean;
	got		: word;
	now		: timetype;
begin
	idle := false;
	rescan := false;
	faraway := false;

	kicktele := false;
	kickchan := false;
	rejoinconf := false;
	writemy := false;
	isweenie := false;

	pullto := 0;
	chessupd := 0;
	othupd := 0;
	sendtimeleft := '';
	sendfile := '';
	sbadword := '';
	sbadlist := '';

	gettime(h, m, se, hu);
	if (h = lh) and (m = lm) and (se = ls) then
		exit;

	lh := h;
	lm := m;
	ls := se;
	lhu := hu;

	status;

	dostime(now);
	if alarmset and (timediff(alarm, now) = 0) then
	begin
		SendThisMsgP(#13#10'\WH * This is your \LR'+blinky+'alarm\WH.'#7#7#7#7#7#7#7#7#13#10#10, 1, myrec.node);
		alarmset := false;
	end;

	if bootset and (timediff(boottime, now) = 0) then
	begin
		enteruserline;
		slwriteln('\WH * This is your \lr/boot-alarm\wh.  See you later!');
		LeaveChannel(false);
		LeaveConference(true);
		waitout;
		hangup;
		halt;
	end;

	OpenSharedFile(cfg.channeldir+strs(myrec.node)+'.ICM', IRW+DenyNone);
	if filesize(sf.f) > 0 then
	begin
		while not eof(sf.f) do
		begin
			{$i-} blockread(sf.f, mh, sizeof(msghdr)); {$I+}
			if ioresult <> 0 then
				break;
			{$i-} blockread(sf.f, s[1], mh.msglen); {$I+}
			if ioresult <> 0 then
				break;

			s[0] := chr(mh.msglen);

			case mh.msgtype of
			 1..4:
			 begin
				ban := false;
				if mh.noignore = false then
				begin
					for lp := 1 to 30 do
						if ignore[lp].name = mh.msgufrom then
							ban := true;
				end;

				if ban = false then
				begin
					if faraway = false then
					begin
						if s <> '' then
						begin
							faraway := true;
							killuserline(x);
						end;
					end;

					if mh.msgtype = 1 then
						indent := cfg.NoticeIndent
					else
						indent := cfg.WritingIndent;
					slwrite(s);
					indent := 0;
				end;

				if (mh.msgtype = 3) and (myuser.whisperbeep) then
					xwrite(#7);

				if mh.msgtype = 1 then rescan := true;
			 end;
			 5:
			 begin
				if faraway = false then
				begin
					faraway := true;
					killuserline(x);
				end;
				PerformOrder(mh, s);
			 end;
			 0:	;
			end;

			if faraway = true then
				idle := true;
		end;
		seek(sf.f, 0);
		truncate(sf.f);
	end;
	CloseSharedFile;

	if IsWeenie then
	begin
		myuser.iamweenie := true;
		WriteMyUser;

		for n := 1 to (scrbx*24) div 14 do
		begin
			xtextcolor(random(15)+1);
			xwrite('weenie ');
			xtextcolor(random(15)+1);
			xwrite('weenie '#7);
			if not xCarrierDetect then
			begin
				isweenie := false;
				n := (scrbx*24) div 14;
			end;
		end;

		myuser.iamweenie := not isweenie;
		WriteMyUser;

		KickTele := true;
		xHangup;
	end;

	if KickChan then
	begin
		LeaveChannel(true);
		JoinChannel(1, true);
	end;

	if KickTele then
	begin
		LeaveChannel(false);
		LeaveConference(true);
		halt;
	end;

	if RejoinConf then
	begin
		OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRead+DenyNone);
		seek(sf.f, myurec);
		blockread(sf.f, myuser, sizeof(myuser));
		CloseSharedFile;

		seek(usf.f, myrec.node*sizeof(sharedrec));
		blockread(usf.f, myrec, sizeof(myrec));

		myrec.alias := myuser.alias;
		myrec.abbrname := myuser.abbrname;

		WriteMyInfo;
		SendThisMsg('', 1);

		ForceStatus;
	end;

	if WriteMy then
	begin
		WriteMyInfo;
		WriteMyUser;
	end;

	if PullTo > 0 then
	begin
		LeaveChannel(true);
		JoinChannel(PullTo, true);
	end;

	if SendTimeLeft <> '' then
	begin
		if watchtime then
			SendThisMsgP('\WH * User '+cfg.defusrcol+myuser.alias+'\WH has \LG'+strs(timelimit-timeon)+'\WH minute'+
				ps(timelimit-timeon)+' left.'#13#10, 1, GetUserNode(SendTimeLeft, false) )
		else
			SendThisMsgP('\WH * User '+cfg.defusrcol+myuser.alias+'\WH has no time limit.'#13#10,
					1, GetUserNode(SendTimeLeft, false) )

	end;

	if ChessUpd > 0 then
		ChessUpdScr(ChessUpd);

	if OthUpd > 0 then
		OthUpdScr(OthUpd);

{	if SendFile <> '' then
		SendFileZModem(Sendfile);}

	if sBadList <> '' then
		LoadBadWords(sBadList);

	if sBadWord <> '' then
		LoadBadWord(aword(sBadWord, 1, false), aword(sBadWord, 2, true));

	if rescan then
		ReadChannelInfo;
end;

procedure initscr;
begin
	if myrec.afk then
		slwrite('\LR]\LC')
	else if heldmsg <> '' then
		slwrite('\CY'+blinky+']\LC')
	else if myrec.invisible then
		slwrite('\DG]\LC')
	else
		slwrite('\CY]\LC');
end;



procedure WriteHeader;
var
	s, ss, lafk : string;
	nprn : integer;
	n : integer;
	h, m, dum : word;
	ln : string;
	nafk : integer;

const head = cyan;

begin
	xwriteln('');
	PutTrailer(false);
	xtextcolor(head);
	slwrite('  You are on channel number \GR'+strs(myrec.channel)+'\CY');

	s := '';

	nprn := 0;
	nafk := 0;
	ln := '';

	for n := 1 to topnode do
	begin
		if (ccnodes[n] <> Nil) and (ccnodes[n]^.node <> myrec.node) and
		   (not ccnodes[n]^.invisible) then
		begin
			if ccnodes[n]^.afk then
			begin
				lafk := ccnodes[n]^.alias;
				inc(nafk);
			end
			else
			begin
				if nprn = 0 then
					s := s + ' with ';

				s := s + ln + '\CY';

				if nprn > 0 then
					s := s + ', ';

				inc(nprn);
				ln := '\WH' + stripcol(ccnodes[n]^.alias);
			end;
		end;
	end;

	if nprn > 0 then
	begin
		if nprn > 1 then
			s := s + 'and ';

		s := s + ln + '\CY';
	end
	else
		s := s + ' by yourself';

	slwriteln(s+'.');

	if nafk > 0 then
	begin
		if nafk = 1 then
			slwriteln('  User \WH'+stripcol(lafk)+'\CY is Away From Keyboard.')
		else
		begin
			s := 'Users ';

			for n := 1 to topnode do
			begin
				if ccnodes[n]^.afk = true then
				begin
					dec(nafk);

					s := s + '\WH'+stripcol(ccnodes[n]^.alias)+'\CY';
					if nafk > 1 then
						s := s + ', '
					else if nafk = 1 then
						s := s + ' and ';
				end;
			end;

			slwriteln(s+' are Away From Keyboard.');
		end;
	end;

	if mychan.name <> '' then
		slwrite('  The topic for this channel is "\GR'+mychan.name+'\CY".'#13#10);

	if (myrec.ischanop = true) or (GetAccLvl >= cfg.ChanOpLvl) then
		slwriteln('  You are an operator of this channel.');

	if mychan.nowhispers then
		slwriteln('  This channel does not allow paging or whispering.');

	if mychan.frozen then
		slwriteln('  This channel has been frozen and channel options may not be changed.');

	if mychan.moderated then
	begin
		xwrite('  This channel is moderated.  You are ');
		if (not myrec.ismoderator) and (GetAccLvl < cfg.ChanOpLvl) then
			xwrite('NOT ');
		xwriteln('able to send public messages.');
	end;

	if mychan.quiet then
		xwriteln('  This channel is in quiet mode.');

	if mychan.b1ff then
		xwriteln('  This channel is in B1FF mode.');

	if mychan.spamlvl <> 0 then
		slwriteln('  Spam detection is set to \GR'+strs(mychan.spamlvl)+'\CY lines per ten seconds.');

	n := timelimit-timeon;
	slwrite('  Type \GR/?\CY for help.');

	if (watchtime = true) then
	begin
		slwrite('  You have \GR'+strs(n)+'\CY minute');
		if n <> 1 then slwrite('s');
		slwrite(' left.');
	end;

	gettime(h, m, dum, dum);
	slwriteln('  The current time is \GR'+strs2(h)+':'+strs2(m)+'\CY.');
	PutTrailer(false);
end;

function CheckMacro(ch : char; ext : boolean; var s : string; var x : word) : boolean;
var
	m : ^macrolist;

  procedure PerformMacro;
  begin
	insert(m^.str, s, x);
	inc(x, length(m^.str));
  end;

begin
	CheckMacro := false;

	m := pointer(mymacro);
	while m <> Nil do
	begin
		if (m^.key = ord(ch)) and (m^.ext = ext) then
		begin
			PerformMacro;
			CheckMacro := true;
			exit;
		end;

		m := m^.next;
	end;
end;


function GetString(var s : string; var x : word) : word;
var
	b, quit		: boolean;
	ch			: char;
	n			: word;
	starty		: word;
	sx, sy	 	: word;
	m_s, m_ss	: string;
	ext			: boolean;

label recycle, inschar;

begin
recycle:
	xwrite(s);
	if length(s) <> x-1 then
	begin
		n := (xwherey-1) * scrbx + (xwherex-1);

		dec(n, length(s)-x+1);

		xgotoxy(n mod scrbx + 1, n div scrbx + 1);
	end;

	quit := false;
	while quit = false do
	begin
		while (not xkeypressed) or TimeExpired do
		begin
			if TimeExpired then
			begin
				killuserline(x);

				if xCarrierDetect then
				begin
					slwrite('\WH * You are out of time for this call!'#13#10);
					SendSysMsg(cfg.defusrcol+myuser.alias+'\WH has run out of time!');
				end
				else
					SendSysMsg(cfg.defusrcol+myuser.alias+'\WH has dropped carrier!');

				GetString := 1;
				exit;
			end;

			if (watchtime) and (timelimit-timeon < WarnTime) and (timelimit-timeon > 0) then
			begin
				Warntime := timelimit-timeon;
				killuserline(x);
				slwrite('\WH * \LRWarning: \WHYou only have '+strs(warntime)+' minute'+ps(warntime)+' left on line.'#13#10);
				slwrite('   Please finish up your conversation and log out.'#13#10);

				initscr;
				goto recycle;
			end;


			if (cf.node <= MaxNode) and (MsgAvail) then
			begin
				killuserline(x);
				n := getmsg(m_s, m_ss);
				if m_s = 'LogMgr' then
					slwrite('\WH * Node \LG'+strs(n)+'\WH: '+copy(m_ss, 3, 1000)+#13#10)
				else if copy(m_s, 1, 25) = '* Received new mail from ' then
					slwriteln('\WH * You have received new private mail from \LG'+m_s+'\WH.')
				else
					slwrite('\WH * \LG'+m_s+'\WH is paging you from node '+strs(n)+': '+cfg.defmsgcol+m_ss+#13#10);

				initscr;
				goto recycle;
			end;

			if idle(x) = true then
			begin
				initscr;
				goto recycle;
			end;

			slice;
			slice;
		end;

		ch := xreadkey;
		if ch = #0 then
		begin
			ch := xreadkey;
			ext := true;
		end
		else
			ext := false;

		n := x;
		if CheckMacro(ch, ext, s, x) then
		begin
			killuserline(n);
			initscr;
			goto recycle;
		end;

		if ext then
		begin
			case ch of
			 #15:
				if GetAccLvl >= cfg.AllowTabLvl then
				begin
					sx := x;
					if NameExpansion(s, x, false) then
					begin
						killuserline(sx);
						initscr;
						goto recycle;
					end;
				end;

			 #75:
				if x > 1 then
				begin
					dec(x);
					if xwherex = 1 then
						xgotoxy(scrbx, xwherey-1)
					else
						xgotoxy(xwherex-1, xwherey);
				end;

			 #77:
				if x <= length(s) then
				begin
					inc(x);
					if xwherex = scrbx then
						xgotoxy(1, xwherey+1)
					else
						xgotoxy(xwherex+1, xwherey);
				end;

			 #71:
			 begin
				n := (xwherey-1) * scrbx + (xwherex-1);
				dec(n, x-1);
				xgotoxy(n mod scrbx + 1, n div scrbx + 1);
				x := 1;
			 end;

			 #79:
			 begin
				n := (xwherey-1) * scrbx + (xwherex-1);
				n := n - x + 1 + length(s);
				xgotoxy(n mod scrbx + 1, n div scrbx + 1);
				x := length(s)+1;
			 end;

			 #115:
			 begin
				n := x;
				if x > 1 then dec(x);
				while (s[x] = ' ') do dec(x);
				while (x > 1) and (s[x] <> ' ') do
					dec(x);
				if x > 1 then inc(x);
				n := (xwherey-1) * scrbx + (xwherex-1) + (x-n);
				xgotoxy(n mod scrbx + 1, n div scrbx + 1);
			 end;

			 #116:
			 begin
				n := x;
				if x < length(s) then inc(x);
				while (x <= length(s)) and (s[x] <> ' ') do
					inc(x);
				if x < length(s) then inc(x);
				n := (xwherey-1) * scrbx + (xwherex-1) + (x-n);
				xgotoxy(n mod scrbx + 1, n div scrbx + 1);
			 end;

			 #83:
			 begin
				if (x <= length(s)) then
				begin
					delete(s, x, 1);
					sx := xwherex; sy := xwherey;
					xwrite(copy(s, x, 1000)+' ');
					xgotoxy(sx, sy);
				end;
			 end;

			 #61,#72:
			 begin
				if s = '' then
				begin
					s := laststr;
					laststr := '';
					x := length(s) + 1;
					goto recycle;
				end;
			 end;
		 end;

		 continue;
		end;

		case ch of
		 #1:		{ ctrl - a }
		 begin
			killuserline(x);

			if s = '' then
			begin
				if heldmsg = '' then
				begin
					slwrite('\WH * You don''t have a held message to retrieve.'#13#10);
					initscr;
					goto recycle;
				end;

				s := heldmsg;
				x := heldpos;

				heldmsg := '';
			end
			else
			begin
				if heldmsg <> '' then
				begin
					slwrite('\WH * You already have a held message.'#13#10);
					initscr;
					goto recycle;
				end;

				heldmsg := s;
				heldpos := x;

				s := '';
				x := 1;

				slwrite('\WH * Message held.  Press CTRL-A to retrieve.'#13#10);
			end;

			initscr;
			goto recycle;
		 end;


		 #13:
		 begin
			GetString := 0;
			exit;
		 end;

		 #8:
		 begin
			if x > 1 then
			begin
				delete(s, x-1, 1);
				dec(x);
				if xwherex = 1 then
				begin
					n := xwherey - 1;
					xgotoxy(scrbx, n);
					xwrite(' ');
					xgotoxy(scrbx, n);
				end
				else
				begin
					if x > length(s) then
						xwrite(#8' '#8)
					else
					begin
						sx := xwherex; sy := xwherey;
						xwrite(#8+copy(s, x, 1000)+' ');

						if sx = 1 then
							xgotoxy(scrbx, sy-1)
						else
							xgotoxy(sx-1, sy);
					end;
				end;
			end;
		 end;

		 #9:
		 begin
			if GetAccLvl >= cfg.AllowTabLvl then
			begin
				sx := x;
				if NameExpansion(s, x, true) then
				begin
					killuserline(sx);
					initscr;
					goto recycle;
				end;
			end;
		 end;

		 #3,#27:
		 begin
			killuserline(x);
			s := '';
			x := 1;
			initscr;
		 end;

		 #127,#2:
		 begin
		   ch := #0;
		   while (x > 1) and (ch <> #32) do
		   begin
			 ch := s[x-1];
			 delete(s, x-1, 1);
			 dec(x);
			 if xwherex = 1 then
			 begin
				n := xwherey - 1;
				xgotoxy(scrbx, n);
				xwrite(' ');
				xgotoxy(scrbx, n);
			 end
			 else
			 begin
				if x > length(s) then
					xwrite(#8' '#8)
				else
					begin
						sx := xwherex; sy := xwherey;
						xwrite(#8+copy(s, x, 1000)+' ');

						if sx = 1 then
							xgotoxy(scrbx, sy-1)
						else
							xgotoxy(sx-1, sy);
					end;
			 end;
		   end;
		 end;

		 #32..#126,#128..#254:
		 begin
inschar:
			if x < 220 then
			begin
				if x > length(s) then
				begin
					s := s + ch;
					xwrite(ch);
				end
				else
				begin
					m_ss := ch;
					insert(m_ss, s, x);

					sx := xwherex; sy := xwherey;
					xwrite(copy(s, x, 1000));

					n := (sy-1) * scrbx + (sx-1);
					inc(n, length(s)-x+1);

					if n >= scrbx*ScreenLength then
						dec(sy);

					if sx = scrbx then
						xgotoxy(1, sy+1)
					else
						xgotoxy(sx+1, sy);
				end;

				inc(x);
			end;
		 end;
		end;
	end;
end;


procedure SuperRah;
var
	cred, guess, rah, d     : longint;
	n, r, today				: word;
	s 						: string;
begin
	getdate(n, n, today, n);
	if myuser.superrahtry = today then
	begin
		slwrite('\WH * Sorry, you''ve already Super Rah''ed today!'#13#10);
		exit;
	end;

	myuser.superrahtry := today;
	WriteMyUser;

	slwriteln(#10'\LRYou are about to play SuperRah!');
	slwriteln('\WHThe authories that run SuperRah are open to bribery, however.  How many');
	slwrite('of your \LG'+strs(myuser.points)+'\WH MogPoints would you like to donate? \LG');

	s := getlinep('0', 6, false, false, false, 0, 999999, r, #0, false, false);
	cred := vals(s);

	if cred > myuser.points then
	begin
		slwriteln(#10'\WHThe authories are not impressed that you tried to donate more than you');
		slwriteln('have!  They have decided to weenie you to teach you a lesson :-)');
		SendOrdMsg('WEENIE', myrec.node);
		exit;
	end;

	dec(myuser.points, cred);
	WriteMyUser;

	guess := 0;
	while not (guess in [1..100]) do
	begin
		slwrite(#10'\WHGuess your number between 1 and 100: \LG');
		s := getlinep('', 3, false, false, false, 1, 100, r, #0, false, false);
		guess := vals(s);

		if not (guess in [1..100]) then
			slwriteln('That number isn''t between 1 and 100.  Try again!');
	end;

	rah := random(100) + 1;
	cred := cred div 2;

	d := abs(rah - guess);

	if cred > d then
	begin
		rah := guess;
	end
	else if rah > guess then
		dec(rah, cred)
	else
		inc(rah, cred);

	d := abs(rah - guess);
	slwriteln('\WHThe judges have chosen the number \LG'+strs(rah)+'\WH!');

	d := (100 - (d * 4)) div 8;

	if d > 0 then
		d := d * ((abs(guess-50) div 12) + 1)
	else
		d := d * 2;

	if d = 0 then
		slwriteln('You don''t win or lose anything!')
	else if d < 0 then
		slwriteln('You have lost \LG'+strs(-d)+'\WH minute'+ps(-d)+' of on-line time!')
	else
		slwriteln('You have won \LG'+strs(d)+'\WH minute'+ps(d)+' of on-line time!');

	if -d > timelimit - timeon then
	begin
		timelimit := 1;

		slwriteln(#10'Oh dear, you seem to have run out of time for the judges!');
		slwriteln('You''ll have to be weenied for that! :-)');
		SendOrdMsg('WEENIE', myrec.node);
		exit;
	end;

	inc(timelimit, d);
end;



procedure toggle(s : string; var a : boolean);
begin
	a := not a;
	slwrite('\WH * User option '+cfg.defusrcol+s+'\WH has now been toggled ');
	if a then
		slwrite('\LGON\WH.'#13#10)
	else
		slwrite('\LGOFF\WH.'#13#10);

	WriteMyUser;
end;

function CheckBadWords(var tt : string) : boolean;
var
	on, n    : longint;
	s, t : string;
	np : word;

	bw 	: ^badwordlist;
begin
	CheckBadWords := false;

	t := stripcol(ups(tt));

	bw := BadWord.next;
	if bw = nil then
		exit;

	repeat
		s := bw^.wrd^;
		n := pos(s, t);
		if n > 0 then
		begin
			if ((n = 1) or not (t[n-1] in ['A'..'Z','a'..'z'])) and
			   ((n = length(t)-length(s)+1) or not (t[n+length(s)] in ['A'..'Z','a'..'z'])) then
			begin
				if bw^.repl = Nil then
				begin
					CheckBadWords := true;
					exit;
				end;

				tt := stripcol(tt);

				delete(tt, n, length(s));
				insert(bw^.repl^, tt, n);

				delete(t, n, length(s));
				insert(sp(length(bw^.repl^)), t, n);
			end
			else
				bw := bw^.next;
		end
		else
			bw := bw^.next;

	until bw^.next = Nil;

end;


procedure RealTimeChat(direct : boolean; chan : word; endstr : string);
var
	n, nn 	: longint;
	s 		: string;
	r 		: word;
	ch 		: char;
	cappos 	: integer;
	isf 	: sfhtype;
	line	: string;
begin
	isf.isopen := false;
	OpenSharedFileF(isf, cfg.realtimedir+strs(chan)+'.ICF', IRW+DenyNone);

	n := filesize(isf.f);
	seek(isf.f, n);

	line := '';
	cappos := 1;

	while true do
	begin
		while not xkeypressed do
		begin
			if not xCarrierDetect then
			begin
				CloseSharedFileF(isf);
				exit;
			end;

			Slice;
			Slice;

			if not direct then
				if idle(xwherex-1) = true then
					xwrite(line);

			nn := filesize(isf.f);
			if nn > n then
			begin
				blockread(isf.f, s[1], 255, r);
				s[0] := chr(r);
				xwrite(s);
				n := nn;
			end;
		end;

		ch := xreadkey;

		if (ch = endstr[cappos]) and (endstr <> '') then
		begin
			inc(cappos);
			if cappos = length(endstr)+1 then
			begin
				CloseSharedFileF(isf);
				exit;
			end;
		end
		else
		begin
			if (cappos <> 2) or (endstr[1] <> ch) then
				cappos := 1;
		end;

		seek(isf.f, filesize(isf.f));
		if direct then
			blockwrite(isf.f, ch, 1)
		else
		begin
			case ch of
			 #0:	xreadkey;
			 #13:
			 begin
				s := #13#10;
				blockwrite(isf.f, s[1], 2);
			 end;
			 #8:
			 begin
				s := #8' '#8;
				blockwrite(isf.f, s[1], 3);
			 end;
			 #1..#31: ;
			 #255:    ;
			 else
				blockwrite(isf.f, ch, 1);
			end;
			seek(isf.f, n);
		end;
	end;
end;


function cmdparse(var s : string; var x : word) : boolean;
var
	n, nn 	: word;
	ss		: string;
	w1		: string;
	sr		: sharedrec;
	fptr	: text;
begin
	cmdparse := false;

	w1 := strlwr(aword(s, 1, false));

	if (w1 = '/w') or (w1 = '/who') then
	begin
		enteruserline;
		PrintUserList;
		exit;
	end;

	if w1 = '/#' then
	begin
		enteruserline;
		slwriteln('\WH * Use \LC/w\WH instead.');
		exit;
	end;

	if w1 = '/$' then
	begin
		enteruserline;
		slwriteln('\WH * You have \LG'+strs(user.credits)+'\WH credit'+ps(user.credits)+' remaining.');
		slwriteln('\WH * You have \LG'+strs(myuser.points)+'\WH MogPoint'+ps(myuser.points)+'!');
		exit;
	end;

	if (w1 = '/?') or (w1 = '/help') then
	begin
		enteruserline;
		PutHeading('General Commands', false);
		slwriteln('  \WH/w                     \GYDisplays users currently on-line.');
		slwriteln('  \WH/my-help               \GYDisplays your personal commands.');
		slwriteln('  \WH/ch-help               \GYDisplays channel operator help.');

		if GetAccLvl >= cfg.ViewOpCmds then
			slwriteln('  \WH/co-help               \GYDisplays conference operator help.');

		slwriteln('  \WH/key-help              \GYDisplays help on key operations.');
		slwriteln('  \WH/op-help               \GYDisplays help on the various option settings.');
		slwriteln('  \WH/games                 \GYDisplays the list of available MogTalk games.');
		slwriteln('  \WH/abbr [word]           \GYLooks up the abbreviation dictionary for [word].');
		slwriteln('  \WH/recent                \GYDisplays this BBS''s recent callers.');
		slwriteln('  \WH/userlist {wildcard}   \GYDisplays users that have used teleconference.');
		slwriteln('  \WH/bye                   \GYLog off the BBS instantly.');
		slwriteln('  \WH/x                     \GYQuit teleconference.');

		PutHeading('External Modules', false);
		slwriteln('  \WH/loginmsg {new msg}    \GYDisplays and sets your login message.');
		PutTrailer(false);
		exit;
	end;

	if w1 = '/games' then
	begin
		enteruserline;
		PutHeading('MogTalk Games', false);
		slwriteln('  \WH/mind-help             \GYGet help on how to play MogestMind.');
		slwriteln('  \WH/chess-help            \GYGet help on how to play MogChess.');
		PutTrailer(false);
		exit;
	end;

	if w1 = '/my-help' then
	begin
		enteruserline;
		PutHeading('Personal Commands', false);
		slwriteln('  \WH/afk {reason}          \GYToggles your Away From Keyboard status.');
		slwriteln('  \WH/alarm {minutes}       \GYSets an alarm to ring in [minutes] minutes.');
		slwriteln('  \WH/boot-alarm            \GYSets alarm to hang up on you in 1 to 2 minutes.');
		slwriteln('  \WH/channel               \GYDisplays channels currently in use.');
		slwriteln('  \WH/channel [number]      \GYChanges your channel number to [number].');
		slwriteln('  \WH/clrscr                \GYClears your terminal''s screen.');
		slwriteln('  \WH/ignore [user]         \GYIgnore or listen to comments from user [user].');
		slwriteln('  \WH/ignorep [user]        \GYPermanently ignores user [user].');
		slwriteln('  \WH/lines [lines]         \GYView or set number of lines your terminal has.');
		slwriteln('  \WH/listed                \GYToggles whether your channel number is listed.');
		slwriteln('  \WH/me [message]          \GYAction; your alias [message].');
		slwriteln('  \WH/myabbr [abbr]         \GYSets your abbreviated name to [abbr].');
		slwriteln('  \WH/page [node] [message] \GYPages node [node] with the message [message].');
		slwriteln('  \WH/whisper [user] [x]    \GYWhisper [x] to user [user].');
		slwriteln('  \WH;[user] [x]            \GYWhisper [x] to user [user].');
		PutTrailer(false);
		exit;
	end;

	if w1 = '/op-help' then
	begin
		enteruserline;
		PutHeading('Personal Options', false);
		slwriteln('  \WH/op-disp               \GYDisplay your option settings.');
		slwriteln('  \WH/op-chess-expert       \GYSets your chess expert mode setting.');

		if GetAccLvl >= cfg.ViewOpCmds then
			slwriteln('  \WH/op-ignoreable         \GYToggles whether users can ignore you.');

		if GetAccLvl >= cfg.InvisibleLvl then
			slwriteln('  \WH/op-invisible          \GYToggles your invisibility status.');

		slwriteln('  \WH/op-no-page-warn       \GYToggles real name page query.');
		slwriteln('  \WH/op-notify-send        \GYToggles display of send confirmation message.');
		slwriteln('  \WH/op-notify-page        \GYToggles display of page confirmation message.');
		slwriteln('  \WH/op-tab-beep           \GYBeeps if your name extension can not be done.');
		slwriteln('  \WH/op-whisper-beep       \GYToggles the beep when a whisper is received.');
		PutTrailer(false);
		exit;
	end;

	if w1 = '/ch-help' then
	begin
		enteruserline;
		PutHeading('Channel Operator Commands', false);
		slwriteln('  \WH/ch-b1ff               \GYToggles the b1ffness modes of a channel.');

		if GetAccLvl >= cfg.FreezeLvl then
			slwriteln('  \WH/ch-freeze             \GYFreezes the channel from modifications.');

		slwriteln('  \WH/ch-moderated          \GYToggles moderated status of this channel.');
		slwriteln('  \WH/ch-no-whispers        \GYToggles availablity of the whisper command.');
		slwriteln('  \WH/ch-passwd [password]  \GYSet a password for this channel.');
		slwriteln('  \WH/ch-setmod [user]      \GYMakes [user] a moderator for this channel.');
		slwriteln('  \WH/ch-setop [user]       \GYMakes [user] an operator for this channel.');
		slwriteln('  \WH/ch-spamlvl [lines]    \GYSets the spam level to [lines] per 10 seconds.');
		slwriteln('  \WH/ch-topic [topic]      \GYSet a topic for this channel.');
		slwriteln('  \WH/kick [user]           \GYKicks [user] out of your current channel.');
		slwriteln('  \WH/silence [user]        \GYSilences [user] or allows [user] to talk.');
		PutTrailer(false);
		exit;
	end;

	if (w1 = '/co-help') and (GetAccLvl >= cfg.ViewOpCmds) then
	begin
		enteruserline;
		PutHeading('Conference Operator Commands', false);

		if GetAccLvl >= cfg.AdjTimeLvl then
			slwriteln('  \WH/adjtime [user] [time] \GYAdjusts [user]''s time left in teleconference.');

		if GetAccLvl >= cfg.BanLvl then
		begin
			slwriteln('  \WH/ban [user] {mins}     \GYBans [user] from teleconference.');
			slwriteln('  \WH/unban [user]          \GYUnbans [user] from teleconference.');
		end;

		if GetAccLvl >= cfg.BeepLvl then
			slwriteln('  \WH/beep [user]           \GYBeeps user [user] three times.');

		if GetAccLvl >= cfg.BootLvl then
			slwriteln('  \WH/boot [user]           \GYBoots the user [user] out of teleconference.');

		if GetAccLvl >= cfg.OrderLvl then
		begin
			slwriteln('  \WH/order [user] [text]   \GYSend an order message [text] to [user].');
			slwriteln('  \WH/order all [text]      \GYSend an order message [text] to everyone.');
		end;

		if GetAccLvl >= cfg.RenameLvl then
			slwriteln('  \WH/rename [old] [name]   \GYChanges [old]''s alias to [new].');

		if GetAccLvl >= cfg.SetLvl then
		begin
			slwriteln('  \WH/set [user]            \GYDisplays [user]''s options.');
			slwriteln('  \WH/set [user] [opt]      \GYDisplays the status of option [opt] for [user].');
			slwriteln('  \WH/set [user] [opt] [s]  \GYSets option [opt] to [s] for [user].');
		end;

		if GetAccLvl >= cfg.SysLvl then
			slwriteln('  \WH/sys [text]            \GYWrite [text] directly to everyone''s screen.');

		if GetAccLvl >= cfg.WriteLvl then
			slwriteln('  \WH/write [text]          \GYWrite [text] without spam or bad word detection.');

		PutTrailer(false);
		exit;
	end;

	if w1 = '/key-help' then
	begin
		enteruserline;
		PutHeading('Keyboard Commands', false);
		slwriteln('  \WH[ENTER]                \GYDisplays channel and time information.');
		slwriteln('  \WH[LEFT], [RIGHT]        \GYMoves the cursor left and right.');
		slwriteln('  \WH[HOME], [END]          \GYMoves the cursor to the start and end of the line.');
		slwriteln('  \WH[CTRL]-[LEFT]          \GYMoves the cursor one word to the left.');
		slwriteln('  \WH[CTRL]-[RIGHT]         \GYMoves the cursor one word to the right.');
		slwriteln('  \WH[CTRL]-[A]             \GYHolds text in hold buffer and retrieves.');
		slwriteln('  \WH[CTRL]-[BACKSPACE]     \GYDeletes the last word.');
		slwriteln('  \WH[CTRL]-[B]             \GYDeletes the last word.');
		slwriteln('  \WH[ESC]                  \GYDeletes the entire line.');
		slwriteln('  \WH[F3], [UP]             \GYRepeats the last unsuccessful command or whisper.');

		PutTrailer(false);
		exit;
	end;

	if w1 = '/myabbr' then
	begin
		enteruserline;
		ss := stripcol(copy(aword(s, 2, true), 1, 10));
		if ss = '' then
		begin
			slwriteln('\WH * Your name abbreviation is '+cfg.defusrcol+myuser.abbrname+'\WH.');
			exit;
		end;

		if (myuser.banabbrset) and (GetAccLvl < 255) then
		begin
			slwriteln('\WH * You may not set your own name abbreviation.');
			exit;
		end;

		myuser.abbrname := ss;
		myrec.abbrname := ss;

		WriteMyInfo;
		WriteMyUser;

		slwriteln('\WH * Your name abbreviation is now '+cfg.defmsgcol+ss+'\WH.');
		slwriteln('   Note that this must be a proper abbreviation of your name.  Any misuse of');
		slwriteln('   this command will result in your access to it being revoked.');

		SendThisMsg('', 1);
		exit;
	end;

	if (w1 = '/abbr') or (w1 = '/dict') then
	begin
		enteruserline;
		ss := aword(s, 2, false);
		if ss = '' then
		begin
			slwriteln('\WH * Use is '+w1+' [word to look up].');
			exit;
		end;

		upstr(ss);
		stripspaces(ss);
		ss := stripcol(ss);

		w1 := ss;
		s := ss;
		while pos('-', ss) > 0 do		{ remove noses! }
			delete(ss, pos('-', ss), 1);

		assign(fptr, 'abbr.lst');
		{$i-} reset(fptr); {$I+}
		if ioresult <> 0 then
		begin
			slwriteln('\WH * Abbreviation list not found.  Contact your SysOp.');
			exit;
		end;

		while not eof(fptr) do
		begin
			readln(fptr, s);
			if ss = copy(s, 1, pos('|', s)-1) then
			begin
				slwriteln('\YE'+w1+'\GR : '+copy(s, pos('|', s)+1, 1000));
				close(fptr);
				exit;
			end;

			if ss = copy(s, 1, pos('^', s)-1) then
			begin
				slwriteln('\YE'+w1+'\GR : '+copy(s, pos('^', s)+1, 1000));
				close(fptr);
				exit;
			end;
		end;

		slwriteln('\WH * Definition not found.');
		close(fptr);
		exit;
	end;

	if w1 = '/recent' then
	begin
		enteruserline;
		RecentCalls(false, 75);
		exit;
	end;

	if (w1 = '/me') or (w1 = '/me''s') then
	begin
		if (myrec.silenced) and (GetAccLvl < cfg.CantSilenceLvl) then
		begin
			enteruserline;
			slwrite('\WH * Message not sent; you are silenced!'#13#10)
		end
		else
		begin
			if (mychan.moderated) and
					(not myrec.ismoderator) and
					(GetAccLvl < cfg.ChanOpLvl) then
			begin
				enteruserline;
				slwriteln('\WH * You cannot send public messages on this channel since it is moderated.')
			end
			else if CheckSpam = true then
			begin
				enteruserline;
				slwriteln('\WH * The spam detector has disallowed your previous public message.')
			end
			else if CheckBadWords(s) = true then
			begin
				enteruserline;
				slwriteln('\WH * The bad words detector has disallowed your previous public message.')
			end
			else
			begin
				ss := aword(s, 2, true);
				if mychan.quiet then
					ss := MakeQuiet(ss);
				if mychan.b1ff then
					ss := MakeB1ff(ss);

				if w1 = '/me' then
					ss := ' \GY* '+cfg.defusrcol+myrec.alias+' \WH'+ss
				else
					ss := ' \GY* '+cfg.defusrcol+myrec.alias+'''s \WH'+ss;

				if (ss[length(ss)] in ['A'..'Z','a'..'z']) then ss := ss + '.';
				killuserline(x);
				indent := cfg.WritingIndent;
				slwriteln(ss);
				indent := 0;

				SendThisMsg(ss+#13#10, 4);
			end;
		end;
		exit;
	end;

	if (w1 = '/page') or (w1 = '/p') then
	begin
		enteruserline;

		if mychan.nowhispers then
			slwriteln('\WH * Pages are disabled on this channel.')
		else
			SendPage(aword(s, 2, false), aword(s, 3, true), x);
		exit;
	end;

	if w1 = '/afk' then
	begin
		enteruserline;
		if myrec.afk then
		begin
			myrec.afk := false;
			WriteMyInfo;

			slwrite('\WH * You are now considered Back To Keyboard.'#13#10);
			SendSysMsg('User '+cfg.defusrcol+myuser.alias+'\WH is Back To Keyboard.');
		end
		else
		begin
			myrec.afk := true;
			WriteMyInfo;

			ss := aword(s, 2, true);
			if ss <> '' then ss := ' ' + ss;
			if (ss[length(ss)] in ['A'..'Z','a'..'z','0'..'9']) then ss := ss + '.';
			slwrite('\WH * You are now considered Away From Keyboard.'#13#10);
			SendSysMsg('User '+cfg.defusrcol+myuser.alias+'\WH is Away From Keyboard'+ss);
		end;

		exit;
	end;

	if (w1 = '/setkey') and (GetAccLvl >= cfg.MacroLvl) then
	begin
		enteruserline;
		SetKey(aword(s, 2, false), aword(s, 3, true));
		exit;
	end;

	if (w1 = '/delkey') and (GetAccLvl >= cfg.MacroLvl) then
	begin
		enteruserline;
		SetKey(aword(s, 2, false), '');
		exit;
	end;

	if (w1 = '/listkey') and (GetAccLvl >= cfg.MacroLvl) then
	begin
		enteruserline;
		ListKey;
		exit;
	end;

	if w1 = '/alarm' then
	begin
		enteruserline;
		SetAlarm(aword(s, 2, false));
		exit;
	end;

	if (s = '/channel') or (s = '/c') then
	begin
		enteruserline;
		ScanChannel;
		exit;
	end;

	if (w1 = '/channel') or (w1 = '/c') then
	begin
		enteruserline;

		if (GetAccLvl < cfg.PrivLvl) then
		begin
			slwriteln('\WH * You are not permitted to use '+w1+'.');
			exit;
		end;

		val(aword(s, 2, false), n, nn);
		if (n > 0) and (n < 60001) then
		begin
			LeaveChannel(true);
			n := JoinChannel(n, true);
			slwrite('\WH * You have switched to channel '+strs(n)+'.'#13#10);
			s := ''; x := 1;

			cmdparse := true;
			exit;
		end;
		slwrite('\WH * Channel number must be between 1 and 60000.'#13#10);
		exit;
	end;

	if (w1 = '/sneek') and (GetAccLvl >= cfg.InvisibleLvl) then
	begin
		enteruserline;
		val(aword(s, 2, false), n, nn);
		if (n > 0) and (n < 60001) then
		begin
			LeaveChannel(false);
			n := JoinChannel(n, false);
			slwrite('\WH * You have switched to channel '+strs(n)+'.'#13#10);
			s := ''; x := 1;

			cmdparse := true;
			exit;
		end;
		slwrite('\WH * Channel number must be between 1 and 60000.'#13#10);
		exit;
	end;

	if (w1 = '/realtime') or (w1 = '/direct') then
	begin
		enteruserline;

		if (GetAccLvl < cfg.PrivLvl) then
		begin
			slwriteln('\WH * You are not permitted to use '+w1+'.');
			exit;
		end;

		if aword(s, 2, false) <> '' then
		begin
			val(aword(s, 2, false), n, nn);
			if (n < 1) or (n > 2000) then
			begin
				slwriteln('\WH * Real time chat channel must be between 1 and 2000.');
				exit;
			end;
			slwriteln('\WH * You are in real time channel \LG'+strs(n)+'\WH.  Type \LG/x\WH to exit.');
		end
		else
		begin
			if w1 = '/direct' then
			begin
				slwriteln('\WH * You must specify a specific channel for /direct.');
				exit;
			end;

			slwriteln('\WH * You are now in GLOBAL real time chat.  ANYONE will be able to see your');
			slwriteln('   conversation.  To finish, type \LC/x\WH on a new line.\LG'#10);
			n := 0;
		end;

		nn := myrec.channel;
		LeaveChannel(true);

		if w1 = '/direct' then
		begin
			JoinChannel(62002+n, true);
			RealTimeChat(true, n, '/x'+#13);
		end
		else
		begin
			JoinChannel(60001+n, true);
			RealTimeChat(false, n, '/x'+#13);
		end;

		LeaveChannel(true);
		JoinChannel(nn, true);

		slwriteln('');

		s := '';
		x := 1;
		cmdparse := true;
		exit;
	end;

	if w1 = '/boot-alarm' then
	begin
		enteruserline;
		BootAlarm;
		exit;
	end;

	if w1 = '/test-colour' then
	begin
		enteruserline;
		TestColour;
		exit;
	end;

	if w1 = '/lines' then
	begin
		enteruserline;
		val(aword(s, 2, true), n, nn);
		if n = 0 then
		begin
			slwriteln('\WH * Your terminal is currently set to \LG'+strs(ScreenLength)+'\WH lines.');
			exit;
		end;

		if (n < 24) or (n > 100) then
		begin
			slwriteln('\WH * You can only set your terminal size between 24 and 100 lines.');
			exit;
		end;

		slwriteln('\WH * Terminal set to \LG'+strs(n)+'\WH lines.');
		ScreenLength := n;
		exit;
	end;

	if w1 = '/listed' then
	begin
		enteruserline;
		myrec.listed := not myrec.listed;
		slwrite('\WH * Your channel is now ');
		if not myrec.listed then slwrite('NOT ');
		slwriteln('listed in /channel.');

		WriteMyInfo;
		exit;
	end;

	if (s = '/ignore') or (s = '/ignorep') then
	begin
		enteruserline;
		PutHeading('Users you are ignoring', false);
		for n := 1 to 30 do
		begin
			if ignore[n].name <> '' then
			begin
				if ignore[n].isperm then
					slwrite('\WH'+blinky+'  * \LG')
				else
					slwrite('\WH    ');

				slwriteln(cfg.defusrcol+GetAName(ignore[n].name));
			end;
		end;

		PutTrailer(false);
		exit;
	end;

	if w1 = '/ignore' then
	begin
		enteruserline;
		IgnoreUser(aword(s, 2, true), false);
		exit;
	end;

	if w1 = '/ignorep' then
	begin
		enteruserline;
		IgnoreUser(aword(s, 2, true), true);
		exit;
	end;

	if w1 = '/op-notify-send' then
	begin
		enteruserline;
		toggle(s, myuser.notifysend);
		exit;
	end;

	if w1 = '/op-notify-page' then
	begin
		enteruserline;
		toggle(s, myuser.notifypage);
		exit;
	end;

	if w1 = '/op-no-page-warn' then
	begin
		enteruserline;
		toggle(s, myuser.nopagewarn);
		exit;
	end;

	if w1 = '/op-windowing' then
	begin
		enteruserline;
		toggle(s, myuser.usewindow);
		exit;
	end;

	if w1 = '/op-tab-beep' then
	begin
		enteruserline;
		toggle(s, myuser.tabbeep);
		exit;
	end;

	if w1 = '/op-whisper-beep' then
	begin
		enteruserline;
		toggle(s, myuser.whisperbeep);
		exit;
	end;

	if w1 = '/op-chess-expert' then
	begin
		enteruserline;
		toggle(s, myuser.chessexp);
		exit;
	end;

	if w1 = '/op-disp' then
	begin
		enteruserline;
		PutHeading('Your Option Settings', false);

		slwrite(#13#10+
				'\GYNotify when messages sent:     \WH'+ yn(myuser.notifysend)+' \GY(/op-notify-send)'+#13#10+
				'\GYNotify when page sent:         \WH'+ yn(myuser.notifypage)+' \GY(/op-notify-page)'+#13#10+
				'\GYWarn about real name page:     \WH'+ yn(not myuser.nopagewarn)+' \GY(/op-no-page-warn)'+#13#10);

		slwrite('\GYMessages sent are ignoreable:  \WH'+ yn(not myuser.notignore)+' \GY(/op-ignoreable)'+#13#10+
				'\GYBeep if name expansion fails:  \WH'+ yn(myuser.tabbeep)+' \GY(/op-tab-beep)'+#13#10+
				'\GYBeep on receipt of a whisper:  \WH'+ yn(myuser.whisperbeep)+' \GY(/op-whisper-beep)'+#13#10);

		slwrite('\GYDefault chess expert mode on:  \WH'+ yn(myuser.chessexp)+' \GY(/op-chess-expert)'+#13#10+
				#13#10);

		PutTrailer(false);
		exit;
	end;

	if w1 = '/whisper' then				{ whisper kludge }
	begin
		if (GetAccLvl < cfg.PrivLvl) then
		begin
			slwriteln('\WH * You are not permitted to use '+w1+'.');
			exit;
		end;

		if mychan.nowhispers then
		begin
			enteruserline;
			slwriteln('\WH * Whispers are disabled on this channel.')
		end
		else
			PrivateMsg(aword(s, 2, false), aword(s, 3, true), x);

		exit;
	end;

	if w1 = '/userlist' then
	begin
		enteruserline;
		ConfUserList(aword(s, 2, true));
		exit;
	end;

	if w1 = '/clrscr' then
	begin
		xclrscr;
		exit;
	end;

	if w1 = '/topic' then
	begin
		enteruserline;
		if mychan.name = '' then
			slwriteln('\WH * There is no topic for this channel.')
		else
			slwriteln('\WH * The topic for this channel is "'+mychan.name+'\WH".');
		exit;
	end;

	if w1 = '/rescan' then
	begin
		enteruserline;
		ReadChannelInfo;
		exit;
	end;

	if w1 = '/bye' then
	begin
		enteruserline;
		slwriteln('\WH * See you later!');
		LeaveChannel(false);
		LeaveConference(true);
		waitout;
		hangup;
		halt;
	end;

	if ((myrec.ischanop = true) or (GetAccLvl >= cfg.ChanOpLvl)) and
	   ((not mychan.frozen) or (GetAccLvl >= cfg.FreezeLvl)) then
	begin
		if w1 = '/ch-spamlvl' then
		begin
			enteruserline;
			val(aword(s, 2, true), n, nn);
			if (nn <> 0) or (n < 0) or (n > MaxSpamLvl) then
			begin
				slwriteln('\WH * Must be between 0 (off) and '+strs(MaxSpamLvl)+' lines.');
				exit;
			end;

			ReadCInfo;
			mychan.spamlvl := n;
			WriteCInfo;

			if n = 0 then
			begin
				slwriteln('\WH * Spam detection is now \LGOFF\WH.');
				SendSysMsg('Spam detection is now \LGOFF\WH.');
				exit;
			end;

			s := 'Spam detection set to \LG'+strs(n)+'\WH lines per ten seconds.';
			SendSysMsg(s);

			slwriteln('\WH * '+s);
			exit;
		end;

		if w1 = '/ch-moderated' then
		begin
			enteruserline;

			if (mychan.moderated) and
			   (myrec.channel = 1) and
			   (GetAccLvl < 255) then
			begin
				slwriteln('\WH * You may not make channel 1 a moderated channel.');
				exit;
			end;

			ReadCInfo;
			mychan.moderated := not mychan.moderated;
			WriteCInfo;

			s := 'This channel is now ';
			if mychan.moderated = false then s := s + 'NOT ';
			s := s + 'moderated.';

			SendSysMsg(s);
			slwriteln('\WH * '+s);
			exit;
		end;

		if w1 = '/ch-quiet' then
		begin
			enteruserline;

			ReadCInfo;
			mychan.quiet := not mychan.quiet;
			WriteCInfo;

			s := 'This channel is now ';
			if mychan.quiet = false then s := s + 'NOT ';
			s := s + 'quiet.';

			SendSysMsg(s);
			slwriteln('\WH * '+s);
			exit;
		end;

		if w1 = '/ch-b1ff' then
		begin
			enteruserline;

			ReadCInfo;
			mychan.b1ff := not mychan.b1ff;
			WriteCInfo;

			s := 'This channel is now ';
			if mychan.b1ff = false then s := s + 'NOT ';
			s := s + 'a b1ff channel.';

			SendSysMsg(s);
			slwriteln('\WH * '+s);
			exit;
		end;

		if w1 = '/ch-no-whispers' then
		begin
			enteruserline;

			ReadCInfo;
			mychan.nowhispers := not mychan.nowhispers;
			WriteCInfo;

			s := 'This channel now does ';
			if mychan.nowhispers then s := s + 'NOT ';
			s := s + 'allow whispers.';

			SendSysMsg(s);
			slwriteln('\WH * '+s);
			exit;
		end;

		if w1 = '/ch-setmod' then
		begin
			enteruserline;
			ToggleModerator(aword(s, 2, true));
			exit;
		end;

		if w1 = '/ch-setop' then
		begin
			enteruserline;
			ToggleChanOp(aword(s, 2, true));
			exit;
		end;

		if w1 = '/silence' then
		begin
			enteruserline;
			ToggleSilence(aword(s, 2, true));
			exit;
		end;

		if w1 = '/kick' then
		begin
			enteruserline;
			if (myrec.channel = 1) then
			begin
				slwriteln('\WH * You can''t kick a person off channel 1.');
				exit;
			end;

			ss := GetUserAlias(aword(s, 2, true));
			if ss = '' then
			begin
				slwrite('\WH * User '+cfg.defusrcol+s+'\WH is not on this channel!'#13#10);
				exit;
			end;

			SendOrdMsg('KICK', GetUserNode(ss, false));
			SendSysMsg(cfg.defusrcol+myrec.alias+'\WH has kicked '+cfg.defusrcol+ss+'\WH off this channel!');
			exit;
		end;

		if w1 = '/ch-topic' then
		begin
			enteruserline;
			ss := aword(s, 2, true);
			stripspaces(ss);

			if length(ss) >= 65 then
			begin
				slwrite('\WH * Topic must be under 65 characters in length.'#13#10);
				exit;
			end;

			ReadCInfo;
			mychan.name := ss;
			WriteCInfo;

			SendSysMsg('A new topic has been set by '+cfg.defusrcol+myrec.alias+'\WH.');
			slwrite('\WH * You have set a new topic.'#13#10);
			exit;
		end;

		if w1 = '/ch-passwd' then
		begin
			enteruserline;
			ss := aword(s, 2, true);
			stripspaces(ss);
			upstr(ss);

			if length(ss) > 9 then
			begin
				slwrite('\WH * Password must be nine characters or less.  Password not changed.'#13#10);
				exit;
			end;

			ReadCInfo;
			mychan.password := ss;
			WriteCInfo;

			SendSysMsg('\WHA new password has been set by '+cfg.defusrcol+myrec.alias+'\WH.');
			slwrite('\WH * You have set a new password.'#13#10);
			exit;
		end;

		if (w1 = '/ch-freeze') and (GetAccLvl >= cfg.FreezeLvl) then
		begin
			enteruserline;

			ReadCInfo;
			mychan.frozen := not mychan.frozen;
			WriteCInfo;

			s := 'This channel is now ';
			if mychan.frozen = false then s := s + 'NOT ';
			s := s + 'frozen.';

			SendSysMsg(s);
			slwriteln('\WH * '+s);
			exit;
		end;
	end;

	if (w1 = '/beep') and (GetAccLvl >= cfg.BeepLvl) then
	begin
		enteruserline;
		if GetUserRec(aword(s, 2, true), CurrentChannel, true, sr) <> Okay then
			exit;

		SendThisMsgP(#7#7#7, 1, sr.node);
		slwriteln('\WH * User '+cfg.defusrcol+sr.alias+'\WH has been beeped.');
		exit;
	end;


	if (w1 = '/adjtime') and (GetAccLvl >= cfg.AdjTimeLvl) then
	begin
		enteruserline;
		adjtime(aword(s, 2, false), aword(s, 3, false));
		exit;
	end;

	if (w1 = '/adjmp') and (GetAccLvl >= cfg.AdjMPLvl) then
	begin
		enteruserline;
		adjmp(aword(s, 2, false), aword(s, 3, false));
		exit;
	end;

	if (w1 = '/ban') and (GetAccLvl >= cfg.BanLvl) then
	begin
		enteruserline;
		BanUser(aword(s, 2, false), vals(aword(s, 3, false)));
		exit;
	end;

	if (w1 = '/unban') and (GetAccLvl >= cfg.BanLvl) then
	begin
		enteruserline;
		UnbanUser(aword(s, 2, false));
		exit;
	end;

	if (w1 = '/boot') and (GetAccLvl >= cfg.BootLvl) then
	begin
		enteruserline;
		ss := GetUserAlias(aword(s, 2, false));
		if ss = '' then
		begin
			slwrite('\WH * User '+cfg.defusrcol+aword(s, 2, false)+'\WH is not on this channel!'#13#10);
			exit;
		end;

		SendOrdMsg('BOOT', GetUserNode(ss, false));
		SendSysMsg(cfg.defusrcol+myrec.alias+'\WH has booted '+cfg.defusrcol+ss+'\WH out of teleconference!');
		exit;
	end;

	if (w1 = '/op-ignoreable') and (GetAccLvl >= cfg.ConfOpLvl) then
	begin
		enteruserline;
		myuser.notignore := not myuser.notignore;

		WriteMyUser;

		slwrite('\WH * You are now ');
		if myuser.notignore then slwrite('NOT ');
		slwrite('ignoreable.'#13#10);
		exit;
	end;

	if (w1 = '/order') and (GetAccLvl >= cfg.OrderLvl) then
	begin
		enteruserline;
		SendOrder(aword(s, 2, false), aword(s, 3, true), true);
		exit;
	end;

	if (w1 = '/set') and (GetAccLvl >= cfg.SetLvl) then
	begin
		enteruserline;
		SetUserOption(aword(s, 2, false), aword(s, 3, false), aword(s, 4, true));
		exit;
	end;

	if (w1 = '/rename') and (GetAccLvl >= cfg.RenameLvl) then
	begin
		enteruserline;
		RenameUser(aword(s, 2, false), aword(s, 3, true));
		exit;
	end;

	if (w1 = '/setabbr') and (GetAccLvl >= cfg.SetAbbrLvl) then
	begin
		enteruserline;
		SetAbbrName(aword(s, 2, false), aword(s, 3, true));
		exit;
	end;

	if (w1 = '/sys') and (GetAccLvl >= cfg.SysLvl) then
	begin
		enteruserline;
		SendThisMsg(aword(s, 2, true)+#13#10, 1);

		killuserline(x);
		slwrite(aword(s, 2, true)+#13#10);
		exit;
	end;

	if (w1 = '/write') and (GetAccLvl >= cfg.WriteLvl) then
	begin
		s := copy(s, 8, 1000);
		SendThisMsgAll(cfg.defusrcol+myrec.alias+': '+cfg.defmsgcol+s+#13#10, 2);

		killuserline(x);
		exit;
	end;

	if w1 = '/mine' then enteruserline;

{	if mind_parse(s) = true then
		exit;
}
	if chess_parse(s) = true then
		exit;

	if othello_parse(s) = true then
		exit;

	if ext_routines(s) = true then
		exit;

	if bar_routines(s) then
		exit;

	if w1 = '/mine' then exit;


{ ************* Undocumented Commands  ******************************* }


	if w1 = '/whoami' then
	begin
		enteruserline;
		if realusername = '' then
			slwriteln('\WH * You are not logged into Searchlight.')
		else
			slwriteln('\WH * You are logged into Searchlight as \LG'+namecaps(realusername)+'\WH.');
		exit;
	end;

	if w1 = '/nosui' then
	begin
		nosui;
		exit;
	end;

	if (w1 = '/weenie') and (GetAccLvl >= cfg.WeenieLvl) then
	begin
		enteruserline;
		Weenie(aword(s, 2, true));
		exit;
	end;

	if w1 = '/rah' then
	begin
		enteruserline;
		slwriteln('\WH * Rah!');

		if random(100) > 80 then
			inc(timelimit, 5)
		else
			dec(timelimit, 5);

		exit;
	end;

	if w1 = '/super-rah' then
	begin
		enteruserline;
		SuperRah;
		exit;
	end;

	if w1 = '/version' then
	begin
		enteruserline;
		slwriteln('\WH * You are running MogTalk v'+_ver+'.');
		exit;
	end;

	if w1 = '/override' then
	begin
		enteruserline;
		AccOverride;
		exit;
	end;

	enteruserline;
	slwrite('\WH * Unknown command '+s+'.  Type /? for help.'#13#10);
	laststr := s;
end;


procedure MogHint;
var
	fptr	: text;
	n, lp	: integer;
	s		: string;

begin
	assign(fptr, 'moghint.txt');
	{$i-} reset(fptr); {$I+}
	if ioresult <> 0 then
		exit;

	readln(fptr, n);

	n := random(n);

	for lp := 1 to n do
		readln(fptr, s);

	slwriteln(#10'\WH * MogHint!  Did you know...');

	readln(fptr, s);
	indent := 3;
	slwriteln('   '+s);
	indent := 0;

	close(fptr);
end;

procedure DoMacro(var s : string);
begin
	s := copy(s, 2, 255);

	slwriteln('\WH * Macro \LG'+aword(s, 1, false)+'\WH is not defined.');
end;

procedure LookupAbbr(ss : string);
var
	fptr : text;
	as, s : string;
	snds : string;
begin
	assign(fptr, 'abbr.lst');
	{$i-} reset(fptr); {$I+}
	if ioresult <> 0 then exit;

	if ss[length(ss)] in ['?','.','!'] then
		delete(ss, length(ss), 1);

	upstr(ss);

	as := ss;

	stripspaces(ss);
	ss := stripcol(ss);


	while pos('-', ss) > 0 do		{ remove noses! }
		delete(ss, pos('-', ss), 1);

	while not eof(fptr) do
	begin
		readln(fptr, s);
		if ss = copy(s, 1, pos('|', s)-1) then
		begin
			snds := cfg.defusrcol+
				'MogTalk: '+cfg.defmsgcol+'The abbreviation \WH'+as+cfg.defmsgcol+' means '+copy(s, pos('|', s)+1, 1000)+#13#10;
			indent := 2;
			slwrite(snds);
			indent := 0;
			SendThisMsg(snds, 1);
			close(fptr);
			exit;
		end;

		if ss = copy(s, 1, pos('^', s)-1) then
		begin
			snds := cfg.defusrcol+'MogTalk: \WH'+as+':'+cfg.defmsgcol+'  '+copy(s, pos('^', s)+1, 1000)+#13#10;
			indent := 2;
			slwrite(snds);
			indent := 0;
			SendThisMsg(snds, 1);
			close(fptr);
			exit;
		end;
	end;

	close(fptr);
end;

var
	gx	: word;
	gs	: string;

function Conference : boolean;
var
  s : string;
begin
	conference := false;

	while true do
	begin
		initscr;

		if GetString(gs, gx) > 0 then
			exit;

		if gs = '' then
		begin
			killuserline(gx);
			exit;
		end;

		WriteLog(gs);

		laststr := '';

		if gs[1] = '/' then
		begin
			if (gs = '/quit') or (gs = '/x') or (gs = '/X') or (gs = '/xx') then
			begin
				if bootset then
				begin
					killuserline(gx);
					gs := '';
					gx := 1;
					slwriteln('\WH * You can''t quit when you''ve setted a /boot-alarm.  Use /bye.');
					continue;
				end
				else
				begin
					if (gs <> '/xx') and alarmset then
					begin
						enteruserline;
						indent := 3;
						slwriteln('\WH * You have an alarm set!  The alarm will be disabled if you quit teleconference now.  '+
								  'Type \LC/xx\WH if you wish to exit teleconference.');
						indent := 0;
						gs := '';
						gx := 1;
						continue;
					end
					else
					begin
						enteruserline;
						conference := true;
						exit;
					end;
				end;
			end;

			if cmdparse(gs, gx) then exit;
		end
		else if (gs[1] = ';') and not (gs[2] in ['-',')','(']) and (length(gs) > 1) then
		begin
			if GetAccLvl < cfg.PrivLvl then
			begin
				enteruserline;
				slwriteln('\WH * You are not permitted to use whispers.');
			end
			else if mychan.nowhispers then
			begin
				enteruserline;
				slwriteln('\WH * Whispers are disabled on this channel.')
			end
			else
				PrivateMsg(aword(copy(gs, 2, 255), 1, false), aword(gs, 2, true), gx);
		end
		else if (gs[1] = '=') and (gs[2] in ['a'..'z','A'..'Z']) and (length(gs) > 1) then
		begin
			killuserline(gx);
			DoMacro(gs);
		end
		else
		begin
			if (myrec.silenced) and (GetAccLvl < cfg.CantSilenceLvl) then
			begin
				enteruserline;
				slwrite('\WH * Message not sent; you are silenced!'#13#10)
			end
			else if (mychan.moderated) and
					(not myrec.ismoderator) and
					(GetAccLvl < cfg.ChanOpLvl) then
			begin
				enteruserline;
				slwriteln('\WH * You cannot send public messages on this channel since it is moderated.')
			end
			else if CheckSpam = true then
			begin
				enteruserline;
				slwriteln('\WH * The spam detector has disallowed your previous public message.')
			end
			else if CheckBadWords(gs) = true then
			begin
				enteruserline;
				slwriteln('\WH * The bad words detector has disallowed your previous public message.')
			end
			else
			begin
				s := aword(gs, 1, false);
				if s[length(s)] = ':' then
				begin
					s := GetUserAbbr(copy(s, 1, length(s)-1));
					if s <> '' then
						gs := cfg.defmsgcol + stripcol(s) + ': ' + aword(gs, 2, true);
				end;

				if mychan.quiet then
					gs := MakeQuiet(gs);
				if mychan.b1ff then
					gs := MakeB1ff(gs);

				if gs <> '' then
					SendPublicMsg(gs);

				killuserline(gx);
				indent := cfg.WritingIndent;
				slwrite(cfg.defusrcol+myrec.alias+': '+cfg.defmsgcol+gs+#13#10);
				indent := 0;

				if myrec.afk then
					slwrite('\WH * \LRNOTE: \WHYou are considered Away From Keyboard.  Type /afk to return.'#13#10);

				if (copy(ups(gs), 1, 10) = 'WHAT DOES ') or
				   (copy(ups(gs), 1, 8) =  'WHAT IS ') or
				   (copy(ups(gs), 1, 7) =  'WHO IS ') then
					LookupAbbr(aword(gs, 3, false));
			end;
		end;

		gs := '';
		gx := 1;
	end;
end;



function main : boolean;
begin
	if myuser.IAmWeenie then
	begin
		Indent := 3;
		slwriteln(#10'\WH * Attention Weenie!  You must wait for a whole page of weenies to pass before '+
			'you can use the teleconference again!'#10);
		Indent := 0;
		SendOrdMsg('WEENIE', myrec.node);
	end;

	WriteHeader;
	main := Conference;
end;




function GetCUser(s : string) : boolean;
begin
	with myrec do
	begin
		node := cf.node;
		listed := true;
		silenced := false;
	end;

	OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRW+DenyNone);
	while not eof(sf.f) do
	begin
		blockread(sf.f, myuser, sizeof(myuser));
		if (myuser.name = user.name) then
		begin
			with myrec do
			begin
				name := myuser.name;
				alias := myuser.alias;
				if alias = '' then
					alias := myuser.name;
			end;
			myurec := filepos(sf.f)-sizeof(myuser);
			CloseSharedFile;
			GetCUser := true;
			exit;
		end;
	end;

	with myrec do
	begin
		name := user.name;
		alias := user.alias;
		if alias = '' then
			alias := user.name;
	end;

	fillchar(myuser, sizeof(myuser), 0);
	with myuser do
	begin
		name := myrec.name;
	end;

	myurec := filesize(sf.f);

	if myurec = 0 then		{ first entry }
		myuser.accesslvl := 255
	else
		myuser.accesslvl := 1;

	seek(sf.f, myurec);
	blockwrite(sf.f, myuser, sizeof(myuser));

	CloseSharedFile;
	GetCUser := false;
end;


procedure checkbanned;
var
  bad  	: boolean;
  date 	: datetype;
  r		: longint;
begin
	bad := false;

	if (myuser.banned = true) and (GetAccLvl < cfg.CantBanLvl) then
	begin
		if myuser.banneduntil > 0 then
		begin
			bad := (Time < myuser.banneduntil);
		end
		else
			bad := true;
	end;

	if bad then
	begin
		slwriteln(#10'\LRYou have been banned from using Teleconference!\WH');

		if myuser.banneduntil > 0 then
		begin
			ConvTToDT(myuser.banneduntil, date);
			slwrite('You are banned until \LG'+strdate(date)+'\WH at ');
			r := (myuser.banneduntil mod 86400) div 60;
			slwriteln('\LG'+strs2(r div 60)+':'+strs2(r mod 60)+'\WH.');
		end;

		slwrite('Write a message to your SysOp if you do not know why.'#13#10);
		halt;
	end;

	myuser.banned := false;
end;



function moglogin(UseUsersTime : boolean) : boolean;
var
	s : string;
	tries : integer;
	ret : word;
	d,m,y,w : word;

	arec : aliastype;
	apos : longint;

begin
	tries := 0;
	moglogin := false;

	xwriteln(#10);

	repeat
		slwrite('\CYEnter your login name:'#13#10'>\LC');
		s := getline('', 25, true, false);
		stripspaces(s);

		usearch(s, user, upos);
		if upos = 0 then
		begin
			asearch(s, arec, apos);
			if apos = 0 then
				slwriteln(#13#10'\LGThat name was not found in the user base.'#10)
			else
			begin
				usearch(arec.name, user, upos);
				s := user.name;
			end;
		end;

		inc(tries);
	until (upos > 0) or (tries > 2);

	if upos = 0 then
		exit;

	myrec.alias := s;

	if checkpasswd(user.passwd, '') = false then
	begin
		tries := 0;

		repeat
			slwrite('\CYEnter your password: \LC');
			s := getlinep('', 25, true, false, false, 0, 0, ret, #0, false, true);
			stripspaces(s);

			if checkpasswd(user.passwd, s) = false then
				slwriteln(#13#10'\LGIncorrect password!'#10);

			inc(tries);
		until (checkpasswd(user.passwd, s) = true) or (tries > 2);

		if checkpasswd(user.passwd, s) = false then
			exit;
	end;

	if ups(paramstr(1)) = 'CHAT' then
	begin
		if not (7 in user.access.attrib) then
		begin
			slwriteln(#10'\WH * You do not have access to log in through the CHAT facility.');
			exit;
		end;
	end;


	if UseUsersTime then
	begin
		getdate(y,m,d,w);
		y := y - 1900;

		if (y <> user.laston.year) or (m <> user.laston.month) or (d <> user.laston.day) then
		begin
			user.laston.year := y;
			user.laston.month := m;
			user.laston.day := d;

			if (cf.usesession = true) then
				user.timeleft := user.access.sesslimit
			else
				user.timeleft := user.access.timelimit;

			gettime(y,m,d,w);
			user.lasttime.hour := y;
			user.lasttime.minute := m;

			writeuser(user, upos);
		end;

		timelimit := user.timeleft;

		if user.access.sesslimit < timelimit then
			timelimit := user.access.sesslimit;

		if timelimit = 1 then timelimit := 0;
	end;

	moglogin := true;
	LoginSuccessful := true;
end;




procedure init;
var
	n 			: word;
	h, m		: word;
	fptr 		: file;
	r 			: sharedrec;
	quit		: boolean;
	cu			: cusertype;
	s, ss		: string;

begin
	if (paramcount < 2) and (cf.curruser = 0) then
	begin
		slwriteln(#10'\WHThis program should be run either as a door or with command line parameters.');
		slwriteln(#10'Use: MOGTALK.EXE slbbs                     (with a user logged in only)');
		slwriteln('     MOGTALK.EXE login [node number]       (local login / user login)');
		slwriteln('     MOGTALK.EXE chat [node] [time limit]  (special chat account)'#10);
		slwriteln('     MOGTALK.EXE clean                     (cleans node files)');
		slwriteln('     MOGTALK.EXE maint                     (performs daily chess maintenance)');
		halt;
	end;

	for n := 1 to hmaxnodes do
		ccnodes[n] := Nil;

	if cf.curruser > 0 then
	begin
		readuser(user, cf.curruser);
		upos := cf.curruser;
	end;

	mymacro := nil;

	sf.isopen := false;
	alarmset := false;

	heldmsg := '';

	gs := '';
	gx := 1;

	WarnTime := 4;

	linefull := false;
	lineptr := 1;

	fillchar(myrec, sizeof(myrec), 0);

	s := paramstr(1);
	upstr(s);

	realusername := user.name;
	myrec.invisible := (paramstr(2) = 'i') or (paramstr(3) = 'i');

	if s = 'CHAT' then
	begin
		myrec.alias := '';

		val(paramstr(2), node, n);
		if (n <> 0) or (node = 0) then
		begin
			slwriteln(#13#10'\CYInvalid command line parameters!');
			slwriteln('Use:  MOGTALK.EXE CHAT [node number] [session limit]');
			halt;
		end;

		val(paramstr(3), m, n);
		if (m = 0) or (n <> 0) then m := 1440;

		timelimit := m;

		gettime(h, m, n, n);
		cf.logtime.hour := h;
		cf.logtime.minute := m;

		if MogLogin(false) = false then
			halt;

		user.name := stripcol(ups(myrec.alias));
		cf.node := node;

		Login := TChat;
	end

	else if s = 'LOGIN' then
	begin
		myrec.alias := '';
		timelimit := 1;

		val(paramstr(2), node, n);
		if (n <> 0) or (node = 0) then
		begin
			slwriteln(#13#10'\CYInvalid command line parameters!');
			slwriteln('Use:  MOGTALK.EXE LOGIN [node number]');
			halt;
		end;

		if (node > cfg.maxnodes) then
		begin
			slwriteln(#13#10'\CYInvalid node number.');
			halt;
		end;

		gettime(h, m, n, n);
		cf.logtime.hour := h;
		cf.logtime.minute := m;

		if MogLogin(true) = false then
			halt;

		user.name := ups(stripcol(myrec.alias));
		cf.node := node;

		Login := TLogin;
	end

	else if s = 'SLBBS' then
	begin
		if (paramcount > 1) and not ( (paramcount = 2) and (paramstr(2) = 'i') ) then
		begin
			slwriteln(#13#10'\CYThe MogTalk SLBBS parameter does not take additional parameters.');
			halt;
		end;

		timelimit := cf.timelimit;
		Login := TSlbbs;
	end

	else
	begin
		slwriteln(#13#10'\CYInvalid command line parameters!');
		slwriteln('Type MOGTALK.EXE to get a list of valid parameters.');
		halt;
	end;

	watchtime := true;

	if (GetCUser(user.name) = false) or (myuser.alias = '') then
	begin
		slwriteln(#13#10'\CYWelcome, this is the first time you have used MogTalk!');
		slwriteln(#13#10'You must first select an alias name that you will be known by.  You cannot');
		slwriteln('change this name without the SysOp''s intervention, so make it a good one!');
		slwriteln('You may use your real name if you wish.'#13#10);

		repeat
			quit := true;

			slwrite('\GRPlease select an alias name: \CY');

			myuser.alias := getline('', 50, false, false);
			if myuser.alias = '' then
			begin
				slwriteln(#13#10'\LGReturning to BBS.  Please enter again once you''ve thought of an alias!');
				halt;
			end;

			if (length(myuser.alias) < 3) then
			begin
				slwriteln('\LGAlias name must be between 3 and 20 characters in length.'#13#10);
				quit := false;
			end;

			if (length(stripcol(myuser.alias)) > 20) then
			begin
				slwriteln('\LGAlias name must be less than 20 characters, excluding colours.'#13#10);
				quit := false;
			end;

			if (quit = true) and (pos('"', myuser.alias) > 0) then
			begin
				slwriteln('\LGAliases must not contain the " character.'#13#10);
				quit := false;
			end;

			if quit = true then
			begin
				s := myuser.alias;
				stripspaces(s);
				myuser.alias := s;
				s := stripcol(ups(s));

				OpenSharedFile(cfg.channeldir+'MOGTALK.USR', IRead+DenyNone);
				while not eof(sf.f) do
				begin
					blockread(sf.f, cu, sizeof(cu));
					ss := stripcol(ups(cu.alias));
					if (ss = s) then
					begin
						slwriteln('\LGThat name has already been chosen by someone else.  Please choose another.'#13#10);
						quit := false;
					end;
				end;

				CloseSharedFile;
			end;
		until quit = true;

		myrec.alias := myuser.alias;
		WriteMyUser;
	end;

	if GetAccLvl >= cfg.NoTimeLvl then
		watchtime := false;

	assign(fptr, cfg.channeldir+strs(myrec.node)+'.ICM');
	{$i-} erase(fptr); {$I+}
	n := ioresult;

	h := 0;


	filemode := filemode95 + DenyNone + IRead;
	assign(fptr, cfg.channeldir+'MOGTALK.UOL');
	{$i-} reset(fptr, 1); {$I+}
	n := ioresult;
	if n = 2 then
	begin
		filemode := filemode95 + DenyAll + IWrite;
		rewrite(fptr, 1);
		fillchar(r, sizeof(r), 0);
		for n := 0 to cfg.maxnodes do
			blockwrite(fptr, r, sizeof(r));
		close(fptr);
	end;

	if n = 0 then
	begin
		while not eof(fptr) do
		begin
			blockread(fptr, r, sizeof(r));
			if (r.node <> 0) and not r.invisible then
				inc(h);
		end;

		close(fptr);
	end;

	if Login in [TLogin, TChat] then
	begin
		filemode := $2;
		OpenSystemLog('MOGTALK', stripcol(myrec.alias), cf.node);
		if myrec.invisible then
			SystemLogEvent('O', '+')
		else
			SystemLogEvent('O', stripcol(myrec.alias));
		CloseSystemLog;
	end;

	OpenSharedFileF(usf, cfg.channeldir+'MOGTALK.UOL', IRW+DenyNone);

	case h of
	  0: slwriteln(#10'\WH * There are \LGno\WH other users currently in MogTalk.');
	  1: slwriteln(#10'\WH * There is \LG1\WH other user currently in MogTalk.');
	else
		slwriteln(#10'\WH * There are \LG'+strs(h)+'\WH other users currently in MogTalk.')
	end;

	slwriteln('\WH * You have \LG'+strs(myuser.points)+'\WH MogPoint'+ps(myuser.points)+'!');

	if myuser.abbrname = '' then
		myuser.abbrname := MakeAbbrName(myuser.alias);
	myrec.abbrname := myuser.abbrname;

	LoadBadWords('badwords.lst');
end;


procedure clean;
var
	f : file;
	sr : searchrec;
begin
	assign(f, cfg.channeldir+'MOGTALK.UOL');
	{$i-} erase(f); {$I+}
	if ioresult = 0 then ;

	findfirst(cfg.channeldir+'*.ICM', 0, sr);
	while doserror = 0 do
	begin
		assign(f, cfg.channeldir+sr.name);
		{$i-} erase(f); {$I+}
		findnext(sr);
	end;

	findfirst(cfg.channeldir+'*.CHA', 0, sr);
	while doserror = 0 do
	begin
		assign(f, cfg.channeldir+sr.name);
		{$i-} erase(f); {$I+}
		findnext(sr);
	end;

	slwriteln(#10'\WH * Clean performed.');
end;

procedure loadcfg;
var
	fptr : file;
begin
	assign(fptr, 'MOGTALK.CFG');
	{$i-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
	begin
		slwriteln('\WH * MOGTALK.CFG was not found in the current directory.');
		halt(3);
	end;

	blockread(fptr, cfg, sizeof(cfg));

	close(fptr);
end;


procedure loadmacros;
var
	dml : dmacrolist;
	n	: longint;
	p	: ^macrolist;
	pp	: ^pointer;
	c	: integer;

begin
	if myuser.macros = 0 then
		exit;

    exit;

	OpenSharedFile(cfg.channeldir+'MOGTALK.MAC', IRead+DenyNone);

	p := nil;
	pp := nil;
	n := myuser.macros;
	c := 0;

	while n > 0 do
	begin
		seek(sf.f, n);
		blockread(sf.f, dml, sizeof(dml));

		if dml.str = '' then
		begin
			n := dml.next;
			continue;
		end;

		if pp = nil then
		begin
			getmem(mymacro, sizeof(macrolist));
			p := pointer(mymacro);
		end
		else
		begin
			getmem(p, sizeof(macrolist));
			pp^ := p;
		end;

		pp := @p^.next;

		p^.key := dml.key;
		p^.ext := dml.ext;
		p^.action := dml.action;
		p^.str := dml.str;
		p^.next := nil;

		n := dml.next;
		inc(c);
	end;

	CloseSharedFile;

	slwriteln('\WH * \LG'+strs(c)+'\WH macros loaded.');
end;


procedure Maintenance;
begin
	xwriteln('');

	slwriteln('\WH * Chess maintenance...');
	ChessMaint;
	slwriteln('\WH * Done!');
end;


procedure killnode(s : string);
var
	n, nn : integer;
begin
	val(s, n, nn);
	if n = 0 then
	begin
		slwriteln('\WH * A node must be specified between 1 and '+strs(cfg.maxnodes)+'.');
		exit;
	end;
end;

procedure logoff;
begin
end;


var ox, oy : integer;
	oep    : pointer;

procedure nep; far;
var
	s : string;
begin
	exitproc := oep;

	CloseSharedFileF(usf);

	if Login = TSlbbs then
	begin
		if timelimit - timeon < 1 then
			user.timeleft := 1
		else
			user.timeleft := timelimit;
		writeuser(user, upos);

		readcf;
		cf.timelimit := timelimit;
		writecf;
	end;

	if (Login = TLogin) and LoginSuccessful then
	begin
		if timelimit - timeon < 1 then
			user.timeleft := 1
		else
			user.timeleft := timelimit - timeon;
		writeuser(user, upos);
	end;

	if Login in [TLogin, TChat] then
	begin
		filemode := $2;
		OpenSystemLog('MOGTALK', user.name, cf.node);
		SystemLogEvent('F', '');
		CloseSystemLog;
	end;

	CloseUserFile;
	CloseAllFiles;
end;

procedure tl(n : integer);
var f : text;
begin
	assign(f, 'mboot.log');
    {$i-} append(f); {$I+}
    if ioresult <> 0 then rewrite(f);
    writeln(f, n);
    close(f);
end;


begin
	ox := xwherex; oy := xwherey;
	if oy > scrby then oy := scrby;
	if ox > scrbx then ox := scrbx;
	xwindow(1, 1, scrbx, scrby);
	xgotoxy(ox, oy);

	if (lo(dosversion) >= 7) and (lo(dosversion) < 20) then { win95/98/NT }
		filemode95 := 256 + 16384
	else
		filemode95 := 0;

	if (not openfiles([CONFIGF, NODESF, CHATF])) or (not openuserfile) then
	begin
		slwriteln(#10'Unable to open Searchlight files.  Check your SLBBS variable.');
		halt(3);
	end;

	if SubListInit(Subboards, '') = false then
	begin
		slwriteln(#10'Unable to open subboard files.  Check your SLBBS variable.');
		halt(3);
	end;

	ComToggle;

	if local then
		ScreenLength := 24
	else
		ScreenLength := GetScreenLength;

	xtextbackground(black);
	xclrscr;

	if ScreenLength < 24 then
		ScreenLength := 24;

	PutHeading('MogTalk Teleconference v'+_ver, true);
	slwriteln('\GY * Copyright 1996-2000 LastByte Software.');

	if paramstr(1) = 'clean' then
	begin
		clean;
		halt;
	end;
{
	if paramstr(1) = 'kill' then
	begin
		killnode(paramstr(2));
		halt;
	end;
}

	if paramstr(1) = 'maint' then
	begin
		maintenance;
		halt;
	end;

	LoginSuccessful := false;

	LoadCfg;
	Init;

	oep := exitproc;
	exitproc := @nep;

	Status;
	CheckBanned;
	LoadIgnores;
	LoadMacros;
	MogHint;

	JoinChannel(1, true);

	while (Main = false) and (TimeExpired = false) do ;

	LeaveChannel(false);
	LeaveConference(true);
end.
