unit mogutils;

interface

uses	crt, dos,
		xcrt,
		general, filedef, users, defs, slfossil, modem, multi,
		slnter, utils;

function  csn : char;

procedure slwrite(s : string);
procedure slwriteln(s : string);

function  GetAccLvl : byte;
function  sp(n : word) : string;
procedure forcestatus;
procedure status;
function  aword(s : string; n : integer; toeol : boolean) : string;
function  ups(s : string) : string;
function  yn(b : boolean) : string;
function  ps(n : integer) : string;
function  stripcol(s : string) : string;
procedure enteruserline;

function  GetScreenLength : word;


const
	blinky : string[4] = '\=@';

	colcol : array [1..16] of byte = ( BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, BROWN, LIGHTGRAY, DARKGRAY, LIGHTBLUE,
						LIGHTGREEN, LIGHTCYAN, LIGHTRED, YELLOW, LIGHTMAGENTA, WHITE );
	colname : array [1..21] of string[4] = ('BK', 'BL', 'GR', 'CY', 'RD', 'MG', 'BR', 'GY', 'DG', 'LB', 'LG', 'LC', 'LR',
						'YE', 'LM', 'WH', '=@', 'NO', 'IV', '&S', '&L' );


var
	indent	: integer;
	saveattr : word;
	AccOverrideLvl : byte;


implementation

function GetAccLvl : byte;
begin
	if AccOverrideLvl > 0 then
	begin
		GetAccLvl := AccOverrideLvl;
		exit;
	end;

	if cf.superuser then
	begin
		GetAccLvl := 255;
		exit;
	end;

	GetAccLvl := myuser.accesslvl;
end;



function GetSecs : word;
var a,b,c : word;
begin
	gettime(a, b, c, a);
	GetSecs := b * 60 + c;
end;

function GetScreenLength : word;
var
	tm, a, b, nn	: word;
	ch			: char;
	s			: string;
	fptr		: text;
begin
	xclrscr;

	for a := 1 to 50 do
		xwrite(#10);

	if not Local then
		WaitOut;

	xstrwrite(#27'[6n');

	tm := (GetSecs + 3) mod 3600;

	s := '';
	while (GetSecs < tm) do
	begin
		while (not xkeypressed) and (GetSecs < tm) do Slice;

		if xkeypressed then
		begin
			ch := xreadkey;

			if ch = 'R' then
				tm := 0
			else
				s := s + ch;
		end;
	end;

	a := 0;
	b := 0;
	tm := pos(';', s);
	if tm > 0 then
	begin
		val(copy(s, tm+1, 255), a, nn);
		nn := pos('[', s)+1;
		val(copy(s, nn, tm-nn), b, nn);

		if b > a then a := b;
	end;

	GetScreenLength := a;
end;



function stripcol(s : string) : string;
var
	lp, pp 	: integer;
	t 		: string;
begin
	lp := 1;
	while lp <= length(s) do
	begin
		if s[lp] = '\' then
		begin
			if s[lp+1] in ['0'..'9'] then
			begin
				delete(s, lp, 4);
				continue;
			end;

			if s[lp+1] = '&' then
			begin
				delete(s, lp, 3);
				continue;
			end;

			t := copy(s, lp+1, 2);
			upstr(t);
			for pp := 1 to 21 do
			begin
				if colname[pp] = t then
				begin
					delete(s, lp, 3);
					dec(lp, 1);
				end;
			end;
		end;
		inc(lp, 1);
	end;

	stripcol := s;
end;


function sp(n : word) : string;
var s : string;
	lp : integer;
begin
	s := '';

	for lp := 1 to n do
		s := s + ' ';

	sp := s;
end;


procedure wrapwrite(s : string);
var
	lp, pp, x	: integer;
	quit		: boolean;
begin
	lp := 1;
	x := wherex;

	while (lp < length(s)) do
	begin
		if s[lp] = #13 then
		begin
			xwrite(copy(s, 1, lp+1));
			delete(s, 1, lp+1);
			lp := 1;
			x := 1;
		end
		else
		begin
			quit := false;

			if lp + x >= scrbx then
			begin
				for pp := lp downto 1 do
				begin
					if s[pp] = ' ' then
					begin
						xwrite(copy(s, 1, pp-1)+#13#10+sp(indent));
						delete(s, 1, pp);
						pp := 1;
						quit := true;
					end;
				end;

				if not quit then
				begin
					xwrite(#13#10+sp(indent)+copy(s, 1, lp));
					delete(s, 1, lp);
				end;

				lp := 1;
				x := 1 + indent;
			end
			else
				inc(lp);
		end;
	end;

	xwrite(s);
end;

procedure slwrite(s : string);
var
	n, lp 	: integer;
	p		: string;
	isc		: boolean;
begin
	while length(s) > 0 do
	begin
		n := pos('\', s);
		if n = 0 then
		begin
			wrapwrite(s);
			if textattr shr 4 > 0 then
				xtextbackground(black);
			exit;
		end;
		wrapwrite(copy(s, 1, n-1));
		delete(s, 1, n-1);

		if (s[2] in ['0'..'9']) and
		   (s[3] in ['0'..'9']) and
		   (s[4] in ['0'..'9']) then
		begin
			p := copy(s, 2, 3);
			val(p, n, lp);
			extextcolor(xtextattr and 15, n);
			delete(s, 1, 4);
			continue;
		end;

		p := copy(s, 2, 2);
		upstr(p);

		isc := false;

		for lp := 1 to 16 do
		begin
			if colname[lp] = p then
			begin
				xtextcolor(colcol[lp]);
				isc := true;
				break;
			end;
		end;

		if p = copy(blinky, 2, 2) then
		begin
			xtextcolor(textattr and 15 + blink);
			isc := true;
		end;

		if p = 'NO' then
		begin
			xtextcolor(green);
			xtextbackground(black);
			isc := true;
		end;

		if p = 'IV' then
		begin
			xtextbackground(textattr and 15);
			xtextcolor(black);
			isc := true;
		end;

		if p = '&S' then
		begin
			saveattr := textattr;
			isc := true;
		end;

		if p = '&L' then
		begin
			xtextbackground(saveattr shr 4);
			xtextcolor(saveattr and 15);
			isc := true;
		end;

		if p = '&R' then
		begin
			xtextcolor(random(15) + 1);
			isc := true;
		end;

		if isc = false then
		begin
			xwrite('\');
			delete(s, 1, 1);
		end
		else
			delete(s, 1, 3);
	end;

	if textattr shr 4 > 0 then
		xtextbackground(black);
end;

procedure slwriteln(s : string);
begin
	slwrite(s+#13#10);
end;


function timeon : word;
var
	h,m,s,hs : word;
	a, b : word;
begin
	gettime(h, m, s, hs);
	a := h * 60 + m;
	b := cf.logtime.hour * 60 + cf.logtime.minute;

	if (a < b) then
		inc(a, 1440);

	timeon := a - b;
end;

var LastStatMin : word;

procedure forcestatus;
begin
	LastStatMin := 61;
	status;
end;

procedure status;
var
	x, y		: word;
	ta 			: byte;
	s			: string;
	oscrty		: word;
begin
	gettime(x, y, x, x);
	if y = LastStatMin then
		exit;
	LastStatMin := y;

	oscrty := scrty0;

	directvideo := true;

	x := wherex;
	y := wherey;

	ta := textattr;

	window(1, 1, 80, 25);
	gotoxy(1, 25);
	textbackground(cf.colorchart[BACKGROUND]);
	textcolor(cf.colorchart[INVERSE]);
	clreol;
	write(' User: ',user.name);

	gotoxy(34, 25);
	write('Acc:',GetAccLvl:3,'/',user.access.msglevel:3,'/',user.access.filelevel:3);
	write('  Time:',timeon:4,'/',timelimit:4);

	write(' Node ',cf.node);

	if cf.node < 10 then
		s := '  '
	else if cf.node < 100 then
		s := ' '
	else
		s := '';

	if cf.superuser then s := s + 'S' else s := s + 's';
	if cf.sysavail then s := s + 'A' else s := s + 'a';
	if cf.paged then s := s + 'C' else s := s + 'c';
	if cf.sysopnext then s := s + 'N' else s := s + 'n';

	write(s+'l');

	if y = 25 then y := 24;
	window(1, scrty0+1, scrbx, scrby);
	gotoxy(x, y);
	textbackground(ta shr 4);
	textcolor(ta and 15);

	directvideo := false;
end;


function aword(s : string; n : integer; toeol : boolean) : string;
var
	n1, n2 : integer;
	inq : boolean;
	t   : string;
begin
	inq := false;
	while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
		delete(s, 1, 1);

	while (n > 1) do
	begin
		while (s[1] <> ' ') and (s[1] <> #9) and (s[1] <> '"') and (length(s) > 0) do
			delete(s, 1, 1);

		if (s[1] = '"') and (length(s) > 0) then
		begin
			delete(s, 1, 1);
			while (s[1] <> '"') and (length(s) > 0) do
				delete(s, 1, 1);
			delete(s, 1, 1);
		end
		else
		begin
			while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
				delete(s, 1, 1);

			if (s = '') then
			begin
				aword := '';
				exit;
			end;

			dec(n);
		end;
	end;

	if toeol then
	begin
		while pos('"', s) > 0 do
			delete(s, pos('"', s), 1);
		aword := s;
		exit;
	end;

	t := '';

	while ((inq = true) or ((s[1] <> #9) and (s[1] <> ' '))) and (length(s) > 0) do
	begin
		if (s[1] = '"') then
		begin
			delete(s, 1, 1);
			if (inq = true) then
				inq := false
			else
				inq := true;
		end
		else
		begin
			t := t + s[1];
			delete(s, 1, 1);
		end;
	end;

	aword := t;
end;


function ups(s : string) : string;
var
	lp : integer;
begin
	for lp := 1 to length(s) do
		s[lp] := upcase(s[lp]);
	ups := s;
end;

function yn(b : boolean) : string;
begin
	if b then yn := 'Yes' else yn := 'No ';
end;

function ps(n : integer) : string;
begin
	if n <> 1 then ps := 's' else ps := '';
end;


function csn : char;
begin
	slwrite('\CYMore... ');
	init_barmenu;
	add_barmenu('Continue', '');
	add_barmenu('NonStop', '');
	add_barmenu('Stop', '');
	csn := disp_barmenu_1;
	xwrite(#13);
	xclreol;
end;

procedure enteruserline;
begin
	xwrite(#13#10);
end;


begin
	ansi := true;
	LastStatMin := 61;
	indent := 0;
end.
