unit othello;

interface

uses
	dos, xcrt,
	oth_def, oth_gen,
	defs, mogutils, mogfile, mogsend, utils,
	users, message, post, filedef, sublist, general;


function  Othello_Parse(s : string) : boolean;
function  ListMyOthelloGames(prn : boolean) : integer;
procedure OthUpdScr(n : integer);

implementation



procedure OthScrOff;
var
	lp 	: integer;
begin
	for lp := 1 to 15 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xstrwrite(#27'[1r');
end;


procedure OthScrOn;
var
	lp, pp, n	: integer;
begin
	xstrwrite(#27'[15r');

	for lp := 1 to 15 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xgotoxy(1, 1);
	xtextbackground(red);
	xtextcolor(yellow);
	xclreol;
	xgotoxy(64, 1);
	xwrite('MogTalk Othello');

	xgotoxy(1, 14);
	xclreol;
	xgotoxy(57, 14);
	xwrite('MogTalk Teleconference');

	xtextbackground(black);

	xgotoxy(1, 3);
	slwriteln('  \LCPlayer Information'+#13#10+
			  '  \LGWhite:'+#13#10+
			  '    Str:'#13#10+
			  '   Blue:'#13#10+
			  '    Str:'#13#10#10+
			  '  \LCGame Status'#13#10+
			  '   \LGGame:'+#13#10#10+
			  '  State:\WH');

	xgotoxy(29, 2);
	xwrite('a  b  c  d  e  f  g  h');
	xgotoxy(27, 3);
	xwrite('Ŀ');

	for lp := 1 to 4 do
	begin
		xgotoxy(26, 2+lp*2);
		xwrite(strs(10-(lp*2))+'');

		for pp := 1 to 4 do
		begin
			xtextbackground(lightgray);
			xwrite('   ');
			xtextbackground(black);
			xwrite('   ');
		end;
		xwrite(''+strs(10-(lp*2)));

		xgotoxy(26, 3+lp*2);
		xwrite(strs(9-(lp*2))+'');
		for pp := 1 to 4 do
		begin
			xtextbackground(black);
			xwrite('   ');
			xtextbackground(lightgray);
			xwrite('   ');
		end;
		xtextbackground(black);
		xwrite(''+strs(9-(lp*2)));
	end;

	xgotoxy(27, 12);
	xwrite('');

	xgotoxy(29, 13);
	xwrite('a  b  c  d  e  f  g  h');
end;

procedure DisplayInfo(game : gamet);
var
	s 		: string;

  procedure put_s;
  begin
	while length(stripcol(s)) > 15 do
		delete(s, length(s), 1);
	slwrite(s+sp(15-length(stripcol(s))));
  end;

begin
	s := '\LB'+game.player_w;
	xgotoxy(10, 4);
	put_s;

	s := '\WH'+strs(GetStrength(game, PWhite));
	xgotoxy(10, 5);
	put_s;

	s := '\WH'+strs(GetStrength(game, PBlack));
	xgotoxy(10, 7);
	put_s;

	s := '\LB'+game.player_b;
	xgotoxy(10, 6);
	put_s;

	if game.state < Finished then
	begin
		xgotoxy(4, 11);
		slwrite('\LGTurn:');
		if game.turn = PWhite then
			s := '\LB'+game.player_w;
		xgotoxy(10, 11);
		put_s;
	end
	else
	begin
		if game.state in [Drawn] then
		begin
			xgotoxy(4, 11);
			slwrite(sp(22));
		end
		else
		begin
			xgotoxy(4, 11);
			slwrite('\LG Win:');

			if game.winner = PWhite then
				s := '\LB'+game.player_w;
			xgotoxy(10, 11);
			put_s;
		end;
	end;

	s := '\WH'+strs(viewing);
	xgotoxy(10, 10);
	put_s;

	s := '\WH'+states[game.state];
	xgotoxy(10, 12);
	put_s;
end;


function ListMyOthelloGames(prn : boolean) : integer;
var
	sr	: searchrec;
	gr  : gamet;
	s 	: string;
	n	: integer;
begin
	findfirst(cfg.gamedir+'*.OTH', 0, sr);

	n := 0;

	while DosError = 0 do
	begin
		fillchar(gr, sizeof(gr), 0);
		OpenSharedFile(cfg.gamedir+sr.name, IRead+DenyNone);
		{$i-} blockread(sf.f, gr, sizeof(gr)); {$i+}
		CloseSharedFile;

		if gr.state < Finished then
		begin
			s := copy(sr.name, 1, pos('.', sr.name)-1);

			if (gr.player_w = myrec.alias) and (gr.player_b <> '[Open]') then
			begin
				if prn then
				begin
					if gr.turn = pwhite then
						slwriteln('\WH * It is your turn in othello game \LG'+s+'\WH against \LB'+gr.player_b+'\WH.')
					else
						slwriteln('\WH * You are playing in othello game \LG'+s+'\WH against \LB'+gr.player_b+'\WH.');
				end;
				inc(n);
			end;

			if (gr.player_b = myrec.alias) and (gr.player_w <> '[Open]') then
			begin
				if prn then
				begin
					if gr.turn = pblack then
						slwriteln('\WH * It is your turn in othello game \LG'+s+'\WH against \LB'+gr.player_w+'\WH.')
					else
						slwriteln('\WH * You are playing in othello game \LG'+s+'\WH against \LB'+gr.player_w+'\WH.');
				end;
				inc(n);
			end;
		end;

		FindNext(sr);
	end;

	ListMyOthelloGames := n;
end;

function CheckForTooManyGames : boolean;
var
	n : integer;
begin
	CheckForTooManyGames := true;

	n := ListMyOthelloGames(false);
	if ((n >= 1) and (user.access.msglevel < 200)) then
	begin
		slwriteln('\WH * Being an non-donating user, you can play one othello game at a time!');
		slwriteln('   Please read bulletin two which details donation information.');
		exit;
	end;

	if ((n >= 5) and (user.access.msglevel < 254)) then
	begin
		slwriteln('\WH * You can only play in five othello games at one time.');
		exit;
	end;

	CheckForTooManyGames := false;
end;


const mv : array [1..8,1..2] of shortint =
	( (-1, -1), (-1, 0), (-1, 1), (0, -1), (0, 1), (1, -1), (1, 0), (1, 1) );

function IsValidPut(var game : gamet; p : position; c : piece; DispErrors : boolean) : boolean;
var
	np : position;
	nc : piece;
	lp : integer;
	ok : boolean;
begin
	IsValidPut := false;

	if GetP(game, p) <> PNone then
	begin
		if DispErrors then
		begin
			ResetScr;
			slwriteln('\WH * There is already a piece on that square.');
		end;
		exit;
	end;

	ok := false;

	for lp := 1 to 8 do
	begin
		np := p;

		inc(np.x, mv[lp,1]);
		inc(np.y, mv[lp,2]);

		if GetP(game, np) = InvColor(c) then
		begin
			inc(np.x, mv[lp,1]);
			inc(np.y, mv[lp,2]);

			while (np.x in [1..8]) and (np.y in [1..8]) do
			begin
				nc := GetP(game, np);
				if nc = PNone then
					np.y := 100
				else if nc = c then
				begin
					ok := true;
					dec(np.x, mv[lp,1]);
					dec(np.y, mv[lp,2]);
					while (np.x <> p.x) or (np.y <> p.y) do
					begin
						PutP(game, np, c);
						WritePiece(np, c);
						dec(np.x, mv[lp,1]);
						dec(np.y, mv[lp,2]);
					end;
					PutP(game, np, c);
					WritePiece(np, c);
					IsValidPut := true;
					np.x := 100;
				end
				else
				begin
					inc(np.x, mv[lp,1]);
					inc(np.y, mv[lp,2]);
				end;
			end;
		end;
	end;

	if (not ok) and (DispErrors) then
	begin
		ResetScr;
		slwriteln('\WH * That is not a flanking move.');
	end;
end;



var
	g 		: gamet;
	p1 		: position;


procedure OthUpdScr(n : integer);
begin
	if n = viewing then
	begin
		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		GetGame(viewing, g);
		DisplayScreen(g);
		DisplayInfo(g);
		ResetScr;
	end;
end;

function othello_parse(s : string) : boolean;
var
	w1 		: string;
	n, nn	: integer;
	cut	    : cusertype;
begin
	othello_parse := true;

	w1 := aword(s, 1, false);

	if s = '/othello' then
	begin
		enteruserline;
		if inited then
		begin
			SaveScr;
			OthScrOff;
			xwindow(1, 1, scrbx, scrby);
			xgotoxy(sx, sy);

			Inited := false;
			exit;
		end
		else
		begin
			if scrty0 <> 0then
			begin
				slwriteln('\WH * You can only open one game window at a time.');
				exit;
			end;

			SaveScr;
			OthScrOn;
			ResetScr;

			Inited := true;
			exit;
		end;
	end;

	if w1 = '/mine' then
	begin
		ListMyOthelloGames(true);
	end;

	if not inited then
	begin
		othello_parse := false;
		exit;
	end;

	if (w1 = '/put') or ((myuser.accesslvl = 255) and (w1 = '/fput')) then
	begin
		enteruserline;
		if viewing = 0 then
		begin
			slwriteln('\WH * You are not currently playing a game!');
			exit;
		end;

		if w1 = '/put' then
		begin
			if g.state > Finished then
			begin
				slwriteln('\WH * This game has finished.');
				exit;
			end;

			if (myrec.alias <> g.player_w) and
			   (myrec.alias <> g.player_b) then
			begin
				slwriteln('\WH * You are not playing in this game.');
				exit;
			end;

			if ( (g.turn = PWhite) and (g.player_w <> myrec.alias) ) or
			   ( (g.turn = PBlack) and (g.player_b <> myrec.alias) ) then
			begin
				slwriteln('\WH * It is not your turn in this game.');
				exit;
			end;
		end;

		SaveScr;
		xwindow(1, 1, scrbx, scrby);

		s := ups(aword(s, 2, false));

		if (PosTranslate(s, p1) = false) then
		begin
			ResetScr;
			slwriteln('\WH * Illegal coordinate.  Type /othello-help for syntax.');
			exit;
		end;

		if IsValidPut(g, p1, g.turn, true) = false then exit;

		g.turn := InvColor(g.turn);

		PutGame(viewing, g);

		DisplayInfo(g);

		if g.turn = PWhite then
			n := GetUserNode(g.player_w, true)
		else
			n := GetUserNode(g.player_b, true);

		if n > 0 then
			SendThisMsgP('\WH[\LGO'+strs(viewing)+'\WH]'#13#10, 1, n);

		ResetScr;
		SendThisMsgAll('OTH-UPD '+strs(viewing), 5);
		exit;
	end;

	if w1 = '/new' then
	begin
		enteruserline;
		if CheckForTooManyGames then exit;

		if aword(s, 2, true) <> '' then
		begin
			if GetCUserRec(aword(s, 2, true), cut) = false then
				exit;

			CloseSharedFile;

			if myrec.alias = cut.alias then
			begin
				slwriteln('\WH * You can''t have a game against yourself!');
				exit;
			end;

			n := MakeGame(myrec.alias, cut.alias);

			nn := GetUserNode(cut.alias, true);
			if nn > 0 then
			begin
				SendThisMsgP('\WH * User \LG'+myrec.alias+'\WH is challenging you to a game of Othello!'#13#10, 1, nn);
				SendThisMsgP('   Type \LC/view '+strs(n)+'\WH to play.'#13#10, 1, nn);
			end;
		end
		else
			n := MakeGame(myrec.alias, '[Open]');

		slwriteln('\WH * Game number \LG'+strs(n)+'\WH has been created.');

		w1 := '/view';
		s := '/view '+strs(n);
	end;

	if w1 = '/join' then
	begin
		enteruserline;
		if CheckForTooManyGames then exit;

		val(aword(s, 2, false), n, nn);
		if GetGame(n, g) = false then
		begin
			slwriteln('\WH * That game does not exist!');
			exit;
		end;

		if (g.player_w <> '[Open]') and (g.player_b <> '[Open]') then
		begin
			slwriteln('\WH * That game already has two players.');
			exit;
		end;

		if (g.player_w = myrec.alias) or
		   (g.player_b = myrec.alias) then
		begin
			slwriteln('\WH * You can''t have a game against yourself!');
			exit;
		end;

		if g.player_w = '[Open]' then
		begin
			g.player_w := myrec.alias;
			nn := GetUserNode(g.player_b, true);
		end
		else
		begin
			g.player_b := myrec.alias;
			nn := GetUserNode(g.player_w, true);
		end;

		PutGame(n, g);

		if nn > 0 then
			SendThisMsgP('\WH * User \LG'+myrec.alias+'\WH has joined your game number \LG'+strs(n)+'\WH.'#13#10, 1, nn);
		SendThisMsgAll('OTH-UPD '+strs(viewing), 5);

		w1 := '/view';
		s := '/view '+strs(n);
	end;


	if w1 = '/view' then
	begin
		enteruserline;
		val(aword(s, 2, false), n, nn);
		if GetGame(n, g) = false then
		begin
			slwriteln('\WH * That is not a valid Othello game.');
			exit;
		end;
		viewing := n;
		SaveScr;
		xwindow(1, 1, scrbx, scrby);
		DisplayScreen(g);
		DisplayInfo(g);
		ResetScr;
		exit;
	end;


	othello_parse := false;
end;

begin
	fillchar(g, sizeof(g), 0);
end.
