unit output;

interface

uses	dos, xcrt,
		general, filedef, users, mdefs, fossil, modem, multi,
		slnter, slenter, utils, slfn;

function  csn : char;

procedure slwrite(s : string);
procedure slwriteln(s : string);
procedure slextwrite(s : string; ext, wrap : boolean);

procedure wrapwrite(s : string);

function  stripcol(s : string) : string;

function  SLWriteFile(name : string) : boolean;
function  PrintFile(s : string; report : boolean) : boolean;

function  slc(n : word) : string;

const
	colcol  : array [1..16] of byte = ( BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, BROWN, LIGHTGRAY, DARKGRAY, LIGHTBLUE,
						LIGHTGREEN, LIGHTCYAN, LIGHTRED, YELLOW, LIGHTMAGENTA, WHITE );
	colname : array [1..19] of string[4] = ('BK', 'BL', 'GR', 'CY', 'RD', 'MG', 'BR', 'GY', 'DG', 'LB', 'LG', 'LC', 'LR',
						'YE', 'LM', 'WH', 'BI', 'NO', 'IV' );


var
	indent	: integer;


implementation

function stripcol(s : string) : string;
var
	lp, pp 	: integer;
	t 		: string;
begin
	lp := 1;
	while lp <= length(s) do
	begin
		if s[lp] = '\' then
		begin
			if s[lp+1] in ['0'..'9'] then
			begin
				delete(s, lp, 4);
				continue;
			end;

			if s[lp+1] = '&' then
			begin
				delete(s, lp, 3);
				continue;
			end;

			t := copy(s, lp+1, 2);
			upstr(t);
			for pp := 1 to 19 do
			begin
				if colname[pp] = t then
				begin
					delete(s, lp, 3);
					dec(lp, 1);
				end;
			end;
		end;
		inc(lp);
	end;

	stripcol := s;
end;


procedure wrapwrite(s : string);
var
	lp, pp, x	: integer;
	quit		: boolean;
begin
	lp := 1;
	x := xwherex;

	while (lp < length(s)) do
	begin
		if s[lp] = #13 then
		begin
			xwrite(copy(s, 1, lp+1));
			delete(s, 1, lp+1);
			lp := 1;
			x := 1;
		end
		else
		begin
			quit := false;

			if lp + x >= scrbx then
			begin
				for pp := lp downto 1 do
				begin
					if s[pp] = ' ' then
					begin
						xwrite(copy(s, 1, pp-1)+#13#10+sp(indent));
						delete(s, 1, pp);
						pp := 1;
						quit := true;
					end;
				end;

				if not quit then
				begin
					xwrite(copy(s, 1, lp)+#13#10+sp(indent));
					delete(s, 1, lp);
				end;

				lp := 1;
				x := 1 + indent;
			end
			else
				inc(lp);
		end;
	end;

	xwrite(s);
end;


procedure slextwrite(s : string; ext, wrap : boolean);
const nportrate : array [bNone..b230k] of longint =
	( 0, 150, 300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 57600,
		 115200, 230400 );

var
	n, lp 	: integer;
	p		: string;
	isc		: boolean;
begin
	while length(s) > 0 do
	begin
		n := pos('\', s);
		if n = 0 then
		begin
			if wrap then
				wrapwrite(s)
			else
				xwrite(s);
			if xtextattr shr 4 > 0 then
				xtextbackground(black);
			exit;
		end;

		if wrap then
			wrapwrite(copy(s, 1, n-1))
		else
			xwrite(copy(s, 1, n-1));

		delete(s, 1, n-1);

		if copy(s, 2, 1) = '=' then
		begin
			p := copy(s, 3, 3);
			val(p, n, lp);
			extextcolor(xtextattr and 15, n);
			delete(s, 1, 4);
			exit;
		end;

		p := copy(s, 2, 2);
		upstr(p);

		isc := false;

		for lp := 1 to 16 do
		begin
			if colname[lp] = p then
			begin
				xtextcolor(colcol[lp]);
				isc := true;
			end;
		end;

		if p = 'BI' then
		begin
			xtextcolor(xtextattr and 15 + blink);
			isc := true;
		end;

		if p = 'NO' then
		begin
			xtextcolor(cf.colorchart[NORMAL]);
			xtextbackground(black);
			isc := true;
		end;

		if p = 'IV' then
		begin
			xtextbackground(xtextattr and 15);
			xtextcolor(black);
			isc := true;
		end;

		if ext then
		begin
			if p = 'SB' then
			begin
				xwrite(cf.currsub);
				isc := true;
			end;

			if p = 'FD' then
			begin
				xwrite(cf.currdir);
				isc := true;
			end;

			if p[1] = '%' then
			begin
				isc := true;
				case p[2] of
				  'A':  xwrite(strs(user.access.msglevel));
				  'B':  xwrite(strs(nportrate[cf.lockedbaud]));
				  'C':  if cf.sysavail then xwrite('Y') else xwrite('N');
				  'D':  xwrite(cf.currdir);
				  'E':  xwrite(strs(cf.node));
				  'F':  xwrite(strs(user.access.filelevel));
				  'G':  if not cf.ansi then xwrite('N') else begin
							 if cf.color then xwrite('C') else xwrite('M') end;
				  'H':  xwrite(cf.currsub);
				  'I':  if user.alias <> '' then xwrite(user.alias)
											else xwrite(user.name);
				  'J':  if user.alias <> '' then xwrite(undersc(user.alias))
											else xwrite(undersc(user.name));
				  'K':  xwrite(NameCaps(user.name));
				  'L':  ; { system time hh:mm }
				  'M':  xwrite(strs(cf.timelimit-GetTimeOnline));
				  'N':  xwrite(user.name);
				  'O':  xwrite(strs(cf.node));
				  'P':  xwrite(strs(cf.comport));
				  'R':  xwrite(strs(cf.baudrate));
				  'S':  xwrite(cf.systemname);
				  'T':  xwrite(strs(user.access.timelimit));
				  'U':  xwrite(undersc(user.name));
				  'X':  if cf.isalias then xwrite(user.alias)
									  else xwrite(user.name);
				  'Y':  if cf.isalias then xwrite(undersc(user.alias))
									  else xwrite(undersc(user.name));
				else
					isc := false;
				end;
			end;
		end;

		if isc = false then
			xwrite('\'+copy(s, 2, 2));

		delete(s, 1, 3);
	end;

	if xtextattr shr 4 > 0 then
		xtextbackground(black);
end;

procedure slwrite(s : string);
begin
	slextwrite(s, false, true);
end;

procedure slwriteln(s : string);
begin
	slwrite(s+#13#10);
end;


function timeon : word;
var
	h,m,s,hs : word;
	a, b : word;
begin
	gettime(h, m, s, hs);
	a := h * 60 + m;
	b := cf.logtime.hour * 60 + cf.logtime.minute;

	if (a < b) then
		inc(a, 1440);

	timeon := a - b;
end;


function csn : char;
begin
	slwrite('\CYMore... ');
	init_barmenu;
	add_barmenu('Continue', '');
	add_barmenu('NonStop', '');
	add_barmenu('Stop', '');
	csn := disp_barmenu_1;
	xwrite(#13);
	xclreol;
end;


{


var LastStatMin : word;

procedure status;
var
	x, y		: word;
	ta 			: byte;
	s			: string;
begin
	gettime(x, y, x, x);
	if y = LastStatMin then
		exit;
	LastStatMin := y;

	directvideo := true;

	x := wherex;
	y := wherey;

	ta := textattr;

	window(1,1,80,25);
	gotoxy(1,25);
	textbackground(cf.colorchart[BACKGROUND]);
	textcolor(cf.colorchart[INVERSE]);
	clreol;
	write(' User: ',user.name);

	gotoxy(34, 25);
	write('Access: ',user.access.msglevel:3,'/',user.access.filelevel:3);
	write('  Time:',timeon:4,'/',cf.timelimit:4);

	write(' Node ',cf.node);

	if cf.node < 10 then
		s := '  '
	else if cf.node < 100 then
		s := ' '
	else
		s := '';

	if cf.superuser then s := s + 'S' else s := s + 's';
	if cf.sysavail then s := s + 'A' else s := s + 'a';
	if cf.paged then s := s + 'C' else s := s + 'c';
	if cf.sysopnext then s := s + 'N' else s := s + 'n';

	write(s+'l');

	if y = 25 then y := 24;
	window(1, scrty, scrbx, scrby);
	gotoxy(x, y);
	textbackground(ta shr 4);
	textcolor(ta and 15);

	directvideo := false;
end;
}

function SLWriteFile(name : string) : boolean;
var
	fptr	: text;
	s		: string;
begin
	SLWriteFile := false;

	assign(fptr, name);
	{$i-} reset(fptr); {$i+}
	if ioresult <> 0 then
		exit;

	xtextcolor(cf.colorchart[NORMAL]);

	while not eof(fptr) do
	begin
		readln(fptr, s);
		slextwrite(s+#13#10, true, false);
	end;

	close(fptr);
	SLWriteFile := true;
end;

function slc(n : word) : string;
var
	lp : integer;
begin
	if n > 16 then n := cf.colorchart[NORMAL];

	for lp := 1 to 16 do
	begin
		if colcol[lp] = n then
		begin
			slc := '\'+colname[lp];
			exit;
		end;
	end;
end;

function PrintFile(s : string; report : boolean) : boolean;
var
	fn 		: string;
	result	: boolean;
begin
	fn := aword(s, 1, false);

	if fn[1] = '@' then
	begin
		delete(fn, 1, 1);
		fn := cf.textpath + fn;
	end;

	if fn[1] = '%' then
	begin
		delete(fn, 1, 1);
		fn := cf.incpath + fn;
	end;

	if pos('.', fn) = 0 then
	begin
		if cf.ansi then
		begin
			if SLWriteFile(fn+'.ANS') = false then
				result := SLWriteFile(fn+'.TXT');
		end
		else
			result := SLWriteFile(fn+'.TXT');
	end
	else
		result := SLWriteFile(fn);

	if (result = false) and report then
	begin
		xtextcolor(cf.colorchart[ERRCOLOR]);
		xwriteln('[file '+fn+' not found]');
	end;

	PrintFile := result;
end;


begin
	ansi := true;
	{LastStatMin := 61;}
	indent := 0;
end.
