unit recent;

interface

uses
	dos, xcrt,
	utils, slenter, slgen, output, scr, filedef, statlog, dtime;

procedure RecentCalls(double : boolean; putn : integer);

implementation

type
	syslogdb = record
		rah			: char;
		progid		: array [0..7] of char;
		user		: array [0..24] of char;
		node		: array [0..3] of char;
		date		: array [0..7] of char;
		time		: array [0..4] of char;
		res1,
		res2,
		res3,
		res4		: array [0..3] of char;
		action		: char;
		msg			: array [0..59] of char;
	end;

	mtrace = record
		time		: string[5];
		date		: string[8];
		use			: boolean;
		name		: string[25];
	end;

	reclog = record
		name		: string[25];
		node		: integer;
		ontime		: string[5];
		ondate		: string[8];
		offtime		: string[5];
		offdate		: string[8];
		sort		: longint;
	end;


function fromsp(p : array of char; n : integer) : string;
var
	s  : string;
	lp : integer;
begin
	s := '';

	for lp := 0 to n-1 do
	begin
		{ programming is bad }

		s := s + p[lp];
	end;

	while (s[length(s)] = #32) do
		dec(s[0]);

	while (s[0] > #0) and (s[1] = #32) do
		delete(s, 1, 1);

	fromsp := s;
end;


const
	timen = 50;
	maxputn = 150;

var
	lp, pp		: integer;
	l, fp, ll  	: longint;
	p, n		: word;
	s, progid, ss	: string;
	dd, dm, dy	: word;
	rln			: integer;

	sld  	: array [1..timen] of syslogdb;
	mt   	: array [1..20] of mtrace;
	rl      : array [1..maxputn] of reclog;
	rlt		: reclog;
	fptr 	: file;



procedure PutCallers;
var
  fptr 			: file;
  slt			: statlogtype;
begin
	filemode := $42;
	assign(fptr, cf.datapath+'STATLOG.SL2');
	{$i-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		blockread(fptr, slt, sizeof(slt));
		close(fptr);
	end;

	slwriteln('\GYThere have been \WH'+strs(slt.data[1,1])+'\GY callers today.  The time is \WH'+
		StrTimeT(time mod 86400)+'\GY on \WH'+StrDateT(time)+'\GY.'#10);
end;



procedure RecentCalls(double : boolean; putn : integer);
var
  today : boolean;
begin
	if putn > maxputn then
	begin
		slwriteln('\WH * You cannot view that many callers.');
		exit;
	end;

	filemode := $42;
	assign(fptr, cf.datapath+'SYSLOG.DBF');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		exit;

	PutHeading(cf.systemname+'''s last '+strs(putn)+' callers', double);

	PutCallers;

	getdate(dy, dm, dd, n);
	s := strs4(dy) + strs2(dm) + strs2(dd);
	for lp := 1 to 20 do
	begin
		mt[lp].time := '     ';
		mt[lp].date := s;
		mt[lp].use := true;
		mt[lp].name := '';
	end;

	p := 0;
	rln := 1;

	fp := filesize(fptr);

	while rln <= putn do
	begin
		if fp = 0 then break;

		dec(fp, timen * sizeof(syslogdb));
		if fp < 0 then fp := 0;

		seek(fptr, fp);
		blockread(fptr, sld, timen * sizeof(syslogdb), lp);

		for lp := timen downto 1 do
		begin
			val(fromsp(sld[lp].node, 4), l, n);

			if fromsp(sld[lp].progid, 8) = 'LOGMGR' then
				mt[l].name := fromsp(sld[lp].msg, 60);

			if sld[lp].action = 'F' then
			begin
				mt[l].time := fromsp(sld[lp].time, 5);
				mt[l].date := fromsp(sld[lp].date, 8);
				mt[l].use := true;
				mt[l].name := '';
			end;

			if (sld[lp].action = 'O') and mt[l].use then
			begin
				if pos('+', fromsp(sld[lp].msg, 60)) = 0 then
				begin
					s := fromsp(sld[lp].date, 8);
					s := copy(s, 7, 2) + '/' + copy(s, 5, 2);

					if fromsp(sld[lp].progid, 8) = 'MOGTALK' then
						rl[rln].name := fromsp(sld[lp].msg, 60)
					else
					begin
						if mt[l].name <> '' then
							rl[rln].name := NameCaps(mt[l].name)
						else
							rl[rln].name := NameCaps(fromsp(sld[lp].user, 25));
					end;

					rl[rln].offdate := s;
					rl[rln].offtime := mt[l].time;
					rl[rln].ondate := s;
					rl[rln].ontime := fromsp(sld[lp].time, 5);
					rl[rln].node := l;

					if rl[rln].offtime = '     ' then
					begin
						s := mt[l].date;
						ss := rl[rln].ontime;
						ll := $ffffff;
					end
					else
					begin
						ss := rl[rln].offtime;
						ll := 0;
					end;

					rl[rln].sort := ll +
						vals(copy(s, 4, 2)) * 1440 * 32 +
						vals(copy(s, 1, 2)) * 1440 +
						vals(copy(ss, 1, 2)) * 60 +
						vals(copy(ss, 4, 2));

					inc(rln);
				end;

				mt[l].use := false;
				mt[l].name := '';
			end;

			if rln > putn then break;
		end;
	end;
	close(fptr);

	for lp := 1 to putn do
	begin
		n := lp;
		l := rl[n].sort;

		for pp := lp to putn do
		begin
			if l < rl[pp].sort then
			begin
				n := pp;
				l := rl[pp].sort;
			end;
		end;

		if n <> lp then
		begin
			move(rl[lp], rlt, sizeof(reclog));
			move(rl[n], rl[lp], sizeof(reclog));
			move(rlt, rl[n], sizeof(reclog));
		end;
	end;

	for lp := 1 to putn do
	begin
		with rl[lp] do
			slwriteln('   \GY'+strs2(node)+'  \WH'+name+'  \DG'+spc(25-length(name), '.')+'  \GY'+ondate+'   '+
				ontime+'  '+offtime);

		if (lp+2) mod 22 = 0 then
		begin
			slwrite('\NOMore... ');
			if BarDisplayList('Continue Stop') = 'S' then
			begin
				xwrite(#13);
				xclreol;
				break;
			end;

			xwrite(#13);
			xclreol;
		end;
	end;
end;

end.

