unit slenter;

interface

uses
	filedef, general, utils, xcrt;


type
	MenuItem = record
		title	: string[30];
		desc	: string[80];
		keypos	: byte;
		hot		: char;
	end;

	ScrMenuType = object
		items	: array [1..64] of MenuItem;
		nitems	: byte;

		pos		: byte;


		procedure AddItemH(t, d : string; h : char);
		procedure AddItem(t, d : string);

		function  DisplayList(s : string) : char;

		function  Display : char; virtual;

		procedure Init;

		constructor ct;
	end;

	BarMenuType = object(ScrMenuType)

		displine2	: boolean;

		function  Display : char; virtual;

		function  DisplayTTY : char;
		function  DisplayANSI : char;
		procedure DisplayItem(poss, lp : byte);

		constructor ct;
	end;

	CharMenuType = object(ScrMenuType)
		AllowEnter	: boolean;

		function  Display : char; virtual;

		constructor ct;
	end;


	WordMenuType = object(CharMenuType)

		startx 		: integer;

		procedure DisplayItem;
		function  Display : char; virtual;

		constructor ct;
	end;


const
	updownkeys = [#72,#80];


function getlinep(init : string; maxlen : integer;
		  allcaps, path, updown : boolean;
		  min,max : longint; var ret : word;
		  ungetch : char; extended : boolean; pw : boolean) : string;

function getline(init:string; maxlen : integer; allcaps, path : boolean) : string;

procedure TextHigh;
procedure TextLow;


function BarDisplayList(s : string) : char;


var
	Ansi		: boolean;


implementation

constructor WordMenuType.ct;
begin
end;

constructor ScrMenuType.ct;
begin
end;

constructor BarMenuType.ct;
begin
	DispLine2 := true;
end;

constructor CharMenuType.ct;
begin
end;


procedure ScrMenuType.Init;
begin
	fillchar(items, sizeof(MenuItem)*25, 0);
	nitems := 0;
	pos := 1;
end;

procedure ScrMenuType.AddItem(t, d : string);
var
	lp, pp	 : integer;
	hot		 : char;
	free	 : set of char;
begin
	hot := #0;

	free := [ '!'..'`', '{'..'~', #128..#255 ];

	for lp := 1 to nitems do
		free := free - [items[lp].hot];

	for lp := 1 to length(t) do
	begin
		if t[lp] in free then
		begin
			hot := t[lp];
			lp := length(t);
		end;
	end;

	if hot = #0 then
	begin
		for lp := 1 to length(t) do
		begin
			if upcase(t[lp]) in free then
			begin
				hot := upcase(t[lp]);
				lp := length(t);
			end;
		end;
	end;

	AddItemH(t, d, hot);
end;


procedure ScrMenuType.AddItemH(t, d : string; h : char);
var
	lp : integer;
begin
	inc(nitems);

	h := upcase(h);
	with items[nitems] do
	begin
		title := t;
		desc := d;
		hot := h;
		keypos := 0;

		if hot <> #0 then
		begin
			upstr(t);
			h := upcase(h);
			for lp := 1 to length(t) do
			begin
				if t[lp] = h then
				begin
					keypos := lp;
					lp := length(t);
				end;
			end;
		end;
	end;
end;

function ScrMenuType.DisplayList(s : string) : char;
var
	lp : integer;
begin
	lp := 1;
	while aword(s, lp, false) <> '' do
	begin
		AddItem(aword(s, lp, false), '');
		inc(lp);
	end;

	DisplayList := Display;
end;


function ScrMenuType.Display : char;
begin
	Display := #0;
end;


function BarMenuType.Display : char;
begin
	if nitems = 0 then
	begin
		Display := #0;
		exit;
	end;

	if Ansi = False then
		Display := DisplayTTY
	else
		Display := DisplayANSI;
end;


function BarMenuType.DisplayTTY : char;
var
	lp			: byte;
	ch 			: char;
begin
	lp := 1;
	for lp := 1 to nitems do
	begin
		xwrite(copy(items[lp].title, 1, items[lp].keypos-1)+
			   '('+
			   items[lp].title[items[lp].keypos]+
			   ')'+
			   copy(items[lp].title, items[lp].keypos+1, 100));

		if lp <> nitems then
			xwrite(', ');
	end;
	xwrite(' ? ');

	while true do
	begin
		ch := upcase(xreadkey);

		if (ch = #27) then
		begin
			pos := nitems;
			DisplayTTY := items[nitems].hot;
			xwriteln(items[nitems].hot);
			exit;
		end;

		lp := 1;
		for lp := 1 to nitems do
		begin
			if (items[lp].hot = ch) then
			begin
				pos := lp;
				DisplayTTY := ch;
				xwriteln(ch);
				exit;
			end;
		end;
	end;
end;



procedure BarMenuType.DisplayItem(poss, lp : byte);
var
	x 		: word;
begin
	if (poss = lp) then
	begin
		xtextbackground(cf.colorchart[BACKGROUND]);
		xtextcolor(cf.colorchart[INVERSE]);
		xwrite(' '+items[lp].title+' ');
		xtextbackground(black);

		if displine2 then
		begin
			x := xwherex;
			xwriteln('');
			xtextcolor(cf.colorchart[SPECIAL]);
			xwrite(items[lp].desc);
			xclreol;
			xgotoxy(x,xwherey-1);
		end;
	end
	else
	begin
		xwrite(' ');
		if (items[lp].keypos = 1) then
		begin
			xtextcolor(cf.colorchart[SPECIAL]);
			xwrite(items[lp].title[1]);
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(items[lp].title, 2, 100));
		end
		else
		begin
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(items[lp].title, 1, items[lp].keypos-1));
			xtextcolor(cf.colorchart[SPECIAL]);
			xwrite(items[lp].title[items[lp].keypos]);
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(items[lp].title, items[lp].keypos+1, 100));
		end;
		xwrite(' ');
	end;
end;



function BarMenuType.DisplayANSI : char;
var
	lp 			: byte;
	ch			: char;
	d, startx	: word;
	ota			: word;
begin
	startx := xwherex;
	ota := xtextattr and 15;

	d := startx;
	for lp := 1 to nitems do
	begin
		DisplayItem(pos, lp);
		if lp <= pos then
			d := d + length(items[lp].title) + 2;
	end;

	xgotoxy(d, xwherey);

	while true do
	begin
		ch := upcase(xreadkey);
		case ch of
		  #0:
		  begin
			ch := xreadkey;

			case ch of
			  #77:
			  begin
				inc(pos);
				xgotoxy(xwherex-length(items[pos-1].title)-2, xwherey);
				DisplayItem(pos, pos-1);

				if pos > nitems then
				begin
					pos := 1;
					xgotoxy(startx,xwherey);
				end;

				DisplayItem(pos, pos);
			  end;

			  #75,#15:
			  begin
				dec(pos);
				xgotoxy(xwherex-length(items[pos+1].title)-2, xwherey);
				DisplayItem(pos+2, pos+1);

				if pos = 0 then
				begin
					d := startx;
					for lp := 1 to nitems-1 do
						inc(d, length(items[lp].title)+2);

					pos := nitems;
					xgotoxy(d, xwherey);
				end
				else
					xgotoxy(xwherex-length(items[pos+1].title)-length(items[pos].title)-4, xwherey);

				DisplayItem(pos, pos);
			  end;
			end;

			ch := #0;
		  end;

		  #32,#9:
		  begin
			inc(pos);
			xgotoxy(xwherex-length(items[pos-1].title)-2, xwherey);
			DisplayItem(pos, pos-1);
					if pos > nitems then
			begin
				pos := 1;
				xgotoxy(startx,xwherey);
			end;

			DisplayItem(pos, pos);
		  end;

		  #13:
		  begin
			DisplayANSI := items[pos].hot;
			if DispLine2 then
			begin
				xwriteln('');
				xclreol;
			end;
			xtextcolor(ota);
			exit;
		  end;

		  #27: 	ch := items[nitems].hot;
		end;

		if ch > #31 then
		begin
			for lp := 1 to nitems do
			begin
				if items[lp].hot = ch then
				begin
					xgotoxy(xwherex-length(items[pos].title)-2, xwherey);
					DisplayItem(0, pos);

					pos := lp;
					d := startx;
					for lp := 1 to pos-1 do
						inc(d, length(items[lp].title)+2);
					xgotoxy(d, xwherey);
					DisplayItem(pos, pos);

					if DispLine2 then
					begin
						xwriteln('');
						xclreol;
					end;

					xtextcolor(ota);

					DisplayANSI := ch;
					exit;
				end;
			end;
		end;
	end;
end;

function CharMenuType.Display : char;
var
	ch		: char;
	lp		: integer;
begin
	if nitems = 0 then
	begin
		Display := #0;
		exit;
	end;

	while true do
	begin
		ch := upcase(xreadkey);

		case ch of
		  #0:	xreadkey;

		  #13:
		  begin
			if AllowEnter then
			begin
				Display := #13;
				exit;
			end;
		  end;

		  else
		  begin
			for lp := 1 to nitems do
			begin
				if items[lp].hot = ch then
				begin
					xwriteln(ch);
					pos := lp;
					Display := ch;
					exit;
				end;
			end;
		  end;
		end;
	end;
end;

procedure WordMenuType.DisplayItem;
var
	x : integer;
begin
	xgotoxy(startx, xwherey);
	xtextbackground(cf.colorchart[BACKGROUND]);
	xtextcolor(cf.colorchart[INVERSE]);
	xwrite(' '+items[pos].title+' ');
	xtextbackground(black);
	xclreol;
	x := xwherex;

	xwrite(#13#10);
	xtextcolor(cf.colorchart[SPECIAL]);
	xwrite(items[pos].desc);
	xclreol;
	xgotoxy(x, xwherey-1);
end;

function WordMenuType.Display : char;
var
	ch		: char;
	lp		: integer;
begin
	if Ansi = false then
	begin
		Display := CharMenuType.Display;
		exit;
	end;

	startx := xwherex;

	DisplayItem;

	while true do
	begin
		ch := upcase(xreadkey);

		case ch of
		  #0:
		  begin
			ch := xreadkey;
			case ch of
			  #77,#80:
			  begin
				inc(pos);
				if pos > nitems then pos := 1;
				DisplayItem;
			  end;

			  #75,#72:
			  begin
				dec(pos);
				if pos = 0 then pos := nitems;
				DisplayItem;
			  end;
			end;
		  end;

		  #13:
		  begin
			Display := items[pos].hot;
			xwriteln('');
			xclreol;
			exit;
		  end;

		  #32:
		  begin
			inc(pos);
			if pos > nitems then pos := 1;
			DisplayItem;
		  end;

		  else
		  begin
			for lp := 1 to nitems do
			begin
				if items[lp].hot = ch then
				begin
					pos := lp;
					DisplayItem;
					lp := nitems;
				end;
			end;
		  end;
		end;
	end;
end;


function dot(n : integer) : string;
var
	s : string;
begin
	s := '';
	while n > 0 do
	begin
		s := s + '.';
		dec(n);
	end;

	dot := s;
end;


function getlinep(init : string; maxlen : integer;
		  allcaps, path, updown : boolean;
		  min,max : longint; var ret : word;
		  ungetch : char; extended : boolean; pw : boolean) : string;
var
	s  			: string;
	x  			: integer;
	ch 			: char;
	oa 			: word;
	sx, sy 		: word;
	li 			: longint;
	ug 			: char;
	fcp			: boolean;

begin
	ret := 1;
	oa := xtextattr;
	s := '';
	sx := xwherex;  sy := xwherey;

	xwrite(sp(maxlen));

	x := 0;
	fcp := true;

	if (extended) then
	begin
		xgotoxy(sx, sy);
		xwrite(init);
		s := init;
		fcp := false;
	end;

	repeat
		xgotoxy(x+sx, sy);
		if ungetch <> #0 then
		begin
			if extended then ch := #0
			else
			begin
				ch := ungetch;
				ungetch := #0;
			end;
		end
		else
			ch := xreadkey;

		if XCarrierDetect = false then
		begin
			getlinep := '';
			exit;
		end;

		case ch of
		  #0:
		  begin
			if (ungetch <> #0) then
			begin
				ch := ungetch;
				ungetch := #0;
			end
			else
				ch := xreadkey;

			case ch of
			  #79:	x := length(s);
			  #71:	x := 0;

			  #60:
			  begin
					xgotoxy(sx, sy);
					xwrite(init);
					s := init;
					for x := length(init) to maxlen do
						xwrite(' ');
					x := length(init);
			  end;

			  #75:  if (x > 0) then dec(x);
			  #77: 	if (x < length(s)) then inc(x);
			  #83:	if (x < length(s)) then
					begin
						delete(s, x+1, 1);
						if pw then
							xwrite(dot(length(copy(s,x+1,255)))+' ')
						else
							xwrite(copy(s, x+1, 255)+' ');
					end;

			  #72,#80:
			  if (updown) then
			  begin
					ret := word(ch);
					ch := #13;
			  end;
		  end;
		end;

		#8:
			if (x > 0) then
			begin
				dec(x);
				delete(s, x+1, 1);
				if pw then
					xwrite(#8+dot(length(copy(s,x+1,255)))+' ')
				else
					xwrite(#8+copy(s, x+1, 255)+' ');
			end;

		#27:
		begin
			ret := 27;
			s := init;
			ch := #13;
		end;

		' '..'~':
		begin
			if ( (not path) or ((ch in ['!'..'}']) and not (ch in ['*','?','|','+',';','<','>']))) and
				( (max = 0) or (ch in ['0'..'9','-']) ) then
			begin
				if not fcp then
				begin
					s := '';
					xwrite(sp(maxlen));
					xgotoxy(sx, sy);
				end;

				if length(s) >= maxlen then
					continue;

				if allcaps then
					ch := upcase(ch);
				if pw then
					xwrite('.')
				else
					xwrite(ch);
				inc(x);
				if (length(s) > x) then
				begin
					if pw then
						xwrite(dot(length(copy(s,x,255))))
					else
						xwrite(copy(s, x, 255));
				end;
				s := copy(s, 1, x-1) + ch + copy(s, x, 255);
			end;
		end;
	  end;

	  fcp := true;

	until ch = #13;

	if (max > 0) then
	begin
		val(s, li, x);
		if li > max then
			str(max, s);
		if li < min then
			str(min, s);
	end;

	xgotoxy(sx, sy);

	if pw then
		xwrite(dot(length(s)))
	else
		xwrite(s);

	xwrite(sp(maxlen-length(s)));

	getlinep := s;
end;

function getline(init : string; maxlen : integer; allcaps, path : boolean) : string;
var ret : word;
begin
	getline := getlinep(init, maxlen, allcaps, path, false, 0, 0, ret, #0, false, false);
end;

function BarDisplayList(s : string) : char;
var
	b : ^BarMenuType;
begin
	new(b, ct);
	b^.init;
	b^.displine2 := false;
	BarDisplayList := b^.DisplayList(s);
	Dispose(b);
end;


procedure TextHigh;
begin
	xtextbackground(cf.colorchart[BACKGROUND]);
	xtextcolor(cf.colorchart[INVERSE]);
end;

procedure TextLow;
begin
	xtextbackground(black);
	xtextcolor(cf.colorchart[NORMAL]);
end;


begin
	Ansi := true;
end.
