unit slfn;

interface

uses
	dos, xcrt,
	utils,
	filedef, users, general;


function  UserLogin(user : usertype; upos : longint) : boolean;
function  GetTimeOnline : word;
function  pattrib(a : attribset) : string;
procedure PrintHeading(s : string);
function  strtodate(d : datetype) : string;
function  datetostr(s : string; var date : datetype) : boolean;
function  IsValidDate(date : datetype) : boolean;

implementation


var
	timelimit	: word;


function pattrib(a : attribset) : string;
var
 lp : integer;
 s  : string;
 st : integer;
begin
	s := '';
	st := 0;

	for lp := 1 to 25 do
	begin
		if lp in a then
		begin
			if st = 0 then
			begin
				st := lp;
				s := s + ',' + chr(lp+64);
			end;
		end
		else
		begin
			if st <> 0 then
			begin
				st := 0;
				s := s + '-' + chr(lp+63);
			end;
		end;
	end;

	delete(s, 1, 1);
	pattrib := s;
end;

function UserLogin(user : usertype; upos : longint) : boolean;
var
	d, m, y, w 		: word;

begin
	UserLogin := false;

	getdate(y, m, d, w);
	y := y - 1900;

	if (y <> user.laston.year) or (m <> user.laston.month) or (d <> user.laston.day) then
	begin
		user.laston.year := y;
		user.laston.month := m;
		user.laston.day := d;

		if (cf.usesession = true) then
			user.timeleft := user.access.sesslimit
		else
			user.timeleft := user.access.timelimit;

		gettime(y, m, d, w);
		user.lasttime.hour := y;
		user.lasttime.minute := m;

		writeuser(user, upos);
	end;

	timelimit := user.timeleft;

	if (cf.usesession = true) and (user.access.sesslimit < timelimit) then
		timelimit := user.access.sesslimit;

	if timelimit = 1 then timelimit := 0;

	UserLogin := true;
end;



function GetTimeOnline : word;
var
	h, m, a, b : word;
begin
	gettime(h, m, a, a);
	a := h * 60 + m;
	b := cf.logtime.hour * 60 + cf.logtime.minute;

	if (a < b) then
		inc(a, 1440);

	GetTimeOnline := a - b;
end;


procedure PrintHeading(s : string);
var
	ss : string;
	lp : integer;
begin
	xclrscr;
	xtextcolor(cf.colorchart[HEADCOLOR]);
	ss := '';
	for lp := 1 to length(s) do
		ss := ss + s[lp] + ' ';

	xgotoxy((80-length(ss)) div 2, 1);
	xwriteln(ss);
	xtextcolor(cf.colorchart[NORMAL]);
end;

function strtodate(d : datetype) : string;
var
  n : integer;
begin
	n := d.year;
	if n > 0 then
		inc(n, 1900);

	if cf.dateformat = 0 then
		strtodate := strs(d.month)+'-'+strs2(d.day)+'-'+strs4(n)
	else
		strtodate := strs(d.day)+'/'+strs2(d.month)+'/'+strs4(n);
end;


function IsValidDate(date : datetype) : boolean;
const
	monlen : array [1..12] of byte
		= ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
begin
	IsValidDate := false;

	if ( (date.day = 0) and (date.month = 0) and (date.year = 0) ) or
	   ( (date.day > 0) and (date.month > 0) and (date.year > 90) and
		 (date.month <= 12) ) then
	begin
		if (date.day <= monlen[date.month]) or
		   ( (date.month = 2) and (date.year mod 4 = 0) and (date.day = 29) ) then
			IsValidDate := true;
	end;
end;


function datetostr(s : string; var date : datetype) : boolean;
var
	t : string;
	n : integer;
begin
	dosdate(date);

	while pos('-', s) > 0 do
		s[pos('-', s)] := '/';

	if s = '0' then
	begin
		date.day := 0;
		date.month := 0;
		date.year := 0;
	end
	else if pos('/', s) = 0 then
	begin
		date.day := vals(s);
	end
	else
	begin
		t := copy(s, 1, pos('/', s)-1);
		delete(s, 1, length(t)+1);

		date.day := vals(t);

		if pos('/', s) = 0 then
		begin
			date.month := vals(s);
		end
		else
		begin
			t := copy(s, 1, pos('/', s)-1);
			delete(s, 1, length(t)+1);

			date.month := vals(t);
			n := vals(s);
			if n >= 1900 then dec(n, 1900);
				date.year := n;
		end;
	end;

	datetostr := IsValidDate(date);
end;



begin
	TimeLimit := 0;
end.
