unit slgen;

interface

uses
	crt, dos,
	utils, slfn, slmem, lng,
	filedef, users;

var
	TimeIsUp		: boolean;



procedure ForceStatusRewrite;
procedure TurnOffStatus;
procedure WriteStatus;


var
	Lang		: TLang;



implementation


{ ********************************************************************* }

type
	scrptrt		= array [0..1999] of word;

var
	oldexitproc : pointer;
	OldInt1C 	: procedure;
	scrptr		: ^scrptrt;

	LastStatusWrite	 : word;



procedure ForceStatusRewrite;
begin
	LastStatusWrite := 62;
end;



var
	a, b, c		: word;
	status_bg	: word;
	s, s2		: string;
	lp			: integer;

procedure WriteStatus;
begin
	gettime(a, b, c, c);
	if b = LastStatusWrite then
		exit;

	LastStatusWrite := b;

	a := a * 60 + b;
	b := cf.logtime.hour * 60 + cf.logtime.minute;

	if (a < b) then
		inc(a, 1440);

	a := a - b;


	s := ' User: '+user.name;

	for lp := length(user.name) to 25 do
		s := s + ' ';

	s := s + 'Access: ';

	str(user.access.msglevel : 3, s2);
	s := s + s2 + '/';

	str(user.access.filelevel : 3, s2);
	s := s + s2 + '  Time:';

	str(a : 4, s2);
	s := s + s2 + '/';

	str(cf.timelimit : 4, s2);
	s := s + s2 + ' Node ';

	str(cf.node : 2, s2);
	s := s + s2 + ' '+
		  chr(ord('S')+byte(not cf.superuser)*32)+
		  chr(ord('A')+byte(not cf.sysavail)*32)+
		  chr(ord('C')+byte(not cf.paged)*32)+
		  chr(ord('N')+byte(not cf.sysopnext)*32)+'l'+
		  chr(ord('I')-byte(not cf.invis)*41)+'  ';

	for b := 1 to 80 do
		scrptr^[1919+b] := ord(s[b]) or status_bg;

	TimeIsUp := a > cf.timelimit;
end;


{$F+,S-}
procedure Int1CHandler; interrupt;
label quit;
begin
	WriteStatus;

quit:
	OldInt1C;
end;
{$F-,S+}


procedure TurnOffStatus;
var lp : integer;
begin
	asm cli; end;
	setintvec($1c, @OldInt1C);
	asm sti; end;

	for lp := 1920 to 1999 do
		scrptr^[lp] := 0;
end;


procedure newexitproc; far;
begin
	asm cli; end;
	setintvec($1c, @OldInt1C);
	asm sti; end;

	closeuserfile;
	closeallfiles;

	exitproc := oldexitproc;
end;

begin
	if (not openfiles([CONFIGF, NODESF])) or (not openuserfile) then
	begin
		writeln('Unable to open Searchlight configuration files.');
		halt(3);
	end;

	if cf.curruser > 0 then
		readuser(user, cf.curruser)
	else
		fillchar(user, sizeof(user), 0);

	Lang.GetHeader;

	if IsMonoMonitor then
		scrptr := ptr($b000, 0)
	else
		scrptr := ptr($b800, 0);

	LastStatusWrite := 61;
	TimeIsUp := false;

	a := wherex;
	b := wherey;
	if b > 24 then b := 24;
	window(1, 1, 80, 24);
	gotoxy(a, b);

	status_bg := cf.colorchart[BACKGROUND] shl 12 +
				 cf.colorchart[INVERSE] shl 8;

	asm cli; end;
	getintvec($1c, @OldInt1C);
{	setintvec($1c, @Int1CHandler);}
	asm sti; end;

	oldexitproc := exitproc;
	exitproc := @newexitproc;
end.
