unit slget;

interface

uses mogutils, xcrt;


function getlinep(init : string; maxlen : integer;
		  allcaps, path, updown : boolean;
		  min,max : longint; var ret : word;
		  ungetch : char; extended : boolean; pw : boolean) : string;

function getline(init:string; maxlen : integer; allcaps, path : boolean) : string;


implementation

function dot(n : integer) : string;
var
	s : string;
begin
	s := '';
	while n > 0 do
	begin
		s := s + '.';
		dec(n);
	end;

	dot := s;
end;


function getlinep(init : string; maxlen : integer;
		  allcaps, path, updown : boolean;
		  min,max : longint; var ret : word;
		  ungetch : char; extended : boolean; pw : boolean) : string;
var
	sp, s  		: string;
	x  			: integer;
	ch 			: char;
	oa 			: word;
	sx, sy 		: word;
	li 			: longint;
	ug 			: char;

begin
	ret := 1;
	oa := xtextattr;
	s := '';
	sx := xwherex;  sy := xwherey;

	sp := '';
	for x := 1 to maxlen do
		sp := sp + ' ';
	xwrite(sp);

	x := 0;

	if (extended) then
	begin
		xgotoxy(sx, sy);
		xwrite(init);
		s := init;
	end;

	repeat;
		xgotoxy(x+sx, sy);
		if ungetch <> #0 then
		begin
			if extended then ch := #0
			else
			begin
				ch := ungetch;
				ungetch := #0;
			end;
		end
		else
			ch := xreadkey;

		if XCarrierDetect = false then
		begin
			getlinep := '';
			exit;
		end;

		case ch of
		  #0:
		  begin
			if (ungetch <> #0) then
			begin
				ch := ungetch;
				ungetch := #0;
			end
			else
				ch := xreadkey;

			case ch of
			  #79:	x := length(s);
			  #71:	x := 0;

			  #60:
			  begin
					xgotoxy(sx, sy);
					xwrite(init);
					s := init;
					for x := length(init) to maxlen do
						xwrite(' ');
					x := length(init);
			  end;

			  #75:  if (x > 0) then dec(x);
			  #77: 	if (x < length(s)) then inc(x);
			  #83:	if (x < length(s)) then
					begin
						delete(s, x+1, 1);
						if pw then
							xwrite(dot(length(copy(s,x+1,255)))+' ')
						else
							xwrite(copy(s, x+1, 255)+' ');
					end;

			  #72,#80:
			  if (updown) then
			  begin
					ret := word(ch);
					ch := #13;
			  end;
		  end;
		end;

		#8:
			if (x > 0) then
			begin
				dec(x);
				delete(s, x+1, 1);
				if pw then
					xwrite(#8+dot(length(copy(s,x+1,255)))+' ')
				else
					xwrite(#8+copy(s, x+1, 255)+' ');
			end;

		#27:
		begin
			ret := 27;
			s := init;
			ch := #13;
		end;

		' '..'~':
		begin
			if (length(s) < maxlen) and
				( (not path) or ((ch in ['!'..'}']) and not (ch in ['*','?','|','+',';','<','>']))) and
				( (max = 0) or (ch in ['0'..'9','-']) ) then
			begin
				if allcaps then
					ch := upcase(ch);
				if pw then
					xwrite('.')
				else
					xwrite(ch);
				inc(x);
				if (length(s) > x) then
				begin
					if pw then
						xwrite(dot(length(copy(s,x,255))))
					else
						xwrite(copy(s, x, 255));
				end;
				s := copy(s, 1, x-1) + ch + copy(s, x, 255);
			end;
		end;
	end;

	until ch = #13;

	if (max > 0) then
	begin
		val(s, li, x);
		if li > max then
			str(max, s);
		if li < min then
			str(min, s);
	end;

	xgotoxy(sx, sy);

	if pw then
		xwrite(dot(length(s)))
	else
		xwrite(s);

	xwriteln(copy(sp, 1, maxlen-length(s)));

	getlinep := s;
end;

function getline(init : string; maxlen : integer; allcaps, path : boolean) : string;
var ret : word;
begin
	getline := getlinep(init, maxlen, allcaps, path, false, 0, 0, ret, #0, false, false);
end;


end.
