unit slsetup;

interface


uses general, filedef, slentold, crt, dos, strings, supdefs, strznnp,
		sublist, utils, message, supdata;

var
	cstrings 	: boolean;
	pheader     : string[75];


procedure exec_menu(d : desctype);



implementation

type string20 = array [0..0] of string[20];
type ma = array [1..1] of cfgscrtype;


procedure c(a : word); begin textcolor(a); end;

procedure yn(a : boolean);
begin
	if a = true then
		write(' Yes ')
	else
		write(' No  ');
end;

procedure sb(var a : boolean);
begin
	if a = false then
		 a := true
	else
		 a := false;
end;


procedure fillsp(n : word);
var s : string;
begin
	s := '';
	while n > 0 do
	begin
		s := s + ' ';
		dec(n);
	end;
	write(s);
end;


function pn(z, oz : znnp) : string;
var
	s : string;
	zone, net, node, point : string[7];
begin
	if z.zone = 65535 then zone := '*' else str(z.zone, zone);
	if z.net  = 65535 then net  := '*' else str(z.net, net);
	if z.node = 65535 then node := '*' else str(z.node, node);
	if z.point= 65535 then point:= '*' else str(z.point, point);

	if (oz.zone <> z.zone) then
		s := zone+':'+net+'/'+node

	else if (oz.net <> z.net) then
		s := net+'/'+node

	else if (oz.node <> z.node) then
		s := node

	else
		s := '';

	if (z.point > 0) then
		s := s + '.' + point;

	pn := s;
end;

procedure pl_cfgscr(line : integer; aline : integer; m : cfgscrtype);
var
 lp : integer;
begin
	gotoxy(1, line+2);
	if m.st = L_NONE then
	begin
		c(cf.colorchart[NORMAL]);
		writeln('     ',m.s)
	end
	else
	begin
		c(cf.colorchart[ALTCOLOR]);
		write(aline:2,'. ');
		c(cf.colorchart[NORMAL]);
		write(m.s);
		if (m.st = L_LINK) then
			write(' [...]')
		else
			for lp := length(m.s) to {34}31 do
				write('.');
	end;
end;


procedure fill_cfgscr(line : integer; m : cfgscrtype);
var
  np : ^byte;
  sp : aocp;
  strp : ^string;
  bp : ^boolean;
  zp : ^znnp;
  szp : ^sysznnp;
  byp : ^byte;
  wop : ^word;
  lop : ^longint;
  lp : integer;
  s20p : ^string20;
  asp : ^attribset;
  s : string;
begin
	gotoxy(37, line+2);

	case m.st of
	  L_NONE:
		exit;

	  L_PATH, L_UPSTR, L_STR, L_FILE:
	  begin
		sp := m.l;
		strp := m.l;

		if cstrings then
			s := fromnts(sp)
		else
			s := strp^;

		if (m.max > 43) then
		begin
			textbackground(black);
			gotoxy(1, line+2);
			c(cf.colorchart[ALTCOLOR]);
			write(line:2,'. ');
			c(cf.colorchart[NORMAL]);
			write(m.s);
			for lp := length(m.s) to {34}31 do
				write('.');

			if highon then high else low;

			if highon then
			begin
				gotoxy(wherex-(m.max-45)-3, wherey);
				write(' ',s);
				fillsp(m.max-length(s));
				gotoxy(wherex-m.max, wherey);
			end
			else
			begin
				if length(s) > 42 then
					s := s + '';
				delete(s, 42, length(s)-42);
				write(' ',s);
				clreol;
				gotoxy(38, line+2);
			end;
		end
		else
		begin
			write(' ', s);
			if highon then
				fillsp(m.max-length(s)+1)
			else
				clreol;
			gotoxy(38, line+2);
		end;
	  end;

	  L_BYTE:
	  begin
		byp := m.l;
		write(' ',byp^:3,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_WORD:
	  begin
		wop := m.l;
		write(' ',wop^:5,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_LONG:
	  begin
		lop := m.l;
		write(' ',lop^:10,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_BOOL:
	  begin
		bp := m.l;
		yn( bp^ );
	  end;

	  L_ZNNP:
	  begin
		zp := m.l;
		write(' ',znnptostr(zp^),' ');
		if (not highon) then
			clreol;
		gotoxy(38, line+2);
	  end;

	  L_SYSZNNP:
	  begin
		szp := m.l;
		if szp^.t = DFidoNet then
			write(' ',znnptostr(szp^.z),' ')
		else
			write(' ',fromnts(@szp^.s),' ');

		if (not highon) then clreol;
		gotoxy(38, line+2);
	  end;

	  L_TOGGLE0, L_TOGGLE1:
	  begin
		np := m.l;
		s20p := pointer(m.min);
		write(' ',s20p^[np^],' ');
		if (not highon) then clreol else
		begin
			low; clreol; high;
		end;
	  end;

	  L_LINK:
	  begin
		gotoxy(1, line+2);
		textbackground(black);
		c(cf.colorchart[ALTCOLOR]);
		write(line:2,'.');
		if highon then high else c(cf.colorchart[NORMAL]);
		write(' ',m.s,' [...] ')
	  end;

	  L_ATTRIB:
	  begin
		asp := m.l;
		s := '';
		for lp := 1 to 24 do
			if lp in asp^ then
				s := s + chr(lp+64);

		write(' ', s);
		if highon then
			for lp := length(s) to 25 do
				write(' ')
		else
			clreol;
		gotoxy(38, line+2);
	  end;
	end;
end;

function do_cfgscr(d : desctype) : byte;
var
  ch   : char;
  at   : byte;
  mp   : ^ma;
  boolp: ^boolean;
  lt   : listtype;
  extd : boolean;
  tp   : pointer;
  stp  : aocp;
  strp : ^string;
  btp  : ^byte;
  wtp  : ^word;
  ltp  : ^longint;
  ztp  : ^znnp;
  asp  : ^attribset;
  sztp : ^sysznnp;
  ret  : word;
  s    : string;
  n    : word;
  z    : znnp;
  lp   : integer;

label down, up, getstrpart;
begin
	mp := d.l;
	at := 1;
	high;
	fill_cfgscr(at, mp^[at]);

	while true do
	begin
		lt := mp^[at].st;
		extd := false;
		ch := readkey;
		case ch of
		  #0:
		  begin
			extd := true;
			ch := readkey;
			case ch of
			  #75,#77,#79{end},#71{home},#115{ctrlleft},#116{ctrlright},#83{delete}:
			  begin
				if (lt in [L_FILE,L_PATH,L_STR,L_UPSTR,L_ZNNP,L_ATTRIB,L_WORD,L_BYTE,L_LONG]) then
					goto getstrpart
				else
					goto down;
			  end;

			  #80:
			  begin
down:         	low;
				fill_cfgscr(at, mp^[at]);
				inc(at);
				if (at > d.n) then
					at := 1;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #81:
			  begin
				low;
				fill_cfgscr(at, mp^[at]);
				inc(at, 4);
				if (at > d.n) then
					at := d.n;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #72:
			  begin
up:             low;
				fill_cfgscr(at, mp^[at]);
				dec(at);
				if (at = 0) then
					at := d.n;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #73:
			  begin
				low;
				fill_cfgscr(at, mp^[at]);
				if (at < 5) then at := 5;
					dec(at, 4);
				high;
				fill_cfgscr(at, mp^[at]);
			  end;
			end;
		  end;

		  #13:
		  begin
			if (lt = L_LINK) then
			begin
				exec_menu(desctype(mp^[at].l^));
				clrscr;
				textcolor(cf.colorchart[HEADCOLOR]);
				writeln(d.d);

				for n := 1 to d.n do
				begin
					pl_cfgscr(n, n, mp^[n]);
					fill_cfgscr(n, mp^[n]);
				end;

				high;
				fill_cfgscr(at, mp^[at]);
			end
			else
			begin
				if at = d.n then
				begin
					low;
					do_cfgscr := 255;
					exit;
				end
				else
					goto down;
			end;
		  end;

		  #32..#126:
		  begin
getstrpart:
			tp := mp^[at].l;
			stp := tp;
			strp := tp;
			btp := tp;
			wtp := tp;
			ltp := tp;
			ztp := tp;
			sztp := tp;

			ret := 0;

			if lt in [L_STR,L_FILE,L_PATH,L_UPSTR] then
			begin
				if cstrings then
					s := fromnts(stp)
				else
					s := strp^;
			end;

			case lt of
			  L_STR:  s := getlinep(s, mp^[at].max, false, false, true, 0, 0, ret, ch, extd);
			  L_PATH:
			  begin
				s := getlinep(s, mp^[at].max, true, true, true, 0, 0, ret, ch, extd);
				if (s[length(s)] <> '\') then s := s + '\';
			  end;
			  L_FILE:  s := getlinep(s, mp^[at].max, true, true, true, 0, 0, ret, ch, extd);
			  L_UPSTR: s := getlinep(s, mp^[at].max, true, false, true, 0, 0, ret, ch, extd);
			  L_BYTE:
			  begin
				str(btp^, s);
				s := getlinep(s, 3, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, btp^, n);
			  end;
			  L_WORD:
			  begin
				str(wtp^, s);
				s := getlinep(s, 6, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, wtp^, n);
			  end;
			  L_LONG:
			  begin
				str(ltp^, s);
				s := getlinep(s, 10, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, ltp^, n);
			  end;
			  L_BOOL:
			  begin
				sb(boolean(mp^[at].l^));
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_ZNNP:
			  begin
				s := znnptostr(ztp^);
				s := getlinep(s, 23, true, false, true, 0, 0, ret, ch, extd);
				if (strtoznnp(s, z) = true) then
					ztp^ := z;
			  end;
			  L_SYSZNNP:
			  begin
				if sztp^.t = DFidoNet then
					s := znnptostr(sztp^.z)
				else
					s := fromnts(@sztp^.s);
				s := getlinep(s, 23, true, false, true, 0, 0, ret, ch, extd);

				while pos(' ', s) > 0 do
					delete(s, pos(' ', s), 1);

				if (strtoznnp(s, z) = true) then
				begin
					sztp^.t := DFidoNet;
					sztp^.z := z;
				end
				else
				begin
					if (length(s) < 9) then
					begin
						sztp^.t := DInternet;
						tonts(s, sztp^.s);
					end;
				end;
			  end;
			  L_TOGGLE1:
			  begin
				inc(btp^);
				if (mp^[at].max <= btp^) then
					btp^ := 1;
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_TOGGLE0:
			  begin
				inc(btp^);
				if (mp^[at].max <= btp^) then
					btp^ := 0;
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_ATTRIB:
			  begin
				asp := tp;
				s := '';
				for lp := 1 to 24 do
					if lp in asp^ then
						s := s + chr(lp+64);

				s := getlinep(s, 24, true, false, true, 0, 0, ret, ch, extd);

				if s = 'ALL' then
					s := 'ABCDEFGHIJKLMNOPQRSTUVWX';

				asp^ := [];
				for lp := 1 to length(s) do
					asp^ := asp^ + [ord(s[lp])-64];
			  end;
			end;

			if lt in [L_STR,L_PATH,L_FILE,L_UPSTR] then
			begin
				stripspaces(s);
				if cstrings then
					tonts(s, stp^)
				else
					strp^ := s;
			end;

			if ret = 27 then
			begin
				low;
				do_cfgscr := 255;
				exit;
			end;

			if ret = 72 then goto up;
			if ret in [1,80] then goto down;

		  end;

		  #27:
		  begin
			low;
			do_cfgscr := 255;
			exit;
		  end;
		end;
	end;
end;

procedure exec_listscr(d : desctype);
type pbyte = array [0..0] of byte;
type plst = array [1..1] of listscrtype;
var
  regs	: registers;
  lsd 	: ^lsdesctype;
  lst 	: ^plst;
  fptr 	: file;
  nptr	: file;
  buf	: ^pbyte;
  toprec  : word;
  cline : byte;
  zp	: ^znnp;
  szp	: ^sysznnp;
  lp	: integer;
  r, y	: integer;
  quit	: boolean;
  ch	: char;
  maxrec : word;
  ds	: ^desctype;
  s20p  : ^string20;
  strp  : ^string;
  bytep  : ^byte;
  s 	: string;

  procedure putrline;
  var lp, pp, n : word;
  begin
  	for lp := 1 to d.n do
	begin
		clreol;
		n := lst^[lp].off;
		case lst^[lp].t of
		  L_NONE: fillsp(lst^[lp].len);
		  L_WORD: write((buf^[n] + buf^[n+1] * 256):lst^[lp].len);
		  L_BYTE: write((buf^[n]):lst^[lp].len);
		  L_LONG: write((buf^[n] + (longint(buf^[n+1]) shl 8)
							+ (longint(buf^[n+2]) shl 16)
								+ (longint(buf^[n+3]) shl 24)):lst^[lp].len);

		  L_ZNNP:
		  begin
			zp := pointer(longint(buf)+n);
			write(znnptostr(zp^));
			gotoxy(wherex + ( lst^[lp].len - length(znnptostr(zp^))), wherey );
		  end;

		  L_SYSZNNP:
		  begin
			szp := pointer(longint(buf)+n);
			if szp^.t = DFidoNet then
				s := znnptostr(szp^.z)
			else
				s := fromnts(@szp^.s);
			write(s);
			gotoxy(wherex + ( lst^[lp].len - length(s) ), wherey);
		  end;

		  L_STR, L_UPSTR, L_PATH, L_FILE:
		  begin
			if cstrings then
			begin
				for pp := 0 to lst^[lp].len-1 do
				begin
					if (buf^[n+pp] = 0) then
					begin
						gotoxy( wherex + (lst^[lp].len)-pp, wherey );
						pp := lst^[lp].len-1
					end
					else
						write(chr(buf^[n+pp]));
				end;
			end
			else
			begin
				strp := @buf^[n];
				write(strp^);
				gotoxy( wherex + (lst^[lp].len)-length(strp^), wherey );
			end;
		  end;

		  L_TOGGLE0, L_TOGGLE1:
		  begin
			s20p := lst^[lp].tog;
			write(s20p^[buf^[n]]);
			gotoxy(wherex + lst^[lp].len - length(s20p^[buf^[n]]), wherey );
		  end;

		  L_BOOL:
		  begin
			if buf^[n] = 0 then
				write('No ')
			else
				write('Yes');
		  end;

		  else
			write('?!');
		end;
	end;
  end;

  procedure putscr;
  var
    lp : integer;
	r  : word;
  begin
	seek(fptr, toprec*lsd^.recsize);

	for lp := 5 to 23 do
	begin
		blockread(fptr, buf^, lsd^.recsize, r);
		if (lsd^.recsize = r) then
		begin
			gotoxy(2, lp);
			clreol;
			putrline;
		end
		else
		begin
			for r := lp to 23 do begin gotoxy(2, r);clreol; end;
			lp := 23
		end;
	end;
  end;

  procedure putline(line : byte);
   var r : word;
  begin
        seek(fptr, (toprec+line)*lsd^.recsize);
        blockread(fptr, buf^, lsd^.recsize, r);
        if (lsd^.recsize = r) then
        begin
        	gotoxy(2, line+5);
                clreol;
				putrline;
        end;
  end;

  procedure drawscreen;
  var lp : integer;
  begin
  	clrscr;
    heading(d.d);

	gotoxy(1,3);
	textcolor(cf.colorchart[SPECIAL]);
	write(' <ENTER> Edit entry   <F1> Add entry   <F2> Delete entry');
    gotoxy(1,4);
	high;
    clreol;
	write(' ');
    for lp := 1 to d.n do
    begin
    	write(lst^[lp].d);
        fillsp(lst^[lp].len-length(lst^[lp].d));
	end;

    gotoxy(1,24);
    clreol;
    write('  Press [ESC] to Exit');
    low;

    putscr;
  end;

label reread;

begin
	regs.al := 1;
    regs.bh := 3;
    regs.ch := 4;
    regs.cl := 0;
    regs.dh := 22;
    regs.dl := 79;

    lsd := d.l;
    lst := lsd^.l;

	toprec := 0;
    cline := 0;


reread:

	assign(fptr, lsd^.fn);
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		rewrite(fptr, 1);

    maxrec := filesize(fptr) div lsd^.recsize;
	if (maxrec > 0) then dec(maxrec);

	if (toprec+cline > maxrec) then
		if (toprec > 0) then dec(toprec) else dec(cline);

    getmem(buf, lsd^.recsize+1);

	drawscreen;

	quit := false;
	while not quit do
	begin
		gotoxy(1, cline+5);

		ch := readkey;
		case ch of
		  #0:
		  begin
			ch := readkey;
			case ch of
			  #59:
			  begin
				fillchar(lsd^.tl^, lsd^.recsize, 0);

				ds := lsd^.dl;
				exec_menu(ds^);

				quit := false;
				bytep := lsd^.tl;
				for lp := 1 to lsd^.recsize do
				begin
					if bytep^ <> 0 then
					begin
						quit := true;
						lp := lsd^.recsize;
					end;
					inc(bytep);
				end;

				if quit = true then
				begin
(*					seek(fptr, 0);
					assign(nptr, 'NEWF.$$$');
					rewrite(nptr, 1);
					for lp := 0 to maxrec do
					begin
						blockread(fptr, buf^, lsd^.recsize);
						if (lp <> toprec+cline) then
							blockwrite(nptr, buf^, lsd^.recsize);
					end;
					close(nptr);
					close(fptr);
					{$I-} erase(fptr); {$I+}
					rename(nptr, lsd^.fn);*)

					seek(fptr, filesize(fptr));
					blockwrite(fptr, lsd^.tl^, lsd^.recsize);
				end;

				quit := false;

				close(fptr);
				goto reread;
			  end;

			  #60:
			  begin
				if filesize(fptr) = 0 then
				begin
					close(fptr);
					goto reread;
				end;

				clrscr;
				heading(d.d);
				write(#10'Are you sure you want to delete this item? ');
				if (bar_noyes = 'N') then
				begin
					close(fptr);
					goto reread;
				end;

				seek(fptr, 0);
				assign(nptr, 'NEWF.$$$');
				rewrite(nptr, 1);
				for lp := 0 to maxrec do
				begin
					blockread(fptr, buf^, lsd^.recsize);
					if (lp <> toprec+cline) then
						blockwrite(nptr, buf^, lsd^.recsize);
				end;
				close(nptr);
				close(fptr);
				{$I-} erase(fptr); {$I+}
				rename(nptr, lsd^.fn);
				goto reread;
			  end;

			  #72:
			  begin
				if cline > 0 then
					dec(cline)
				else
				begin
					if (toprec > 0) then
					begin
						regs.ah := 7; {down}
						intr($10, regs);
						dec(toprec);
						putline(0);
					end;
				end;
			  end;

			  #71:
			  begin
				toprec := 0; cline := 0;
				putscr;
			  end;

			  #73:
			  begin
				if (toprec > 0) then
				begin
					if toprec > 18 then dec(toprec, 18) else toprec := 0;
					putscr;
				end else cline := 0;
			  end;

			  #79:
			  begin
				if maxrec > 16 then
				begin
					toprec := maxrec - 17;
					cline := 17;
				end
				else
				begin
					toprec := 0;
					cline := maxrec;
				end;
				putscr;
			  end;

			  #80:
			  begin
				if (toprec+cline < maxrec) then
				begin
					if (cline < 18) then
						inc(cline)
					else
					begin
						regs.ah := 6;
						intr($10, regs);
						inc(toprec);
						putline(18);
					end;
				end;
			  end;

			  #81:
			  begin
				if (toprec+18 < maxrec) then
				begin
					inc(toprec, 18);
					if maxrec < toprec+cline then
						toprec := maxrec-18;
					putscr;
				end
				else
					cline := maxrec-toprec;
			  end;

			end;
		  end;

		  #13:
		  begin
			if filesize(fptr) > 0 then
			begin
				seek(fptr, (toprec+cline)*lsd^.recsize);
				blockread(fptr, lsd^.tl^, lsd^.recsize, r);

				ds := lsd^.dl;
				exec_menu(ds^);

				seek(fptr, (toprec+cline)*lsd^.recsize);
				blockwrite(fptr, lsd^.tl^, lsd^.recsize);

				drawscreen;
			end;
		  end;

		  #27:	quit := true;

		end;
	end;

	close(fptr);
	freemem(buf, lsd^.recsize+1);
end;



procedure exec_cfgscr(d : desctype);
var
  lp : integer;
  n : byte;
  mp : ^ma;
  s : string;
  ds : ^desctype;
  pos : byte;
  ch : char;
begin
	pos := 1;
	mp := d.l;

	while true do
	begin
		clrscr;
		high;
		gotoxy(1, 24);
		write(' Press [ESC] When Done                ');
		gotoxy(40, 24);
		write('  Press F2 or ^Q to Restore Old Value  ');
		low;
		gotoxy(1,1);

		textcolor(cf.colorchart[HEADCOLOR]);
		writeln(d.d);

		for lp := 1 to d.n do
		begin
			pl_cfgscr(lp, lp, mp^[lp]);
			fill_cfgscr(lp, mp^[lp]);
		end;

		n := do_cfgscr(d);

		if n = 255 then
			exit;

		ds := mp^[n].l;
		exec_menu(ds^);
	end;
end;


procedure exec_menulist(d : desctype);
type ma = array [1..1] of menulisttype;
var
  lp : integer;
  n : byte;
  mp : ^ma;
  s : string;
  ds : ^desctype;
  pos : byte;
begin
	pos := 1;
	mp := d.l;

	while true do
	begin
		clrscr;
		textcolor(cf.colorchart[SPECIAL]);
		gotoxy((80-length(d.d)) div 2, 3);
		writeln(d.d);

		textcolor(cf.colorchart[ALTCOLOR]);
		s := 'Press [ESC] to Exit';
		gotoxy((80-length(s)) div 2, 24);
		write(s);

		textcolor(cf.colorchart[ALTCOLOR]);
		gotoxy((80-length(pheader)) div 2, 4);
		writeln(pheader,#10);

		init_listmenu;
		for lp := 1 to d.n do
		begin
			if mp^[lp].l = Nil then
				desc_listmenu(mp^[lp].s)
			else
				add_listmenu(mp^[lp].s);
		end;

		n := disp_listmenu(pos);

		if n = 27 then
			exit;

		ds := mp^[n].l;

		exec_menu(ds^);
	end;
end;


procedure exec_menu(d : desctype);
begin
	low;
	case d.lt of
	  T_MENULIST: 	exec_menulist(d);
	  T_CFGSCR:     exec_cfgscr(d);
	  T_LISTSCR:	exec_listscr(d);
	end;
end;


end.
