unit supdata;

interface

uses
	defs,
	supdefs,
	menudef;


const m_otheraccess : array [1..12] of cfgscrtype = (
	(s: 'Private functions'; st: L_BYTE; l: @cfg.privLvl),
	(s: 'View Op commands'; st: L_BYTE; l: @cfg.ViewOpCmds),
	(s: 'Channel Op'; st: L_BYTE; l: @cfg.ChanOpLvl),
	(s: 'Conference Op'; st: L_BYTE; l: @cfg.ConfOpLvl),
	(s: 'Ignore channel passwords'; st: L_BYTE; l: @cfg.IgnorePasswordLvl),
	(s: 'Display real name in userlist'; st: L_BYTE; l: @cfg.DispRealNameLvl),
	(s: 'Ignore time limits'; st: L_BYTE; l: @cfg.NoTimeLvl),
	(s: 'Ignore user bans'; st: L_BYTE; l: @cfg.CantBanLvl),
	(s: 'Can rename unrenamable users'; st: L_BYTE; l: @cfg.RenameOverrideLvl),
	(s: 'Can''t boot'; st: L_BYTE; l: @cfg.CantBootLvl),
	(s: 'Can''t silence'; st: L_BYTE; l: @cfg.CantSilenceLvl),
	(s: 'Can''t kick'; st: L_BYTE; l: @cfg.CantKickLvl) );

const d_otheraccess : desctype = (n: 12; d: 'MogTalk Access Level Setup'; l: @m_otheraccess; lt: T_CFGSCR);


const m_allow : array [1..18] of cfgscrtype = (
	(s: 'Allow beep command'; st: L_BYTE; l: @cfg.beepLvl),
	(s: 'Allow tab key'; st: L_BYTE; l: @cfg.AllowTabLvl),
	(s: 'Allow boot command'; st: L_BYTE; l: @cfg.BootLvl),
	(s: 'Allow sys commands'; st: L_BYTE; l: @cfg.SysLvl),
	(s: 'Allow ban'; st: L_BYTE; l: @cfg.BanLvl),
	(s: 'Allow set/use macros'; st: L_BYTE; l: @cfg.MacroLvl),
	(s: 'Allow weenie command'; st: L_BYTE; l: @cfg.weenieLvl),
	(s: 'Allow rename command'; st: L_BYTE; l: @cfg.RenameLvl),
	(s: 'Allow to set conference ops'; st: L_BYTE; l: @cfg.SetConfOpLvl),
	(s: 'Allow adjusting of time'; st: L_BYTE; l: @cfg.AdjTimeLvl),
	(s: 'Allow adjusting of MogPoints'; st: L_BYTE; l: @cfg.AdjMPLvl),
	(s: 'Allow order command'; st: L_BYTE; l: @cfg.OrderLvl),
	(s: 'Allow channel freeze command'; st: L_BYTE; l: @cfg.FreezeLvl),
	(s: 'Allow set command'; st: L_BYTE; l: @cfg.SetLvl),
	(s: 'Allow write command'; st: L_BYTE; l: @cfg.WriteLvl),
	(s: 'Allow setabbr command'; st: L_BYTE; l: @cfg.SetAbbrLvl),
	(s: 'Allow scan all channels'; st: L_BYTE; l: @cfg.ScanAllLvl),
	(s: 'Allow invisible logins'; st: L_BYTE; l: @cfg.InvisibleLvl) );

const d_allow : desctype = (n: 18; d: 'MogTalk Allow Access Setup'; l: @m_allow; lt: T_CFGSCR);


const m_access : array [1..2] of cfgscrtype = (
	(s: 'Allow command access levels'; st: L_LINK; l: @d_allow),
	(s: 'Other access levels'; st: L_LINK; l: @d_otheraccess) );

const d_access : desctype = (n: 2; d: 'MogTalk Access Setup'; l: @m_access; lt: T_CFGSCR);


const m_path : array [1..5] of cfgscrtype = (
	(s: 'Maximum nodes'; st: L_BYTE; l: @cfg.maxnodes ),
	(s: 'Channel directory'; st: L_PATH; l: @cfg.channeldir; min:0; max:45),
	(s: 'Realtime directory'; st: L_PATH; l: @cfg.realtimedir; min:0; max:45),
	(s: 'Game directory'; st: L_PATH; l: @cfg.gamedir; min:0; max:45),
	(s: 'LogMgr directory'; st: L_PATH; l: @cfg.logmgrdir; min:0; max:45) );

const d_path : desctype = (n: 5; d: 'MogTalk Path Setup'; l: @m_path; lt: T_CFGSCR);


const m_colour : array [1..3] of cfgscrtype = (
	(s: 'Default user colour'; st: L_UPSTR; l: @cfg.defusrcol; min:0; max:10),
	(s: 'Default message colour'; st: L_UPSTR; l: @cfg.defmsgcol; min:0; max:10),
	(s: 'Default whisper colour'; st: L_UPSTR; l: @cfg.defwhiscol; min:0; max:10) );

const d_colour : desctype = (n: 3; d: 'MogTalk Colour Setup'; l: @m_colour; lt: T_CFGSCR);

const m_screen : array [1..2] of cfgscrtype = (
	(s: 'Writing indent'; st: L_BYTE; l: @cfg.WritingIndent),
	(s: 'Notice indent'; st: L_BYTE; l: @cfg.NoticeIndent) );

const d_screen : desctype = (n: 2; d: 'MogTalk Screen Setup'; l: @m_screen; lt: T_CFGSCR);


const m_mp : array [1..4] of cfgscrtype = (
	(s: 'Points for successful weenie'; st: L_LONG; l: @cfg.PointsForSuccessfulWeenie),
	(s: 'Points for failed weenie'; st: L_LONG; l: @cfg.PointsForFailedWeenie),
	(s: 'Cost to weenie'; st: L_LONG; l: @cfg.CostToWeenie),
	(s: 'Cost to nosui'; st: L_LONG; l: @cfg.CostToNosui) );

const d_mp : desctype = (n: 4; d: 'MogTalk MogPoints Setup'; l: @m_mp; lt: T_CFGSCR);



const m_main : array [1..5] of cfgscrtype = (
	(s: 'Path setup'; st: L_LINK; l: @d_path ),
	(s: 'Access levels'; st: L_LINK; l: @d_access ),
	(s: 'Colour setup'; st: L_LINK; l: @d_colour ),
	(s: 'Screen setup'; st: L_LINK; l: @d_screen ),
	(s: 'MogPoints setup'; st: L_LINK; l: @d_mp ) );

const d_main : desctype = (n: 5; d: 'MogTalk General Configuration';
						   l: @m_main; lt: T_CFGSCR);




implementation

end.
