unit utils;

interface

uses
	dos;

function  strs(n : longint) : string;
function  strs2(n : longint) : string;
function  strs4(n : longint) : string;
function  strsn(n, sp : longint) : string;
function  vals(s : string) : longint;

function  min(a, b : longint) : word;
function  aword(s : string; n : integer; toeol : boolean) : string;
function  ups(s : string) : string;
function  undersc(s : string) : string;
function  yn(b : boolean) : string;
function  ps(n : integer) : string;
function  sp(n : longint) : string;
function  spc(n : longint; c : char) : string;
function  nsp(n : longint; sp : word) : string;
function  th(n : word) : string;
function  NameCaps(f : string) : string;

function  strlwr(s : string) : string;

function  IsMonoMonitor : boolean;


implementation

function strs(n : longint) : string;
var
 s : string;
begin
	str(n, s);
	strs := s;
end;

function strs2(n : longint) : string;
var s : string;
begin
	str(n, s);
	while (length(s) < 2) do
		s := '0' + s;
	strs2 := s;
end;

function strs4(n : longint) : string;
var s : string;
begin
	str(n, s);
	while (length(s) < 4) do
		s := '0' + s;
	strs4 := s;
end;


function strsn(n, sp : longint) : string;
var s : string;
begin
	str(n : sp, s);
	strsn := s;
end;

function vals(s : string) : longint;
var
	n : word;
	l : longint;
begin
	val(s, l, n);
	vals := l;
end;

function min(a, b : longint) : word;
begin
	if a < b then min := a else min := b;
end;

function aword(s : string; n : integer; toeol : boolean) : string;
var
	n1, n2 : integer;
	inq : boolean;
	t   : string;
begin
	inq := false;
	while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
		delete(s, 1, 1);

	while (n > 1) do
	begin
		while (s[1] <> ' ') and (s[1] <> #9) and (s[1] <> '"') and (length(s) > 0) do
			delete(s, 1, 1);

		if (s[1] = '"') and (length(s) > 0) then
		begin
			delete(s, 1, 1);
			while (s[1] <> '"') and (length(s) > 0) do
				delete(s, 1, 1);
			delete(s, 1, 1);
		end
		else
		begin
			while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
				delete(s, 1, 1);

			if (s = '') then
			begin
				aword := '';
				exit;
			end;

			dec(n);
		end;
	end;

	if toeol then
	begin
		aword := s;
		exit;
	end;

	t := '';

	while ((inq = true) or ((s[1] <> #9) and (s[1] <> ' '))) and (length(s) > 0) do
	begin
		if (s[1] = '"') then
		begin
			delete(s, 1, 1);
			if (inq = true) then
				inq := false
			else
				inq := true;
		end
		else
		begin
			t := t + s[1];
			delete(s, 1, 1);
		end;
	end;

	aword := t;
end;


function ups(s : string) : string;
var
	lp : integer;
begin
	for lp := 1 to length(s) do
		s[lp] := upcase(s[lp]);
	ups := s;
end;

function undersc(s : string) : string;
var
	lp : integer;
begin
	for lp := 1 to length(s) do
		if s[lp] = ' ' then s[lp] := '_';

	undersc := s;
end;

function yn(b : boolean) : string;
begin
	if b then yn := 'Yes' else yn := 'No';
end;

function ps(n : integer) : string;
begin
	if n <> 1 then ps := 's' else ps := '';
end;


function sp(n : longint) : string;
var s : string;
	lp : integer;
begin
	s := '';

	for lp := 1 to n do
		s := s + ' ';

	sp := s;
end;

function spc(n : longint; c : char) : string;
var s : string;
	lp : integer;
begin
	s := '';

	for lp := 1 to n do
		s := s + c;

	spc := s;
end;

function nsp(n : longint; sp : word) : string;
var
	s : string;
begin
	str(n : sp, s);
	nsp := s;
end;


function NameCaps(f : string) : string;
var
	cap 	: boolean;
	lp		: integer;
begin
	cap := true;

	if f = 'NPT' then
	begin
		NameCaps := 'NPT';
		exit;
	end;

	for lp := 1 to length(f) do
	begin
		if (f[lp] < 'A') or (f[lp] > 'Z') then
			cap := true;
		if (cap = false) then
			f[lp] := chr(ord(f[lp])+32);
		if not ((f[lp] < 'A') or (f[lp] > 'Z')) then
			cap := false;

		if (lp > 2) and (copy(f, lp-2, 2) = 'Mc') then
			f[lp] := upcase(f[lp]);
	end;
	NameCaps := f;
end;

function th(n : word) : string;
begin
	if n in [1,21,31] then th := 'st'

	else if n in [2,22] then th := 'nd'

	else if n in [3,23] then th := 'rd'

	else th := 'th';
end;


function IsMonoMonitor : boolean;
var
	r : registers;
begin
	r.ah := $0f;
	intr($10, r);
	IsMonoMonitor := r.al = $07;
end;

function strlwr(s : string) : string;
var
  lp : integer;
begin
	for lp := 1 to length(s) do
		if (s[lp] >= 'A') and (s[lp] <= 'Z') then
			s[lp] := chr(ord(s[lp]) + 32);
	strlwr := s;
end;


end.